/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of MPFR.xs. Do not edit this file, edit MPFR.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MPFR.xs"

#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#include "math_mpfr_include.h"

int nnum = 0; /* flag that is incremented whenever a string containing
                 non-numeric characters is treated as a number */

int nok_pok = 0; /* flag that is incremented whenever a scalar that is both
                 NOK and POK is passed to new or an overloaded operator */

/* Has inttypes.h been included ? */
int _has_inttypes(void) {
#ifdef _MSC_VER
return 0;
#else
#if defined MATH_MPFR_NEED_LONG_LONG_INT
return 1;
#else
return 0;
#endif
#endif
}

int NNW_val(pTHX) {
  /* return the numeric value of $Math::MPFR::NNW - ie the no. of non-numeric instances encountered */
  return SvIV(get_sv("Math::MPFR::NNW", 0));
}

int NOK_POK_val(pTHX) {
  /* return the numeric value of $Math::MPFR::NOK_POK */
  return SvIV(get_sv("Math::MPFR::NOK_POK", 0));
}

int _win32_infnanstring(char * s) { /* MS Windows only - detect 1.#INF and 1.#IND
                                     * Need to do this to correctly handle a scalar
                                     * that is both NOK and POK on older win32 perls */

  /*************************************
  * if input string    =~ /^\-1\.#INF$/ return -1
  * elsif input string =~ /^\+?1\.#INF$/i return 1
  * elsif input string =~ /^(\-|\+)?1\.#IND$/i return 2
  * else return 0
  **************************************/

#ifdef _WIN32_BIZARRE_INFNAN

  int sign = 1;
  int factor = 1;

  if(s[0] == '-') {
    sign = -1;
    s++;
  }
  else {
    if(s[0] == '+') s++;
  }

  if(!strcmp(s, "1.#INF")) return sign;
  if(!strcmp(s, "1.#IND")) return 2;

  return 0;
#else
  croak("Math::MPFR::_win32_infnanstring not implemented for this build of perl");
#endif
}

void Rmpfr_set_default_rounding_mode(pTHX_ SV * round) {
     CHECK_ROUNDING_VALUE
     mpfr_set_default_rounding_mode((mpfr_rnd_t)SvUV(round));
}

unsigned long Rmpfr_get_default_rounding_mode(void) {
     return __gmpfr_default_rounding_mode;
}

SV * Rmpfr_prec_round(pTHX_ mpfr_t * p, SV * prec, SV * round) {
     return newSViv(mpfr_prec_round(*p, (mpfr_prec_t)SvIV(prec), (mpfr_rnd_t)SvUV(round)));
}

void DESTROY(pTHX_ mpfr_t * p) {
     mpfr_clear(*p);
     Safefree(p);
}

void Rmpfr_clear(pTHX_ mpfr_t * p) {
     mpfr_clear(*p);
     Safefree(p);
}

void Rmpfr_clear_mpfr(mpfr_t * p) {
     mpfr_clear(*p);
}

void Rmpfr_clear_ptr(pTHX_ mpfr_t * p) {
     Safefree(p);
}

void Rmpfr_clears(pTHX_ SV * p, ...) {
     dXSARGS;
     unsigned long i;
     for(i = 0; i < items; i++) {
        mpfr_clear(*(INT2PTR(mpfr_t *, SvIVX(SvRV(ST(i))))));
        Safefree(INT2PTR(mpfr_t *, SvIVX(SvRV(ST(i)))));
     }
     XSRETURN(0);
}

SV * Rmpfr_init(pTHX) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_init2(pTHX_ SV * prec) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init2 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init2 (*mpfr_t_obj, (mpfr_prec_t)SvIV(prec));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_init_nobless(pTHX) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     mpfr_init(*mpfr_t_obj);

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_init2_nobless(pTHX_ SV * prec) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init2_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     mpfr_init2 (*mpfr_t_obj, (mpfr_prec_t)SvIV(prec));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

void Rmpfr_init_set(pTHX_ mpfr_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ui(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_ui function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_ui(*mpfr_t_obj, (unsigned long)SvUV(q), (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_si(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_si function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_si(*mpfr_t_obj, (long)SvIV(q), (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_d(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp =  mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_d(*mpfr_t_obj, (double)SvNV(q), (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ld(pTHX_ SV * q, SV * round) {
#ifdef NV_IS_LONG_DOUBLE
#ifndef _MSC_VER
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_ld(*mpfr_t_obj, (long double)SvNV(q), (mpfr_rnd_t)SvUV(round));
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
#else
     croak("Rmpfr_init_set_ld not implemented on this build of perl - use Rmpfr_init_set_d instead");
#endif
#else
     croak("Rmpfr_init_set_ld not implemented on this build of perl");
#endif
}

void Rmpfr_init_set_f(pTHX_ mpf_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_f function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_f(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_z(pTHX_ mpz_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_z function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_z(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_q(pTHX_ mpq_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_q function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_q(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_str(pTHX_ SV * q, SV * base, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan, ret = (int)SvIV(base);
#else
     int ret = (int)SvIV(base);
#endif


     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     if(ret < 0 || ret > MAXIMUM_ALLOWABLE_BASE || ret == 1)
        croak("2nd argument supplied to Rmpfr_init_set str is out of allowable range");

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_str function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(q));
       if(inf_or_nan) {
         mpfr_init(*mpfr_t_obj);
         if(inf_or_nan != 2) mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
       }
       else {
         ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), ret, (mpfr_rnd_t)SvUV(round));
       }
#else
       ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), ret, (mpfr_rnd_t)SvUV(round));

#endif

     NON_NUMERIC_CHAR_CHECK, "Rmpfr_init_set_str");}

     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_nobless(pTHX_ mpfr_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ui_nobless(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp  = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_ui_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_ui(*mpfr_t_obj, (unsigned long)SvUV(q), (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_si_nobless(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_si_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_si(*mpfr_t_obj, (long)SvIV(q), (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_d_nobless(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_d(*mpfr_t_obj, (double)SvNV(q), (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ld_nobless(pTHX_ SV * q, SV * round) {
#ifdef NV_IS_LONG_DOUBLE
#ifndef _MSC_VER
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_ld(*mpfr_t_obj, (long double)SvNV(q), (mpfr_rnd_t)SvUV(round));
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
#else
     croak("Rmpfr_init_set_ld_nobless not implemented on this build of perl - use Rmpfr_init_set_d_nobless instead");
#endif
#else
     croak("Rmpfr_init_set_ld_nobless not implemented on this build of perl");
#endif
}

void Rmpfr_init_set_f_nobless(pTHX_ mpf_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_f_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_f(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1)  = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_z_nobless(pTHX_ mpz_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp  = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_z_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_z(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_q_nobless(pTHX_ mpq_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_q_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_q(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_str_nobless(pTHX_ SV * q, SV * base, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret = (int)SvIV(base);

     CHECK_ROUNDING_VALUE

     if(ret < 0 || ret > MAXIMUM_ALLOWABLE_BASE || ret == 1)
        croak("2nd argument supplied to Rmpfr_init_set_str_nobless is out of allowable range");

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_str_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), ret, (mpfr_rnd_t)SvUV(round));

     NON_NUMERIC_CHAR_CHECK, "Rmpfr_init_set_str_nobless");}

     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_deref2(pTHX_ mpfr_t * p, SV * base, SV * n_digits, SV * round) {
     dXSARGS;
     char * out;
     mpfr_exp_t ptr;
     unsigned long b = (unsigned long)SvUV(base);

     CHECK_ROUNDING_VALUE

     if(b < 2 || b > MAXIMUM_ALLOWABLE_BASE)
        croak("Second argument supplied to Rmpfr_get_str is not in acceptable range");

     out = mpfr_get_str(0, &ptr, b, (unsigned long)SvUV(n_digits), *p, (mpfr_rnd_t)SvUV(round));

     if(out == NULL) croak("An error occurred in mpfr_get_str\n");

     /* sp  = mark; *//* not needed */
     ST(0) = sv_2mortal(newSVpv(out, 0));
     mpfr_free_str(out);
     ST(1) = sv_2mortal(newSViv(ptr));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_set_default_prec(pTHX_ SV * prec) {
     mpfr_set_default_prec((mpfr_prec_t)SvIV(prec));
}

SV * Rmpfr_get_default_prec(pTHX) {
     return newSViv(mpfr_get_default_prec());
}

SV * Rmpfr_min_prec(pTHX_ mpfr_t * x) {
     return newSViv((mpfr_prec_t)mpfr_min_prec(*x));
}

void Rmpfr_set_prec(pTHX_ mpfr_t * p, SV * prec) {
     mpfr_set_prec(*p, (mpfr_prec_t)SvIV(prec));
}

void Rmpfr_set_prec_raw(pTHX_ mpfr_t * p, SV * prec) {
     mpfr_set_prec_raw(*p, (mpfr_prec_t)SvIV(prec));
}

SV * Rmpfr_get_prec(pTHX_ mpfr_t * p) {
     return newSViv(mpfr_get_prec(*p));
}

SV * Rmpfr_set(pTHX_ mpfr_t * p, mpfr_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_ui(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_ui(*p, (unsigned long)SvUV(q), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_si(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_si(*p, (long)SvIV(q), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_uj(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_uj(*p, SvUV(q), (mpfr_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_uj not implemented on this build of perl - use Rmpfr_set_str instead");
#endif
#else
     croak("Rmpfr_set_uj not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_sj(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_sj(*p, SvIV(q), (mpfr_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_sj not implemented on this build of perl - use Rmpfr_set_str instead");
#endif
#else
     croak("Rmpfr_set_sj not implemented on this build of perl");
#endif
}


SV * Rmpfr_set_NV(pTHX_ mpfr_t * p, SV * q, unsigned int round) {

#if defined(NV_IS_LONG_DOUBLE) && !defined(_MSC_VER)

     if(!SvNOK(q)) croak("Second arg given to Rmpfr_set_NV is not an NV");

#if MPFR_VERSION_MAJOR < 3
     if((mpfr_rnd_t)round > 3)
       croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
     return newSViv(mpfr_set_ld(*p, (long double)SvNVX(q), (mpfr_rnd_t)round));

#elif defined(CAN_PASS_FLOAT128)

     if(!SvNOK(q)) croak("Second arg given to Rmpfr_set_NV is not an NV");

     return newSViv(mpfr_set_float128(*p, (float128)SvNVX(q), (mpfr_rnd_t)round));

#elif defined(NV_IS_FLOAT128)

     char buffer[45];
     int exp;
     float128 ld;
     int returned;

     if(!SvNOK(q)) croak("Second arg given to Rmpfr_set_NV is not an NV");

#if MPFR_VERSION_MAJOR < 3
     if((mpfr_rnd_t)round > 3)
       croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif

     ld = (float128)SvNVX(q);

     if(ld != ld) {
       mpfr_set_nan(*p);
       return newSViv(0);
     }

     if(ld != 0.0Q && (ld / ld != 1)) {
       returned = ld > 0.0Q ? 1 : -1;
       mpfr_set_inf(*p, returned);
       return newSViv(0);
     }

     ld = frexpq(ld, &exp); /* 0.5 <= returned value < 1.0 */

     /* Convert ld to an integer by right shifting it 113 bits */
     ld *= 1.0384593717069655257060992658440192e34Q;      /* ld *= powq(2.0Q, 113); */

     returned = quadmath_snprintf(buffer, 45, "%.0Qf", ld);
     if(returned < 0) croak("In Rmpfr_set_NV, encoding error in quadmath_snprintf function");
     if(returned >= 45) croak("In Rmpfr_set_NV, buffer given to quadmath_snprintf function was too small");

     returned = mpfr_set_str(*p, buffer, 10, (mpfr_rnd_t)round);

     mpfr_mul_2si(*p, *p, exp - 113, GMP_RNDN);

     return newSViv(returned);

#else

     if(!SvNOK(q)) croak("Second arg given to Rmpfr_set_NV is not an NV");

#if MPFR_VERSION_MAJOR < 3
     if((mpfr_rnd_t)round > 3)
       croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
     return newSViv(mpfr_set_d (*p, (double)SvNVX(q), (mpfr_rnd_t)round));
#endif
}

int Rmpfr_cmp_NV(pTHX_ mpfr_t * a, SV * b) {

#if defined(NV_IS_LONG_DOUBLE) && !defined(_MSC_VER)

     return mpfr_cmp_ld(*a, SvNV(b));

#elif defined(CAN_PASS_FLOAT128)

     mpfr_t t;
     int ret;
     mpfr_init2(t, FLT128_MANT_DIG);
     mpfr_set_float128(t, SvNV(b), GMP_RNDN);
     ret = mpfr_cmp(*a, t);
     mpfr_clear(t);
     return ret;

#elif defined(NV_IS_FLOAT128)

     mpfr_t t;
     char buffer[45];
     int exp;
     float128 ld;
     int returned;

     ld = (float128)SvNV(b);
     if(ld != ld || mpfr_nan_p(*a)) {
       mpfr_set_erangeflag();
       return 0;
     }

     if(ld != 0.0Q && (ld / ld != 1)) {
       if(ld > 0.0Q) {
         if(mpfr_inf_p(*a)) {
           if(mpfr_signbit(*a)) return -1;
           return 0;
         }
         return -1;
       }
       if(mpfr_inf_p(*a)) {
         if(mpfr_signbit(*a)) return 0;
         return 1;
       }
       return 1;
     }

     if(ld == 0.0Q) {
       if(mpfr_zero_p (*a)) return 0;
       if(mpfr_signbit(*a)) return -1;
       return 1;
     }


     ld = frexpq(ld, &exp); /* 0.5 <= returned value < 1.0 */

     /* Convert ld to an integer by right shifting it 113 bits */
     ld *= 1.0384593717069655257060992658440192e34Q;      /* ld *= powq(2.0Q, 113); */

     returned = quadmath_snprintf(buffer, 45, "%.0Qf", ld);
     if(returned < 0) croak("In Rmpfr_set_NV, encoding error in quadmath_snprintf function");
     if(returned >= 45) croak("In Rmpfr_set_NV, buffer given to quadmath_snprintf function was too small");

     mpfr_init2(t, FLT128_MANT_DIG);
     returned = mpfr_set_str(t, buffer, 10, GMP_RNDN);

     mpfr_mul_2si(t, t, exp - 113, GMP_RNDN);

     returned = mpfr_cmp(*a, t);
     mpfr_clear(t);
     return returned;

#else

     return mpfr_cmp_d(*a, SvNV(b));

#endif
}

SV * Rmpfr_set_ld(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
#ifndef _MSC_VER
     return newSViv(mpfr_set_ld(*p, (long double)SvNV(q), (mpfr_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_ld not implemented on this build of perl");
#endif
#else
     croak("Rmpfr_set_ld not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_d(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_d(*p, (double)SvNV(q), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_z(pTHX_ mpfr_t * p, mpz_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_z(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_q(pTHX_ mpfr_t * p, mpq_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_q(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_f(pTHX_ mpfr_t * p, mpf_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_f(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_set_str(pTHX_ mpfr_t * p, SV * num, SV * base, SV * round) {
#ifdef _WIN32_BIZARRE_INFNAN
    int inf_or_nan, ret = (int)SvIV(base);
#else
    int ret = (int)SvIV(base);
#endif
     CHECK_ROUNDING_VALUE
     if(ret < 0 || ret > MAXIMUM_ALLOWABLE_BASE || ret == 1)
        croak("3rd argument supplied to Rmpfr_set_str is out of allowable range");

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(num));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*p);
         }

         else mpfr_set_inf(*p, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(*p, SvPV_nolen(num), ret, (mpfr_rnd_t)SvUV(round));
       }
#else
       ret = mpfr_set_str(*p, SvPV_nolen(num), ret, (mpfr_rnd_t)SvUV(round));

#endif

     NON_NUMERIC_CHAR_CHECK, "Rmpfr_set_str");}

     return ret;
}

/*
Removed in Math-MPFR-3.30. Should have been removed much earlier
void Rmpfr_set_str_binary(pTHX_ mpfr_t * p, SV * str) {
     mpfr_set_str_binary(*p, SvPV_nolen(str));
}
*/

void Rmpfr_set_inf(mpfr_t * p, int sign) {
     mpfr_set_inf(*p, sign);
}

void Rmpfr_set_nan(mpfr_t * p) {
     mpfr_set_nan(*p);
}

void Rmpfr_swap(mpfr_t *p, mpfr_t * q) {
     mpfr_swap(*p, *q);
}

SV * Rmpfr_get_d(pTHX_ mpfr_t * p, SV * round){
     CHECK_ROUNDING_VALUE
     return newSVnv(mpfr_get_d(*p, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_d_2exp(pTHX_ SV * exp, mpfr_t * p, SV * round){
     long _exp;
     double ret;
     CHECK_ROUNDING_VALUE
     ret = mpfr_get_d_2exp(&_exp, *p, (mpfr_rnd_t)SvUV(round));
     sv_setiv(exp, _exp);
     return newSVnv(ret);
}

SV * Rmpfr_get_ld_2exp(pTHX_ SV * exp, mpfr_t * p, SV * round){
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
#if defined(NV_IS_FLOAT128) && defined(__GNUC__) && ((__GNUC__ > 4 && __GNUC__ < 7) || (__GNUC__ == 4 && __GNUC_MINOR__ >= 9))
  /*
     Casting long double Inf to float128 might result in NaN.
     This is GCC bug 77265, which was fixed for GCC 7:
     https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77265
     The fix might yet be backported to GCC 6. (Not sure.)
     It was earlier reported (also by me) to MinGW:
     https://sourceforge.net/p/mingw-w64/bugs/479/
     Let us take the cautious approach and simply avoid
     making that cast. Instead, we will cast the double Inf
     to a float128.
  */
     if(mpfr_inf_p(*p))
       return newSVnv(mpfr_get_d(*p, (mpfr_rnd_t)SvUV(round)));
#endif
#ifndef _MSC_VER
     long _exp;
     long double ret;
     CHECK_ROUNDING_VALUE
     ret = mpfr_get_ld_2exp(&_exp, *p, (mpfr_rnd_t)SvUV(round));
     sv_setiv(exp, _exp);
     return newSVnv(ret);
#else
     croak("Rmpfr_get_ld_2exp not implemented on this build of perl");
#endif
#else
     croak("Rmpfr_get_ld_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_ld(pTHX_ mpfr_t * p, SV * round){
     CHECK_ROUNDING_VALUE
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
#if defined(NV_IS_FLOAT128) && defined(__GNUC__) && ((__GNUC__ > 4 && __GNUC__ < 7) || (__GNUC__ == 4 && __GNUC_MINOR__ >= 9))
  /*
     Casting long double Inf to float128 might result in NaN.
     This is GCC bug 77265, which was fixed for GCC 7:
     https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77265
     The fix might yet be backported to GCC 6. (Not sure.)
     It was earlier reported (also by me) to MinGW:
     https://sourceforge.net/p/mingw-w64/bugs/479/
     Let us take the cautious approach and simply avoid
     making that cast. Instead, we will cast the double Inf
     to a float128.
  */
     if(mpfr_inf_p(*p))
       return newSVnv(mpfr_get_d(*p, (mpfr_rnd_t)SvUV(round)));

#elif LDBL_MANT_DIG == 106
#if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= DD_INF_BUG)
     double d = mpfr_get_ld(*p, (mpfr_rnd_t)SvUV(round));

     if(d == 0.0 || d != d || d / d != 1) return newSVnv((long double)d);
#endif
#endif
#ifndef _MSC_VER
#if defined MPFR_VERSION && MPFR_VERSION > 196868            /* mpfr_get_ld handles subnormals correctly */
     return newSVnv(mpfr_get_ld(*p, (mpfr_rnd_t)SvUV(round)));
#else                                                        /* mpfr_get_ld handling of subnormals is buggy */

     if(strtold("2e-4956", NULL) == 0.0L) { /* extended precision (80-bit) long double */
       if(mpfr_regular_p(*p) && mpfr_get_exp(*p) < -16381 && mpfr_get_exp(*p) >= -16445) {
         warn("\n mpfr_get_ld is buggy (subnormal values only)\n for this version (%s) of the MPFR library\n", MPFR_VERSION_STRING);
         croak(" Version 3.1.5 or later is required");
       }
     }
     return newSVnv(mpfr_get_ld(*p, (mpfr_rnd_t)SvUV(round)));

#endif
#else
     croak("Rmpfr_get_ld not implemented on this build of perl");
#endif
#else
     croak("Rmpfr_get_ld not implemented on this build of perl");
#endif
}

double Rmpfr_get_d1(mpfr_t * p) {
     return mpfr_get_d1(*p);
}

/* Alias for the perl function Rmpfr_get_z_exp
*  (which will perhaps one day be removed).
*  The mpfr headers define 'mpfr_get_z_exp' to
*  'mpfr_get_z_2exp' when that function is
*  available.
*/
SV * Rmpfr_get_z_2exp(pTHX_ mpz_t * z, mpfr_t * p){
     return newSViv(mpfr_get_z_exp(*z, *p));
}

SV * Rmpfr_add(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     DEAL_WITH_NANFLAG_BUG
     return newSViv(mpfr_add_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     DEAL_WITH_NANFLAG_BUG
     return newSViv(mpfr_add_si(*a, *b, (int)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     DEAL_WITH_NANFLAG_BUG
     return newSViv(mpfr_sub_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_sub(*a, (unsigned long)SvUV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_d_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_d_sub(*a, (double)SvNV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_dim(pTHX_ mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, SV * round) {
     CHECK_ROUNDING_VALUE
         int ret = mpfr_dim( *rop, *op1, *op2, (mpfr_rnd_t)SvUV(round));
         return newSViv(ret);
}

SV * Rmpfr_div(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_div(*a, (unsigned long)SvUV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_d_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_d_div(*a, (double)SvNV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sqrt(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rec_sqrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rec_sqrt(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cbrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cbrt(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqrt_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sqrt_ui(*a, (unsigned long)SvUV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_pow_ui(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_pow_ui(*a, (unsigned long)SvUV(b), (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_pow(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_pow(*a, (unsigned long)SvUV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_neg(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_neg(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_abs(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_abs(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_2exp(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_2ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_2si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_2exp(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_2ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_2si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_cmp(mpfr_t * a, mpfr_t * b) {
     return mpfr_cmp(*a, *b);
}

int Rmpfr_cmpabs(mpfr_t * a, mpfr_t * b) {
     return mpfr_cmpabs(*a, *b);
}

int Rmpfr_cmp_ui(mpfr_t * a, unsigned long b) {
     return mpfr_cmp_ui(*a, b);
}

int Rmpfr_cmp_d(mpfr_t * a, double b) {
     return mpfr_cmp_d(*a, b);
}

int Rmpfr_cmp_ld(pTHX_ mpfr_t * a, SV * b) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
#ifndef _MSC_VER
     return mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
     croak("Rmpfr_cmp_ld not implemented on this build of perl");
#endif
#else
     croak("Rmpfr_cmp_ld not implemented on this build of perl");
#endif
}

int Rmpfr_cmp_si(mpfr_t * a, long b) {
     return mpfr_cmp_si(*a, b);
}

int Rmpfr_cmp_ui_2exp(pTHX_ mpfr_t * a, SV * b, SV * c) {
     return mpfr_cmp_ui_2exp(*a, (unsigned long)SvUV(b), (mpfr_exp_t)SvIV(c));
}

int Rmpfr_cmp_si_2exp(pTHX_ mpfr_t * a, SV * b, SV * c) {
     return mpfr_cmp_si_2exp(*a, (long)SvIV(b), (mpfr_exp_t)SvIV(c));
}

int Rmpfr_eq(mpfr_t * a, mpfr_t * b, unsigned long c) {
     return mpfr_eq(*a, *b, c);
}

int Rmpfr_nan_p(mpfr_t * p) {
     return mpfr_nan_p(*p);
}

int Rmpfr_inf_p(mpfr_t * p) {
     return mpfr_inf_p(*p);
}

int Rmpfr_number_p(mpfr_t * p) {
     return mpfr_number_p(*p);
}

void Rmpfr_reldiff(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     mpfr_reldiff(*a, *b, *c, (mpfr_rnd_t)SvUV(round));
}

int Rmpfr_sgn(mpfr_t * p) {
     return mpfr_sgn(*p);
}

int Rmpfr_greater_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_greater_p(*a, *b);
}

int Rmpfr_greaterequal_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_greaterequal_p(*a, *b);
}

int Rmpfr_less_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_less_p(*a, *b);
}

int Rmpfr_lessequal_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_lessequal_p(*a, *b);
}

int Rmpfr_lessgreater_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_lessgreater_p(*a, *b);
}

int Rmpfr_equal_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_equal_p(*a, *b);
}

int Rmpfr_unordered_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_unordered_p(*a, *b);
}

SV * Rmpfr_sin_cos(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sin_cos(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sinh_cosh(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sinh_cosh(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sin(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sin(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cos(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cos(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_tan(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_tan(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_asin(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_asin(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_acos(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_acos(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atan(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_atan(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sinh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sinh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cosh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cosh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_tanh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_tanh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_asinh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_asinh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_acosh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_acosh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atanh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_atanh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fac_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fac_ui(*a, (unsigned long)SvUV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_log1p(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log1p(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_expm1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_expm1(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_log2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log2(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_log10(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log10(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fma(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, mpfr_t * d, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fma(*a, *b, *c, *d, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fms(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, mpfr_t * d, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fms(*a, *b, *c, *d, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_agm(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_agm(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_hypot(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_hypot(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_log2(pTHX_ mpfr_t * p, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_log2(*p, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_pi(pTHX_ mpfr_t * p, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_pi(*p, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_euler(pTHX_ mpfr_t * p, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_euler(*p, (mpfr_rnd_t)SvUV(round)));
}

/*
Removed in Math-MPFR-3.30. Should have been removed much earlier
void Rmpfr_print_binary(mpfr_t * p) {
     mpfr_print_binary(*p);
}
*/

SV * Rmpfr_rint(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_ceil(mpfr_t * a, mpfr_t * b) {
     return mpfr_ceil(*a, *b);
}

int Rmpfr_floor(mpfr_t * a, mpfr_t * b) {
     return mpfr_floor(*a, *b);
}

int Rmpfr_round(mpfr_t * a, mpfr_t * b) {
     return mpfr_round(*a, *b);
}

int Rmpfr_trunc(mpfr_t * a, mpfr_t * b) {
     return mpfr_trunc(*a, *b);
}

/* NO LONGER SUPPORTED - use Rmpfr_nextabove instead
SV * Rmpfr_add_one_ulp(mpfr_t * p, SV * round) {
     return newSViv(mpfr_add_one_ulp(*p, (mpfr_rnd_t)SvUV(round)));
} */

/* NO LONGER SUPPORTED - use Rmpfr_nextbelow instead
SV * Rmpfr_sub_one_ulp(mpfr_t * p, SV * round) {
     return newSViv(mpfr_sub_one_ulp(*p, (mpfr_rnd_t)SvUV(round)));
} */

SV * Rmpfr_can_round(pTHX_ mpfr_t * p, SV * err, SV * round1, SV * round2, SV * prec) {
#if MPFR_VERSION_MAJOR < 3
    if((mpfr_rnd_t)SvUV(round1) > 3 || (mpfr_rnd_t)SvUV(round2) > 3)
      croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
     return newSViv(mpfr_can_round(*p, (mpfr_exp_t)SvIV(err), SvUV(round1), SvUV(round2), (mpfr_prec_t)SvIV(prec)));
}

SV * Rmpfr_print_rnd_mode(pTHX_ SV * rnd) {
     const char * x = mpfr_print_rnd_mode((mpfr_rnd_t)SvIV(rnd));
     if(x == NULL) return &PL_sv_undef;
     return newSVpv(x, 0);
}

SV * Rmpfr_get_emin(pTHX) {
     return newSViv(mpfr_get_emin());
}

SV * Rmpfr_get_emax(pTHX) {
     return newSViv(mpfr_get_emax());
}

int Rmpfr_set_emin(pTHX_ SV * e) {
     return mpfr_set_emin((mpfr_exp_t)SvIV(e));
}

int Rmpfr_set_emax(pTHX_ SV * e) {
     return mpfr_set_emax((mpfr_exp_t)SvIV(e));
}

SV * Rmpfr_check_range(pTHX_ mpfr_t * p, SV * t, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_check_range(*p, (int)SvIV(t), (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_clear_underflow(void) {
     mpfr_clear_underflow();
}

void Rmpfr_clear_overflow(void) {
     mpfr_clear_overflow();
}

void Rmpfr_clear_nanflag(void) {
     mpfr_clear_nanflag();
}

void Rmpfr_clear_inexflag(void) {
     mpfr_clear_inexflag();
}

void Rmpfr_clear_flags(void) {
     mpfr_clear_flags();
}

int Rmpfr_underflow_p(void) {
     return mpfr_underflow_p();
}

int Rmpfr_overflow_p(void) {
     return mpfr_overflow_p();
}

int Rmpfr_nanflag_p(void) {
     return mpfr_nanflag_p();
}

int Rmpfr_inexflag_p(void) {
     return mpfr_inexflag_p();
}

SV * Rmpfr_log(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_exp(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_exp2(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp10(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_exp10(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_urandomb(pTHX_ SV * x, ...) {
     dXSARGS;
     unsigned long i, t;

     t = items;
     --t;

     for(i = 0; i < t; ++i) {
        mpfr_urandomb(*(INT2PTR(mpfr_t *, SvIVX(SvRV(ST(i))))), *(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(t))))));
        }
     XSRETURN(0);
}

void Rmpfr_random2(pTHX_ mpfr_t * p, SV * s, SV * exp) {
#if MPFR_VERSION_MAJOR > 2
     croak("Rmpfr_random2 no longer implemented. Use Rmpfr_urandom or Rmpfr_urandomb");
#else
     mpfr_random2(*p, (int)SvIV(s), (mpfr_exp_t)SvIV(exp));
#endif
}

SV * _TRmpfr_out_str(pTHX_ FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round) {
     size_t ret;
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("2nd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpfr_out_str(pTHX_ mpfr_t * p, SV * base, SV * dig, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("2nd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     fflush(stdout);
     return newSVuv(ret);
}

SV * _TRmpfr_out_strS(pTHX_ FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
       croak("2nd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
       MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     fflush(stream);
     fprintf(stream, "%s", SvPV_nolen(suff));
     fflush(stream);
     return newSVuv(ret);
}

SV * _TRmpfr_out_strP(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     fprintf(stream, "%s", SvPV_nolen(pre));
     fflush(stream);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     fflush(stream);
     return newSVuv(ret);
}

SV * _TRmpfr_out_strPS(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     fprintf(stream, "%s", SvPV_nolen(pre));
     fflush(stream);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     fflush(stream);
     fprintf(stream, "%s", SvPV_nolen(suff));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpfr_out_strS(pTHX_ mpfr_t * p, SV * base, SV * dig, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
       croak("2nd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
       MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     printf("%s", SvPV_nolen(suff));
     fflush(stdout);
     return newSVuv(ret);
}

SV * _Rmpfr_out_strP(pTHX_ SV * pre, mpfr_t * p, SV * base, SV * dig, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     printf("%s", SvPV_nolen(pre));
     ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     fflush(stdout);
     return newSVuv(ret);
}

SV * _Rmpfr_out_strPS(pTHX_ SV * pre, mpfr_t * p, SV * base, SV * dig, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
       croak("3rd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
       MAXIMUM_ALLOWABLE_BASE);
     printf("%s", SvPV_nolen(pre));
     ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
     printf("%s", SvPV_nolen(suff));
     fflush(stdout);
     return newSVuv(ret);
}

SV * TRmpfr_inp_str(pTHX_ mpfr_t * p, FILE * stream, SV * base, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to TRmpfr_inp_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_inp_str(*p, stream, (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
     if(!ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("input to TRmpfr_inp_str contains non-numeric characters");
     }
     /* fflush(stream); */
     return newSVuv(ret);
}

SV * Rmpfr_inp_str(pTHX_ mpfr_t * p, SV * base, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("2nd argument supplied to Rmpfr_inp_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_inp_str(*p, stdin, (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
     if(!ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("input to Rmpfr_inp_str contains non-numeric characters");
     }
     /* fflush(stdin); */
     return newSVuv(ret);
}

SV * Rmpfr_gamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_gamma(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_zeta(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_zeta(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_zeta_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_zeta_ui(*a, (unsigned long)SvUV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_erf(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_erf(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_frac(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_frac(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_remainder(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_remainder(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_modf(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_modf(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fmod(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fmod(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_remquo(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     dXSARGS;
     long ret, q;
     CHECK_ROUNDING_VALUE
     ret = mpfr_remquo(*a, &q, *b, *c, (mpfr_rnd_t)SvUV(round));
     ST(0) = sv_2mortal(newSViv(q));
     ST(1) = sv_2mortal(newSViv(ret));
     XSRETURN(2);
}

int Rmpfr_integer_p(mpfr_t * p) {
     return mpfr_integer_p(*p);
}

void Rmpfr_nexttoward(mpfr_t * a, mpfr_t * b) {
     mpfr_nexttoward(*a, *b);
}

void Rmpfr_nextabove(mpfr_t * p) {
     mpfr_nextabove(*p);
}

void Rmpfr_nextbelow(mpfr_t * p) {
     mpfr_nextbelow(*p);
}

SV * Rmpfr_min(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_min(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_max(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_max(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_exp(pTHX_ mpfr_t * p) {
     return newSViv(mpfr_get_exp(*p));
}

SV * Rmpfr_set_exp(pTHX_ mpfr_t * p, SV * exp) {
     return newSViv(mpfr_set_exp(*p, (mpfr_exp_t)SvIV(exp)));
}

int Rmpfr_signbit(mpfr_t * op) {
     return mpfr_signbit(*op);
}

SV * Rmpfr_setsign(pTHX_ mpfr_t * rop, mpfr_t * op, SV * sign, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_setsign(*rop, *op, SvIV(sign), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_copysign(pTHX_ mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_copysign(*rop, *op1, *op2, (mpfr_rnd_t)SvUV(round)));
}

SV * get_refcnt(pTHX_ SV * s) {
     return newSVuv(SvREFCNT(s));
}

SV * get_package_name(pTHX_ SV * x) {
     if(sv_isobject(x)) return newSVpv(HvNAME(SvSTASH(SvRV(x))), 0);
     return newSViv(0);
}

void Rmpfr_dump(mpfr_t * a) { /* Once took a 'round' argument */
     mpfr_dump(*a);
}

SV * gmp_v(pTHX) {
#if __GNU_MP_VERSION >= 4
     return newSVpv(gmp_version, 0);
#else
     warn("From Math::MPFR::gmp_v(aTHX): 'gmp_version' is not implemented - returning '0'");
     return newSVpv("0", 0);
#endif
}

/* NEW in MPFR-2.1.0 */

SV * Rmpfr_set_ui_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     return newSViv(mpfr_set_ui_2exp(*a, (unsigned long)SvUV(b), (mpfr_exp_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_si_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     return newSViv(mpfr_set_si_2exp(*a, (long)SvIV(b), (mpfr_exp_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_uj_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_uj_2exp(*a, SvUV(b), SvIV(c), (mpfr_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_set_uj_2exp not implemented on this build of perl");
#endif
#else
     croak ("Rmpfr_set_uj_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_sj_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_sj_2exp(*a, SvIV(b), SvIV(c), (mpfr_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_set_sj_2exp not implemented on this build of perl");
#endif
#else
     croak ("Rmpfr_set_sj_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_z(pTHX_ mpz_t * a, mpfr_t * b, SV * round) {
#if MPFR_VERSION_MAJOR < 3
     CHECK_ROUNDING_VALUE
     mpfr_get_z(*a, *b, (mpfr_rnd_t)SvUV(round));
     return &PL_sv_undef;
#else
     return newSViv(mpfr_get_z(*a, *b, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_si_sub(pTHX_ mpfr_t * a, SV * c, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     DEAL_WITH_NANFLAG_BUG
     return newSViv(mpfr_si_sub(*a, (long)SvIV(c), *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     DEAL_WITH_NANFLAG_BUG
     return newSViv(mpfr_sub_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_si_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_si_div(*a, (long)SvIV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqr(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sqr(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_cmp_z(mpfr_t * a, mpz_t * b) {
     return mpfr_cmp_z(*a, *b);
}

int Rmpfr_cmp_q(mpfr_t * a, mpq_t * b) {
     return mpfr_cmp_q(*a, *b);
}

int Rmpfr_cmp_f(mpfr_t * a, mpf_t * b) {
     return mpfr_cmp_f(*a, *b);
}

int Rmpfr_zero_p(mpfr_t * a) {
     return mpfr_zero_p(*a);
}

void Rmpfr_free_cache(void) {
     mpfr_free_cache();
}

void Rmpfr_free_cache2(unsigned int way) {
#if MPFR_VERSION_MAJOR >= 4
     mpfr_free_cache2((mpfr_free_cache_t) way);
#else
     croak("Rmpfr_free_cache2 not implemented with this mpfr version (%s) - need 4.0.0 or later", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_free_pool(void) {
#if MPFR_VERSION_MAJOR >= 4
     mpfr_free_pool();
#else
     croak("Rmpfr_free_pool not implemented with this mpfr version (%s) - need 4.0.0 or later", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_get_version(pTHX) {
     return newSVpv(mpfr_get_version(), 0);
}

SV * Rmpfr_get_patches(pTHX) {
     return newSVpv(mpfr_get_patches(), 0);
}

SV * Rmpfr_get_emin_min(pTHX) {
     return newSViv(mpfr_get_emin_min());
}

SV * Rmpfr_get_emin_max(pTHX) {
     return newSViv(mpfr_get_emin_max());
}

SV * Rmpfr_get_emax_min(pTHX) {
     return newSViv(mpfr_get_emax_min());
}

SV * Rmpfr_get_emax_max(pTHX) {
     return newSViv(mpfr_get_emax_max());
}

void Rmpfr_clear_erangeflag(void) {
     mpfr_clear_erangeflag();
}

int Rmpfr_erangeflag_p(void) {
     return mpfr_erangeflag_p();
}

SV * Rmpfr_rint_round(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_round(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_trunc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_trunc(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_ceil(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_ceil(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_floor(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_floor(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_ui(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_get_ui(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_si(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_get_si(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_uj(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
     return newSVuv(mpfr_get_uj(*a, (mpfr_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_get_uj not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_sj(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
     return newSViv(mpfr_get_sj(*a, (mpfr_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_get_sj not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_IV(pTHX_ mpfr_t * x, SV * round) {
     CHECK_ROUNDING_VALUE
     if(sizeof(IV) == sizeof(long)) return newSViv(mpfr_get_si(*x, (mpfr_rnd_t)SvUV(round)));
#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(IV) == sizeof(intmax_t)) return newSViv(mpfr_get_sj(*x, (mpfr_rnd_t)SvUV(round)));
#else
     if(sizeof(IV) == sizeof(signed __int64)) return newSViv(mpfr_get_sj(*x, (mpfr_rnd_t)SvUV(round)));
#endif
#endif
     croak("Rmpfr_get_IV not implemented on this build of perl");
}

SV * Rmpfr_get_UV(pTHX_ mpfr_t * x, SV * round) {
     CHECK_ROUNDING_VALUE
     if(sizeof(UV) == sizeof(unsigned long)) return newSVuv(mpfr_get_ui(*x, (mpfr_rnd_t)SvUV(round)));
#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(UV) == sizeof(uintmax_t)) return newSVuv(mpfr_get_uj(*x, (mpfr_rnd_t)SvUV(round)));
#else
     if(sizeof(UV) == sizeof(unsigned __int64)) return newSVuv(mpfr_get_uj(*x, (mpfr_rnd_t)SvUV(round)));
#endif
#endif
     croak("Rmpfr_get_UV not implemented on this build of perl");
}

SV * Rmpfr_get_NV(pTHX_ mpfr_t * x, SV * round) {

     CHECK_ROUNDING_VALUE

#if defined(CAN_PASS_FLOAT128)

     return newSVnv(mpfr_get_float128(*x, (mpfr_rnd_t)SvUV(round)));

#elif defined(NV_IS_FLOAT128)

     mpfr_t t;
     int i, c = 0;
     mpfr_prec_t exp, bits = 113;
     mpfr_rnd_t r = (mpfr_rnd_t)SvUV(round);
     char *out;
     float128 ret = 0.0Q, sign = 1.0Q;

     float128 add_on[113] = {
      5192296858534827628530496329220096e0Q, 2596148429267413814265248164610048e0Q,
      1298074214633706907132624082305024e0Q, 649037107316853453566312041152512e0Q,
      324518553658426726783156020576256e0Q, 162259276829213363391578010288128e0Q,
      81129638414606681695789005144064e0Q, 40564819207303340847894502572032e0Q,
      20282409603651670423947251286016e0Q, 10141204801825835211973625643008e0Q,
      5070602400912917605986812821504e0Q, 2535301200456458802993406410752e0Q,
      1267650600228229401496703205376e0Q, 633825300114114700748351602688e0Q,
      316912650057057350374175801344e0Q, 158456325028528675187087900672e0Q, 79228162514264337593543950336e0Q,
      39614081257132168796771975168e0Q, 19807040628566084398385987584e0Q, 9903520314283042199192993792e0Q,
      4951760157141521099596496896e0Q, 2475880078570760549798248448e0Q, 1237940039285380274899124224e0Q,
      618970019642690137449562112e0Q, 309485009821345068724781056e0Q, 154742504910672534362390528e0Q,
      77371252455336267181195264e0Q, 38685626227668133590597632e0Q, 19342813113834066795298816e0Q,
      9671406556917033397649408e0Q, 4835703278458516698824704e0Q, 2417851639229258349412352e0Q,
      1208925819614629174706176e0Q, 604462909807314587353088e0Q, 302231454903657293676544e0Q,
      151115727451828646838272e0Q, 75557863725914323419136e0Q, 37778931862957161709568e0Q,
      18889465931478580854784e0Q, 9444732965739290427392e0Q, 4722366482869645213696e0Q,
      2361183241434822606848e0Q, 1180591620717411303424e0Q, 590295810358705651712e0Q, 295147905179352825856e0Q,
      147573952589676412928e0Q, 73786976294838206464e0Q, 36893488147419103232e0Q, 18446744073709551616e0Q,
      9223372036854775808e0Q, 4611686018427387904e0Q, 2305843009213693952e0Q, 1152921504606846976e0Q,
      576460752303423488e0Q, 288230376151711744e0Q, 144115188075855872e0Q, 72057594037927936e0Q,
      36028797018963968e0Q, 18014398509481984e0Q, 9007199254740992e0Q, 4503599627370496e0Q,
      2251799813685248e0Q, 1125899906842624e0Q, 562949953421312e0Q, 281474976710656e0Q, 140737488355328e0Q,
      70368744177664e0Q, 35184372088832e0Q, 17592186044416e0Q, 8796093022208e0Q, 4398046511104e0Q,
      2199023255552e0Q, 1099511627776e0Q, 549755813888e0Q, 274877906944e0Q, 137438953472e0Q, 68719476736e0Q,
      34359738368e0Q, 17179869184e0Q, 8589934592e0Q, 4294967296e0Q, 2147483648e0Q, 1073741824e0Q, 536870912e0Q,
      268435456e0Q, 134217728e0Q, 67108864e0Q, 33554432e0Q, 16777216e0Q, 8388608e0Q, 4194304e0Q, 2097152e0Q,
      1048576e0Q, 524288e0Q, 262144e0Q, 131072e0Q, 65536e0Q, 32768e0Q, 16384e0Q, 8192e0Q, 4096e0Q, 2048e0Q,
      1024e0Q, 512e0Q, 256e0Q, 128e0Q, 64e0Q, 32e0Q, 16e0Q, 8e0Q, 4e0Q, 2e0Q, 1e0Q };

     if(!mpfr_regular_p(*x)) return newSVnv((float128)mpfr_get_d(*x, GMP_RNDZ));

     exp = mpfr_get_exp(*x);
     if(exp < -16381)
       bits = exp + 16494;

     if(bits <= 0) {
       mpfr_init2(t, 53);
       if(mpfr_sgn(*x) > 0) {	/* positive */
         mpfr_set_str(t, "0.1e-16494", 2, GMP_RNDZ);
         c = mpfr_cmp(*x, t);
         mpfr_clear(t);
         if(c <= 0) {
           if(r == GMP_RNDN || r == GMP_RNDD || r == GMP_RNDZ) return newSVnv(0.0Q);
           return newSVnv(6.475175119438025110924438958227646552e-4966Q);
         }
         else {
           if(r == GMP_RNDN || r == GMP_RNDU || r == MPFR_RNDA)
             return newSVnv(6.475175119438025110924438958227646552e-4966Q);
           return newSVnv(0.0Q);
         }
       }
       else {			/* negative */
         mpfr_set_str(t, "-0.1e-16494", 2, GMP_RNDZ);
         c = mpfr_cmp(*x, t);
         mpfr_clear(t);
         if(c >= 0) {
           if(r == GMP_RNDN || r == GMP_RNDU || r == GMP_RNDZ) return newSVnv(0.0Q);
           return newSVnv(-6.475175119438025110924438958227646552e-4966Q);
         }
         if(c < 0) {
           if(r == GMP_RNDN || r == GMP_RNDD || r == MPFR_RNDA)
             return newSVnv(-6.475175119438025110924438958227646552e-4966Q);
           return newSVnv(0.0Q);
         }
       }
     }
     else {
       mpfr_init2(t, bits);
       mpfr_set(t, *x, r);
     }

     Newxz(out, 115, char);
     if(out == NULL) croak("Failed to allocate memory in Rmpfr_get_NV function");

     mpfr_get_str(out, &exp, 2, 113, t, (mpfr_rnd_t)SvUV(round));

     mpfr_clear(t);

     if(out[0] == '-') {
       sign = -1.0Q;
       out++;
       c++;
     }
     else {
       if(out[0] == '+') {
         out++;
         c++;
       }
     }

     for(i = 0; i < bits; i++) {
       if(out[i] == '1') ret += add_on[i];
     }

     if(c) out--;
     Safefree(out);

     c = exp < -16381 ? exp + 16381 : 0;	/* function has already returned if exp < -16494 */

     if(c) { 			/* powq(2.0Q, exp) will be zero - so do the calculation in 2 steps */
       ret *= powq(2.0Q, c);
       exp -= c;		/* exp += abs(c) */
     }

     ret *= powq(2.0Q, exp - 113);
     return newSVnv(ret * sign);

#elif defined(NV_IS_LONG_DOUBLE)
#if defined(LD_SUBNORMAL_BUG)

     if(mpfr_get_exp(*x) < -16381 && mpfr_regular_p(*x) && mpfr_get_exp(*x) >= -16445 ) {
       warn("\n mpfr_get_ld is buggy (subnormal values only)\n for this version (%s) of the MPFR library\n", MPFR_VERSION_STRING);
       croak(" Version 3.1.5 or later is required");
     }

     return newSVnv(mpfr_get_ld(*x, (mpfr_rnd_t)SvUV(round)));

#else
     return newSVnv(mpfr_get_ld(*x, (mpfr_rnd_t)SvUV(round)));
#endif
#else
     return newSVnv(mpfr_get_d(*x, (mpfr_rnd_t)SvUV(round)));
#endif

}

SV * Rmpfr_fits_ulong_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_ulong_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
     if((mpfr_rnd_t)SvUV(round) < 3) {
       if((mpfr_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_ulong_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_slong_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_slong_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_ushort_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_ushort_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
     if((mpfr_rnd_t)SvUV(round) < 3) {
       if((mpfr_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_ushort_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_sshort_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_sshort_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_uint_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_uint_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
     if((mpfr_rnd_t)SvUV(round) < 3) {
       if((mpfr_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_uint_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_sint_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_sint_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_uintmax_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_uintmax_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
     if(mpfr_zero_p(*a)) return newSVuv(1);
     if((mpfr_rnd_t)SvUV(round) < 3) {
       if((mpfr_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_uintmax_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_intmax_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_intmax_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_IV_p(pTHX_ mpfr_t * x, SV * round) {
     unsigned long ret = 0, bits = sizeof(IV) * 8;
     mpfr_t high, low, copy;

     CHECK_ROUNDING_VALUE

     if(sizeof(IV) == sizeof(long)) {
       if(mpfr_fits_slong_p(*x, (mpfr_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }

     if(sizeof(IV) == sizeof(int)) {
       if(mpfr_fits_sint_p(*x, (mpfr_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }

#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(IV) == sizeof(intmax_t)) {
       if(mpfr_fits_intmax_p(*x, (mpfr_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }
#else
     if(sizeof(IV) == sizeof(signed __int64)) {
       if(mpfr_fits_intmax_p(*x, (mpfr_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }
#endif
#endif

     mpfr_init2(high, bits);
     mpfr_init2(low, bits);
     mpfr_init2(copy, bits - 1);

     mpfr_set_ui(high, 1, GMP_RNDN);
     mpfr_mul_2exp(high, high, bits - 1, GMP_RNDN);
     mpfr_sub_ui(high, high, 1, GMP_RNDN);

     mpfr_setsign(low, high, 1, GMP_RNDN);
     mpfr_sub_ui(low, low, 1, GMP_RNDN);
     mpfr_set(copy, *x, (mpfr_rnd_t)SvUV(round));

     if(mpfr_lessequal_p(copy, high) && mpfr_greaterequal_p(copy, low)) ret = 1;

     mpfr_clear(high);
     mpfr_clear(low);
     mpfr_clear(copy);

     return newSVuv(ret);
}

SV * Rmpfr_fits_UV_p(pTHX_ mpfr_t * x, SV * round) {
     unsigned long ret = 0, bits = sizeof(UV) * 8;
     mpfr_t high, copy;

     CHECK_ROUNDING_VALUE

     if(sizeof(UV) == sizeof(unsigned long)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_ulong_p(*x, (mpfr_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mpfr_rnd_t)SvUV(round) < 3) {
         if((mpfr_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_ulong_p(*x, (mpfr_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }

     if(sizeof(UV) == sizeof(unsigned int)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_uint_p(*x, (mpfr_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mpfr_rnd_t)SvUV(round) < 3) {
         if((mpfr_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_uint_p(*x, (mpfr_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }

#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(UV) == sizeof(uintmax_t)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_uintmax_p(*x, (mpfr_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mpfr_rnd_t)SvUV(round) < 3) {
         if((mpfr_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_uintmax_p(*x, (mpfr_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }
#else /* _MSC_VER defined */
     if(sizeof(UV) == sizeof(unsigned __int64)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_uintmax_p(*x, (mpfr_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mpfr_rnd_t)SvUV(round) < 3) {
         if((mpfr_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_uintmax_p(*x, (mpfr_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }
#endif /* MSC_VER */
#endif /* MATH_MPFR_NEED_LONG_LONG_INT */

     mpfr_init2(high, bits + 1);
     mpfr_init2(copy, bits);

     mpfr_set_ui(high, 1, GMP_RNDN);
     mpfr_mul_2exp(high, high, bits, GMP_RNDN);
     mpfr_sub_ui(high, high, 1, GMP_RNDN);

     mpfr_set(copy, *x, (mpfr_rnd_t)SvUV(round));

     if(mpfr_lessequal_p(copy, high) && mpfr_cmp_ui(copy, 0) >= 0) ret = 1;

     mpfr_clear(high);
     mpfr_clear(copy);

     return newSVuv(ret);
}

SV * Rmpfr_strtofr(pTHX_ mpfr_t * a, SV * str, SV * base, SV * round) {
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan, b = (int)SvIV(base);
#else
     int b = (int)SvIV(base);
#endif

#if MPFR_VERSION_MAJOR < 3
     CHECK_ROUNDING_VALUE
     if(b < 0 || b > MAXIMUM_ALLOWABLE_BASE || b == 1)
        croak("3rd argument supplied to Rmpfr_strtofr is out of allowable range");
#else
     if(b < 0 || b > 62 || b == 1) croak("3rd argument supplied to Rmpfr_strtofr is out of allowable range");
#endif


#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(str));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*a);
           return newSViv(0);
         }

         mpfr_set_inf(*a, inf_or_nan);
         return newSViv(0);
       }
       else {
         return newSViv(mpfr_strtofr(*a, SvPV_nolen(str), NULL, b, (mpfr_rnd_t)SvUV(round)));
       }
#else
       return newSViv(mpfr_strtofr(*a, SvPV_nolen(str), NULL, b, (mpfr_rnd_t)SvUV(round)));

#endif
}

void Rmpfr_set_erangeflag(void) {
     mpfr_set_erangeflag();
}

void Rmpfr_set_underflow(void) {
     mpfr_set_underflow();
}

void Rmpfr_set_overflow(void) {
     mpfr_set_overflow();
}

void Rmpfr_set_nanflag(void) {
     mpfr_set_nanflag();
}

void Rmpfr_set_inexflag(void) {
     mpfr_set_inexflag();
}

SV * Rmpfr_erfc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_erfc(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_j0(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_j0(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_j1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_j1(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_jn(pTHX_ mpfr_t * a, SV * n, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_jn(*a, (long)SvIV(n), *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_y0(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_y0(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_y1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_y1(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_yn(pTHX_ mpfr_t * a, SV * n, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_yn(*a, (long)SvIV(n), *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atan2(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_atan2(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c,  SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_subnormalize(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_subnormalize(*a, (int)SvIV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_catalan(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_catalan(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sec(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sec(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_csc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_csc(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cot(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cot(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_root(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
#if MPFR_VERSION_MAJOR >= 4
     warn("Rmpfr_root is deprecated - use Rmpfr_rootn_ui instead");
#endif
     return newSViv(mpfr_root(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_eint(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_eint(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_li2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_li2(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_f(pTHX_ mpf_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_get_f(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

/* No need for rounding as result will be exact */
void Rmpfr_get_q(mpq_t * a, mpfr_t * b) {

#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4

     mpfr_get_q(*a, *b);

#else
     mpf_t temp;

     if(!mpfr_number_p(*b)) {
       mpq_set_ui(*a, 0, 1);
       mpfr_set_erangeflag();
     }
     else {
       mpf_init2 (temp, (mp_bitcnt_t)mpfr_get_prec(*b));
       mpfr_get_f(temp, *b, GMP_RNDN);
       mpq_set_f (*a, temp);
       mpf_clear(temp);
     }
#endif
}

SV * Rmpfr_sech(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sech(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_csch(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_csch(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_coth(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_coth(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_lngamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
#if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= LNGAMMA_BUG)
     if(!mpfr_nan_p(*b) && mpfr_sgn(*b) <= 0) {
       mpfr_set_inf(*a, 1);
       return newSViv(0);
     }
#endif
     return newSViv(mpfr_lngamma(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_lgamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     dXSARGS;
     int ret, signp;
     CHECK_ROUNDING_VALUE
     ret = mpfr_lgamma(*a, &signp, *b, (mpfr_rnd_t)SvUV(round));
     ST(0) = sv_2mortal(newSViv(signp));
     ST(1) = sv_2mortal(newSViv(ret));
     XSRETURN(2);
}

SV * _MPFR_VERSION(pTHX) {
#if defined(MPFR_VERSION)
     return newSVuv(MPFR_VERSION);
#else
     return &PL_sv_undef;
#endif
}

SV * _MPFR_VERSION_MAJOR(pTHX) {
     return newSVuv(MPFR_VERSION_MAJOR);
}

SV * _MPFR_VERSION_MINOR(pTHX) {
     return newSVuv(MPFR_VERSION_MINOR);
}

SV * _MPFR_VERSION_PATCHLEVEL(pTHX) {
     return newSVuv(MPFR_VERSION_PATCHLEVEL);
}

SV * _MPFR_VERSION_STRING(pTHX) {
     return newSVpv(MPFR_VERSION_STRING, 0);
}

SV * RMPFR_VERSION_NUM(pTHX_ SV * a, SV * b, SV * c) {
     return newSVuv(MPFR_VERSION_NUM((unsigned long)SvUV(a), (unsigned long)SvUV(b), (unsigned long)SvUV(c)));
}

SV * Rmpfr_sum(pTHX_ mpfr_t * rop, SV * avref, SV * len, SV * round) {
     mpfr_ptr *p;
     SV ** elem;
     int ret, i;
     unsigned long s = (unsigned long)SvUV(len);

     if(s > av_len((AV*)SvRV(avref)) + 1)croak("2nd last arg to Rmpfr_sum is greater than the size of the array");

     CHECK_ROUNDING_VALUE

     Newx(p, s, mpfr_ptr);
     if(p == NULL) croak("Unable to allocate memory in Rmpfr_sum");

     for(i = 0; i < s; ++i) {
        elem = av_fetch((AV*)SvRV(avref), i, 0);
        p[i] = *(INT2PTR(mpfr_t *, SvIVX(SvRV(*elem))));
     }

     ret = mpfr_sum(*rop, p, s, (mpfr_rnd_t)SvUV(round));

     Safefree(p);
     return newSViv(ret);
}

void _fr_to_q(mpq_t * q, mpfr_t * fr) {
   mpfr_exp_t exponent, denpow;
   char * str;
   size_t numlen;

   if(!mpfr_number_p(*fr)) {
     if(mpfr_nan_p(*fr))
       croak ("In Math::MPFR::_fr_to_q, cannot coerce a NaN to a Math::GMPq value");
     croak ("In Math::MPFR::_fr_to_q, cannot coerce an Inf to a Math::GMPq value");
   }

   str = mpfr_get_str(NULL, &exponent, 2, 0, *fr, GMP_RNDN);
   mpz_set_str(mpq_numref(*q), str, 2);
   mpz_set_ui (mpq_denref(*q), 1);
   mpfr_free_str(str);
   numlen = mpz_sizeinbase(mpq_numref(*q), 2);
   denpow = numlen - exponent;

   if(denpow < 0) {
     mpz_mul_2exp(mpq_numref(*q), mpq_numref(*q), -denpow);
   }
   else {
     mpz_mul_2exp(mpq_denref(*q), mpq_denref(*q), denpow);
   }

   mpq_canonicalize(*q);
}

int Rmpfr_q_div(mpfr_t * rop, mpq_t * q, mpfr_t * fr, int round) {
    mpq_t t;
    int ret;

    /* Handle Inf, NaN and zero values of *fr */
    if(!mpfr_regular_p(*fr)) {
      ret = mpfr_si_div(*rop, mpz_cmp_ui(mpq_numref(*q), 0), *fr, (mpfr_rnd_t)round);
      return ret;
    }

    mpq_init(t);

    _fr_to_q(&t, fr);
    mpq_div(t, *q, t);
    ret = mpfr_set_q(*rop, t, (mpfr_rnd_t)round);
    mpq_clear(t);
    return ret;
}

int Rmpfr_z_div(mpfr_t * rop, mpz_t * z, mpfr_t * fr, int round) {
    mpq_t t, tz;
    int ret;

    /* Handle Inf, NaN and zero values of *fr */
    if(!mpfr_regular_p(*fr)) {
      ret = mpfr_si_div(*rop, mpz_cmp_ui(*z, 0), *fr, (mpfr_rnd_t)round);
      return ret;
    }

    mpq_init(t);
    mpq_init(tz);
    mpq_set_z(tz, *z);

    _fr_to_q(&t, fr);
    mpq_div(t, tz, t);
    ret = mpfr_set_q(*rop, t, (mpfr_rnd_t)round);
    mpq_clear(t);
    mpq_clear(tz);
    return ret;
}

SV * overload_mul(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_mul function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_mul(aTHX_ *)");}

       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_mul_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_mul_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else
       mpfr_mul_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), (double)SvNVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_mul");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*mpfr_t_obj);
           mpfr_set_nanflag();
           return obj_ref;
         }

         mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_mul(aTHX_ *)");}

       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {

         mpfr_mul_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                 *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {

         mpfr_mul_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                 *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_mul");
}

SV * overload_add(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_add function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_add(aTHX_ +)");}

       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     DEAL_WITH_NANFLAG_BUG_OVERLOADED
     if(SvUOK(b)) {
       mpfr_add_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_add_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, GMP_RNDN);
       mpfr_add(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else
       mpfr_add_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), (double)SvNVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_add");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*mpfr_t_obj);
           mpfr_set_nanflag();
           return obj_ref;
         }

         mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_add(aTHX_ +)");}

       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                               *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))),
                               __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_add_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                 *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_add_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                 *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_add");
}

SV * overload_sub(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_sub function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_sub(aTHX_ -)");}

       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     DEAL_WITH_NANFLAG_BUG_OVERLOADED
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpfr_ui_sub(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes) mpfr_si_sub(*mpfr_t_obj, SvIVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, GMP_RNDN);
       if(third == &PL_sv_yes)
         mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else
         mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else

       if(third == &PL_sv_yes) mpfr_d_sub(*mpfr_t_obj, SvNVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvNVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_sub");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*mpfr_t_obj);
           mpfr_set_nanflag();
           return obj_ref;
         }

         mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_sub(aTHX_ -)");}

       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_sub_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                      *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_neg(*mpfr_t_obj, *mpfr_t_obj, GMP_RNDN);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_sub_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                      *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_neg(*mpfr_t_obj, *mpfr_t_obj, GMP_RNDN);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
         else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_sub function");
}

SV * overload_div(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_div function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_div(aTHX_ /)");}

       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpfr_ui_div(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes) mpfr_si_div(*mpfr_t_obj, SvIVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, GMP_RNDN);
       if(third == &PL_sv_yes)
         mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else
         mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else

       if(third == &PL_sv_yes) mpfr_d_div(*mpfr_t_obj, SvNVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvNVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_div");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*mpfr_t_obj);
           mpfr_set_nanflag();
           return obj_ref;
         }

         mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_div(aTHX_ /)");}

       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {

         if(third == &PL_sv_yes) {
           Rmpfr_z_div(mpfr_t_obj, INT2PTR(mpz_t * , SvIVX(SvRV(b))),
                                   INT2PTR(mpfr_t *, SvIVX(SvRV(a))),
                                   __gmpfr_default_rounding_mode);
         }
         else {
           mpfr_div_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                   *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                   __gmpfr_default_rounding_mode);
         }
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {

         if(third == &PL_sv_yes) {
           Rmpfr_q_div(mpfr_t_obj, INT2PTR(mpq_t * , SvIVX(SvRV(b))),
                                   INT2PTR(mpfr_t *, SvIVX(SvRV(a))),
                                   __gmpfr_default_rounding_mode);
         }
         else {
           mpfr_div_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                   *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                                   __gmpfr_default_rounding_mode);
         }
         return obj_ref;
       }

       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
         else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_div function");
}

SV * overload_copy(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_copy function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");

     mpfr_init2(*mpfr_t_obj, mpfr_get_prec(*p));
     mpfr_set(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_abs(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_abs function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_abs(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_gt(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_gt(aTHX_ >)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(NV_IS_FLOAT128)
       ret = Rmpfr_cmp_NV(aTHX_ a, b);
#elif defined(NV_IS_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_gt");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_gt(aTHX_ >)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_gt(aTHX_ >)");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return newSViv(0);
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
          return newSVuv(mpfr_greater_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
       }

       if(strEQ(h, "Math::GMPq")) {
         ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
         if(ret > 0) return newSViv(1);
         return newSViv(0);
       }

       if(strEQ(h, "Math::GMPz")) {
         ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
         if(ret > 0) return newSViv(1);
         return newSViv(0);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_gt");
}

SV * overload_gte(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_gte(aTHX_ >=)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(NV_IS_FLOAT128)

       ret = Rmpfr_cmp_NV(aTHX_ a, b);

#elif defined(NV_IS_LONG_DOUBLE)

       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_gte");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_gte(aTHX_ >=)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_gte(aTHX_ >=)");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return newSViv(0);
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSVuv(mpfr_greaterequal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
         }

       if(strEQ(h, "Math::GMPq")) {
         ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
         if(ret >= 0) return newSViv(1);
         return newSViv(0);
       }

       if(strEQ(h, "Math::GMPz")) {
         ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
         if(ret >= 0) return newSViv(1);
         return newSViv(0);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_gte");
}

SV * overload_lt(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_lt(aTHX_ <)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(NV_IS_FLOAT128)

       ret = Rmpfr_cmp_NV(aTHX_ a, b);

#elif defined(NV_IS_LONG_DOUBLE)

       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_lt");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_lt(aTHX_ <)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_lt(aTHX_ <)");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return newSViv(0);
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSVuv(mpfr_less_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
       }

       if(strEQ(h, "Math::GMPq")) {
         ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
         if(ret < 0) return newSViv(1);
         return newSViv(0);
       }

       if(strEQ(h, "Math::GMPz")) {
         ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
         if(ret < 0) return newSViv(1);
         return newSViv(0);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_lt");
}

SV * overload_lte(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_lte(aTHX_ <=)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(NV_IS_FLOAT128)

       ret = Rmpfr_cmp_NV(aTHX_ a, b);

#elif defined(NV_IS_LONG_DOUBLE)

       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_lte(aTHX_ <=)");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_lte(aTHX_ <=)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_lte(aTHX_ <=)");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return newSViv(0);
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR"))
         return newSVuv(mpfr_lessequal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));

       if(strEQ(h, "Math::GMPq")) {
         ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
         if(ret <= 0) return newSViv(1);
         return newSViv(0);
       }

       if(strEQ(h, "Math::GMPz")) {
         ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
         if(ret <= 0) return newSViv(1);
         return newSViv(0);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_lte");
}

SV * overload_spaceship(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)) {
       mpfr_set_erangeflag();
       return &PL_sv_undef;
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_spaceship(aTHX_ <=>)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
       mpfr_set_erangeflag();
       return &PL_sv_undef;
     }

#if defined(NV_IS_FLOAT128)

       ret = Rmpfr_cmp_NV(aTHX_ a, b);

#elif defined(NV_IS_LONG_DOUBLE)

       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_spaceship");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return &PL_sv_undef;
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_spaceship(aTHX_ <=>)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return &PL_sv_undef;
         }
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_spaceship(aTHX_ <=>");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return &PL_sv_undef;
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSViv(mpfr_cmp(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
       }

       if(strEQ(h, "Math::GMPq")) {
         return newSViv(mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b))))));
       }

       if(strEQ(h, "Math::GMPz")) {
         return newSViv(mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b))))));
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_spaceship");
}

SV * overload_equiv(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret =  mpfr_init_set_str(t, (char *)SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_equiv(aTHX_ ==)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(NV_IS_FLOAT128)

       ret = Rmpfr_cmp_NV(aTHX_ a, b);

#elif defined(NV_IS_LONG_DOUBLE)

       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif

       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_equiv");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_equiv(aTHX_ ==)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return newSViv(0);
         }
       }
#else
       ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_equiv(aTHX_ ==)");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return newSViv(0);
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSVuv(mpfr_equal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
       }

       if(strEQ(h, "Math::GMPq")) {
         if(mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))))) return newSViv(0);
         return newSViv(1);
       }

       if(strEQ(h, "Math::GMPz")) {
         if(mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))))) return newSViv(0);
         return newSViv(1);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_equiv");
}

SV * overload_not_equiv(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(1);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_not_equiv(aTHX_ !=)");}

       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUVX(b));
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIVX(b));
       if(ret != 0) return newSViv(1);
       return newSViv(0);
   }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

       if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(1);
       }

#if defined(NV_IS_FLOAT128)

       ret = Rmpfr_cmp_NV(aTHX_ a, b);

#elif defined(NV_IS_LONG_DOUBLE)

       ret = mpfr_cmp_ld(*a, (long double)SvNVX(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNVX(b));
#endif

       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_not_equiv");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_init(t);
           mpfr_set_inf(t, inf_or_nan);
         }
         else { /* it's a NaN */
           mpfr_set_erangeflag();
           return newSViv(1);
         }
       }
       else {
         ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

         NON_NUMERIC_CHAR_CHECK, "overload_not_equiv(aTHX_ !=)");}

         if(mpfr_nan_p(t)) {
           mpfr_clear(t);
           mpfr_set_erangeflag();
           return newSViv(1);
         }
       }
#else
       ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_not_equiv(aTHX_ !=)");}

       if(mpfr_nan_p(t)) {
         mpfr_clear(t);
         mpfr_set_erangeflag();
         return newSViv(1);
       }
#endif
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
       }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         if(mpfr_equal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))))) return newSViv(0);
         return newSViv(1);
       }

       if(strEQ(h, "Math::GMPq")) {
         if(mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))))) return newSViv(1);
         return newSViv(0);
       }

       if(strEQ(h, "Math::GMPz")) {
         if(mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))))) return newSViv(1);
         return newSViv(0);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_not_equiv");
}

SV * overload_true(pTHX_ mpfr_t *a, SV *b, SV * third) {
     if(mpfr_nan_p(*a)) return newSVuv(0);
     if(mpfr_cmp_ui(*a, 0)) return newSVuv(1);
     return newSVuv(0);
}

SV * overload_not(pTHX_ mpfr_t * a, SV * b, SV * third) {
     if(mpfr_nan_p(*a)) return newSViv(1);
     if(mpfr_cmp_ui(*a, 0)) return newSViv(0);
     return newSViv(1);
}

SV * overload_sqrt(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_sqrt function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     /* No - this was wrong. If a negative value is supplied, a NaN should be returned instad */
     /* if(mpfr_cmp_ui(*p, 0) < 0) croak("Negative value supplied as argument to overload_sqrt"); */

     mpfr_sqrt(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_pow(pTHX_ SV * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_pow function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_pow(aTHX_ **)");}

       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpfr_ui_pow(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       /* Need to do it this way as there's no mpfr_si_pow function */
       if(SvIV(b) >= 0) {
         if(third == &PL_sv_yes) mpfr_ui_pow(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
         else mpfr_pow_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(third != &PL_sv_yes) {
         mpfr_pow_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvIV(b), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) {

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);

#endif

       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_pow");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(*mpfr_t_obj);
           mpfr_set_nanflag();
           return obj_ref;
         }

         mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_pow(aTHX_ **)");}

       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         if(third == &PL_sv_yes) {
           mpfr_init2(t, (mpfr_prec_t)mpz_sizeinbase(*(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), 2));
           mpfr_set_z(t, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
           mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
           mpfr_clear(t);
         }
         else mpfr_pow_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p     )))),
                                      *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_set_q(*mpfr_t_obj, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
         else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
         else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_pow.");
}

SV * overload_log(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_log function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_log(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_exp(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_exp function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_exp(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_sin(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_sin function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_sin(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_cos(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_cos function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_cos(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_int(pTHX_ mpfr_t * p, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_int function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_trunc(*mpfr_t_obj, *p);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_atan2(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
#ifdef _WIN32_BIZARRE_INFNAN
     int ret, inf_or_nan;
#else
     int ret;
#endif

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_atan2 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       mpfr_clear(t);
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_atan2");}

       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, *mpfr_t_obj, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, *mpfr_t_obj, __gmpfr_default_rounding_mode);
       }
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_init2(t, 8 * sizeof(long));
       mpfr_set_ui(t, SvUVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, 8 * sizeof(long));
       mpfr_set_si(t, SvIVX(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif

       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_atan2");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       if(inf_or_nan) {
         if(inf_or_nan != 2) {
           mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
         }
         /* else we want *mpfr_t_obj to be a NaN ... which it already is !! :-) */
       }
       else {
         ret = mpfr_init_set_str(*mpfr_t_obj, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif

       NON_NUMERIC_CHAR_CHECK, "overload_atan2");}

       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, *mpfr_t_obj, *a, __gmpfr_default_rounding_mode);
         }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, *mpfr_t_obj, __gmpfr_default_rounding_mode);
         }
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_atan2(*mpfr_t_obj, *a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
         SvREADONLY_on(obj);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_atan2 function");
}

/* Finish typemapping */

SV * Rmpfr_randinit_default_nobless(pTHX) {
     gmp_randstate_t * state;
     SV * obj_ref, * obj;

     Newx(state, 1, gmp_randstate_t);
     if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_default function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     gmp_randinit_default(*state);

     sv_setiv(obj, INT2PTR(IV,state));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_randinit_mt_nobless(pTHX) {
     gmp_randstate_t * rand_obj;
     SV * obj_ref, * obj;

     Newx(rand_obj, 1, gmp_randstate_t);
     if(rand_obj == NULL) croak("Failed to allocate memory in Math::GMPz::Random::Rmpfr_randinit_mt function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     gmp_randinit_mt(*rand_obj);

     sv_setiv(obj, INT2PTR(IV, rand_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_randinit_lc_2exp_nobless(pTHX_ SV * a, SV * c, SV * m2exp ) {
     gmp_randstate_t * state;
     mpz_t aa;
     SV * obj_ref, * obj;

     Newx(state, 1, gmp_randstate_t);
     if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_lc_2exp function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     if(sv_isobject(a)) {
       const char* h = HvNAME(SvSTASH(SvRV(a)));

       if(strEQ(h, "Math::GMP") ||
          strEQ(h, "GMP::Mpz")  ||
          strEQ(h, "Math::GMPz"))
            gmp_randinit_lc_2exp(*state, *(INT2PTR(mpz_t *, SvIVX(SvRV(a)))), (unsigned long)SvUV(c), (unsigned long)SvUV(m2exp));
       else croak("First arg to Rmpfr_randinit_lc_2exp is of invalid type");
     }

     else {
       if(!mpz_init_set_str(aa, SvPV_nolen(a), 0)) {
         gmp_randinit_lc_2exp(*state, aa, (unsigned long)SvUV(c), (unsigned long)SvUV(m2exp));
         mpz_clear(aa);
       }
       else croak("Seedstring supplied to Rmpfr_randinit_lc_2exp is not a valid number");
     }

     sv_setiv(obj, INT2PTR(IV,state));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_randinit_lc_2exp_size_nobless(pTHX_ SV * size) {
     gmp_randstate_t * state;
     SV * obj_ref, * obj;

     if(SvUV(size) > 128) croak("The argument supplied to Rmpfr_randinit_lc_2exp_size_nobless function is too large - ie greater than 128");

     Newx(state, 1, gmp_randstate_t);
     if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_lc_2exp_size_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);

     if(gmp_randinit_lc_2exp_size(*state, (unsigned long)SvUV(size))) {
       sv_setiv(obj, INT2PTR(IV,state));
       SvREADONLY_on(obj);
       return obj_ref;
       }

     croak("Rmpfr_randinit_lc_2exp_size_nobless function failed");
}

void Rmpfr_randclear(pTHX_ SV * p) {
     gmp_randclear(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(p)))));
     Safefree(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(p))));
}

void Rmpfr_randseed(pTHX_ SV * state, SV * seed) {
     mpz_t s;

     if(sv_isobject(seed)) {
       const char* h = HvNAME(SvSTASH(SvRV(seed)));

       if(strEQ(h, "Math::GMP") ||
          strEQ(h, "GMP::Mpz") ||
          strEQ(h, "Math::GMPz"))
            gmp_randseed(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(state)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(seed)))));
       else croak("2nd arg to Rmpfr_randseed is of invalid type");
     }

     else {
       if(!mpz_init_set_str(s, SvPV_nolen(seed), 0)) {
         gmp_randseed(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(state)))), s);
         mpz_clear(s);
       }
       else croak("Seedstring supplied to Rmpfr_randseed is not a valid number");
     }
}

void Rmpfr_randseed_ui(pTHX_ SV * state, SV * seed) {
     gmp_randseed_ui(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(state)))), (unsigned long)SvUV(seed));
}

SV * overload_pow_eq(pTHX_ SV * p, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     SvREFCNT_inc(p);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_pow_eq(aTHX_ **=)");}

       mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_pow_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return p;
     }

     if(SvIOK(b)) {
       /*
       if(SvIV(b) >= 0) {
         mpfr_pow_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
         return p;
       }
       */
       mpfr_pow_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return p;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) {

#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif

       mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_pow_eq");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       mpfr_init(t);
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(t);
         }

         else mpfr_set_inf(t, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_pow_eq(aTHX_ **=)");}

       mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return p;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_pow_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return p;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return p;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_init(t);
         mpfr_set_q(t, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return p;
       }
     }

     SvREFCNT_dec(p);
     croak("Invalid argument supplied to Math::MPFR::overload_pow_eq.");
}

SV * overload_div_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_div_eq(aTHX_ /=)");}

       mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_div_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, __gmpfr_default_rounding_mode);
       mpfr_neg(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif

       mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_div_eq");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       mpfr_init(t);
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(t);
         }

         else mpfr_set_inf(t, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_div_eq(aTHX_ /=)");}

       mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_div_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_div_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_div_eq function");
}

SV * overload_sub_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_sub_eq(aTHX_ -=)");}

       mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     DEAL_WITH_NANFLAG_BUG_OVERLOADED
     if(SvUOK(b)) {
       mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_sub_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_init_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);

#endif

       mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_sub_eq");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       mpfr_init(t);
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(t);
         }

         else mpfr_set_inf(t, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_sub_eq(aTHX_ -=)");}

       mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_sub_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_sub_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_sub_eq function");
}

SV * overload_add_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_add_eq(aTHX_ +=)");}

       mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     DEAL_WITH_NANFLAG_BUG_OVERLOADED
     if(SvUOK(b)) {
       mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_add_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);

#endif

       mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_add_eq(aTHX_ +=)");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       mpfr_init(t);
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(t);
         }

         else mpfr_set_inf(t, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_add_eq(aTHX_ +=)");}

       mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_add_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_add_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_add_eq");
}

SV * overload_mul_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;
#ifdef _WIN32_BIZARRE_INFNAN
     int inf_or_nan;
#endif

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);

       NON_NUMERIC_CHAR_CHECK, "overload_mul_eq(aTHX_ *=)");}

       mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_mul_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, __gmpfr_default_rounding_mode);
       mpfr_neg(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */

#if defined(NV_IS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);

#elif defined(NV_IS_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_init_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);

#endif

       mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "overload_mul_eq");}

#ifdef _WIN32_BIZARRE_INFNAN
       inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
       mpfr_init(t);
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           mpfr_set_nan(t);
         }

         else mpfr_set_inf(t, inf_or_nan);
       }
       else {
         ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       }
#else
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

#endif

       NON_NUMERIC_CHAR_CHECK, "overload_mul_eq(aTHX_ *=)");}

       mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_mul_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_mul_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_mul_eq");
}

SV * _itsa(pTHX_ SV * a) {
     if(SvUOK(a)) return newSVuv(1);
     if(SvIOK(a)) return newSVuv(2);
     if(SvNOK(a) && !SvPOK(a)) return newSVuv(3);
     if(SvPOK(a)) return newSVuv(4);
     if(sv_isobject(a)) {
       const char* h = HvNAME(SvSTASH(SvRV(a)));

       if(strEQ(h, "Math::MPFR")) return newSVuv(5);
       if(strEQ(h, "Math::GMPf")) return newSVuv(6);
       if(strEQ(h, "Math::GMPq")) return newSVuv(7);
       if(strEQ(h, "Math::GMPz")) return newSVuv(8);
       if(strEQ(h, "Math::GMP")) return newSVuv(9);        }
     return newSVuv(0);
}

int _has_longlong(void) {
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
    return 1;
#else
    return 0;
#endif
}

int _has_longdouble(void) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
    return 1;
#else
    return 0;
#endif
}

int _ivsize_bits(void) {
   int ret = 0;
#ifdef IVSIZE_BITS
   ret = IVSIZE_BITS;
#endif
   return ret;
}

/*
int _mpfr_longsize(void) {
    mpfr_t x, y;

    mpfr_init2(x, 100);
    mpfr_init2(y, 100);

    mpfr_set_str(x, "18446744073709551615", 10, GMP_RNDN);
    mpfr_set_ui(y, 18446744073709551615, GMP_RNDN);

    if(!mpfr_cmp(x,y)) return 64;
    return 32;
}
*/

SV * RMPFR_PREC_MAX(pTHX) {
     return newSViv(MPFR_PREC_MAX);
}

SV * RMPFR_PREC_MIN(pTHX) {
     return newSViv(MPFR_PREC_MIN);
}

SV * wrap_mpfr_printf(pTHX_ SV * a, SV * b) {
     int ret;
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")){
         ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         fflush(stdout);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")){
         ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
         fflush(stdout);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_printf");
     }

     if(SvUOK(b)) {
       ret = mpfr_printf(SvPV_nolen(a), SvUVX(b));
       fflush(stdout);
       return newSViv(ret);
     }
     if(SvIOK(b)) {
       ret = mpfr_printf(SvPV_nolen(a), SvIVX(b));
       fflush(stdout);
       return newSViv(ret);
     }
     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
       ret = mpfr_printf(SvPV_nolen(a), SvNVX(b));
       fflush(stdout);
       return newSViv(ret);
     }
     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "wrap_mpfr_printf");}

       ret = mpfr_printf(SvPV_nolen(a), SvPV_nolen(b));
       fflush(stdout);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_printf");
}

SV * wrap_mpfr_fprintf(pTHX_ FILE * stream, SV * a, SV * b) {
     int ret;
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         fflush(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
         fflush(stream);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_fprintf");
     }

     if(SvUOK(b)) {
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvUVX(b));
       fflush(stream);
       return newSViv(ret);
     }
     if(SvIOK(b)) {
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvIVX(b));
       fflush(stream);
       return newSViv(ret);
     }
     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvNVX(b));
       fflush(stream);
       return newSViv(ret);
     }
     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "wrap_mpfr_fprintf");}

       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvPV_nolen(b));
       fflush(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_fprintf");
}

SV * wrap_mpfr_sprintf(pTHX_ SV * s, SV * a, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_sprintf");
     }

     if(SvUOK(b)) {
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvUVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvIOK(b)) {
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvIVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvNVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "wrap_mpfr_sprintf");}

       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvPV_nolen(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_sprintf");
}

SV * wrap_mpfr_snprintf(pTHX_ SV * s, SV * bytes, SV * a, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_snprintf");
     }

     if(SvUOK(b)) {
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvUVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvIOK(b)) {
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvIVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvNVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "wrap_mpfr_snprintf");}

       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvPV_nolen(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_snprintf");
}

SV * wrap_mpfr_printf_rnd(pTHX_ SV * a, SV * round, SV * b) {
     int ret;
     if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 2nd argument (rounding value) of %u passed to Rmpfr_printf", (mpfr_rnd_t)SvUV(round));
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")){
         ret = mpfr_printf(SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         fflush(stdout);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")){
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_printf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_printf");
     }

     croak("In Rmpfr_printf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_fprintf_rnd(pTHX_ FILE * stream, SV * a, SV * round, SV * b) {
     int ret;
     if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_fprintf", (mpfr_rnd_t)SvUV(round));
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_fprintf(stream, SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         fflush(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_fprintf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_fprintf");
     }

     croak("In Rmpfr_fprintf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_sprintf_rnd(pTHX_ SV * s, SV * a, SV * round, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_sprintf", (mpfr_rnd_t)SvUV(round));

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_sprintf(stream, SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_sprintf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_sprintf");
     }

     croak("In Rmpfr_sprintf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_snprintf_rnd(pTHX_ SV * s, SV * bytes, SV * a, SV * round, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_snprintf", (mpfr_rnd_t)SvUV(round));

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_snprintf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_snprintf");
     }

     croak("In Rmpfr_snprintf: The rounding argument is specific to Math::MPFR objects");
}



SV * Rmpfr_buildopt_tls_p(pTHX) {
     return newSViv(mpfr_buildopt_tls_p());
}

SV * Rmpfr_buildopt_decimal_p(pTHX) {
     return newSViv(mpfr_buildopt_decimal_p());
}

SV * Rmpfr_regular_p(pTHX_ mpfr_t * a) {
     return newSViv(mpfr_regular_p(*a));
}

void Rmpfr_set_zero(pTHX_ mpfr_t * a, SV * sign) {
     mpfr_set_zero(*a, (int)SvIV(sign));
}

SV * Rmpfr_digamma(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
     return newSViv(mpfr_digamma(*rop, *op, (mpfr_rnd_t)SvIV(round)));
}

SV * Rmpfr_ai(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
     return newSViv(mpfr_ai(*rop, *op, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_flt(pTHX_ mpfr_t * a, SV * round) {
     return newSVnv(mpfr_get_flt(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_flt(pTHX_ mpfr_t * rop, SV * f, SV * round) {
     return newSViv(mpfr_set_flt(*rop, (float)SvNV(f), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_urandom(pTHX_ mpfr_t * rop, gmp_randstate_t* state, SV * round) {
     return newSViv(mpfr_urandom(*rop, *state, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_z_2exp(pTHX_ mpfr_t * rop, mpz_t * op, SV * exp, SV * round) {
     return newSViv(mpfr_set_z_2exp(*rop, *op, (mpfr_exp_t)SvIV(exp), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_buildopt_tune_case(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSVpv(mpfr_buildopt_tune_case(), 0);
#else
     croak("Rmpfr_buildopt_tune_case not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_frexp(pTHX_ SV * exp, mpfr_t * rop, mpfr_t * op, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     mpfr_exp_t _exp;
     int ret;

     ret = mpfr_frexp(&_exp, *rop, *op, (mpfr_rnd_t)SvUV(round));
     sv_setiv(exp, _exp);
     return newSViv(ret);
#else
     croak("Rmpfr_frexp not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_z_sub(pTHX_ mpfr_t * rop, mpz_t * op1, mpfr_t * op2, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_z_sub(*rop, *op1, *op2, (mpfr_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_z_sub not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_grandom(pTHX_ mpfr_t * rop1, mpfr_t * rop2, gmp_randstate_t * state, SV * round) {
#if MPFR_VERSION_MAJOR >= 4
     warn("Rmpfr_grandom is deprecated - use Rmpfr_nrandom instead");
#endif
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_grandom(*rop1, *rop2, *state, (mpfr_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_grandom not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_clear_divby0(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     mpfr_clear_divby0();
#else
     croak("Rmpfr_clear_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_set_divby0(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     mpfr_set_divby0();
#else
     croak("Rmpfr_set_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_divby0_p(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_divby0_p());
#else
     croak("Rmpfr_divby0_p not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_gmpinternals_p(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_buildopt_gmpinternals_p());
#else
     croak("Rmpfr_buildopt_gmpinternals_p not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * _get_xs_version(pTHX) {
     return newSVpv(XS_VERSION, 0);
}

SV * overload_inc(pTHX_ SV * a, SV * b, SV * third) {
     DEAL_WITH_NANFLAG_BUG_OVERLOADED
     SvREFCNT_inc(a);
     mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), 1, __gmpfr_default_rounding_mode);
     return a;
}

SV * overload_dec(pTHX_ SV * p, SV * b, SV * third) {
     SvREFCNT_inc(p);
     mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), 1, __gmpfr_default_rounding_mode);
     return p;
}

SV * _wrap_count(pTHX) {
     return newSVuv(PL_sv_count);
}

SV * Rmpfr_set_LD(pTHX_ mpfr_t * rop, SV * op, SV *rnd) {
     if(sv_isobject(op)) {
       const char* h = HvNAME(SvSTASH(SvRV(op)));

       if(strEQ(h, "Math::LongDouble")) {
         return newSViv(mpfr_set_ld(*rop, *(INT2PTR(long double *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
       }
       croak("2nd arg (a %s object) supplied to Rmpfr_set_LD needs to be a Math::LongDouble object",
              HvNAME(SvSTASH(SvRV(op))));
     }
     else croak("2nd arg (which needs to be a Math::LongDouble object) supplied to Rmpfr_set_LD is not an object");
}

/*
int mpfr_set_decimal64 (mpfr_t rop, _Decimal64 op, mpfr_rnd_t rnd)
*/

SV * Rmpfr_set_DECIMAL64(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(3,1,0)))
     croak("Perl interface to Rmpfr_set_DECIMAL64 not available for this version (%s) of the mpfr library. We need at least version 3.1.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL164 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL64)
    if(sv_isobject(op)) {
      const char* h = HvNAME(SvSTASH(SvRV(op)));

      if(strEQ(h, "Math::Decimal64"))
        return newSViv(mpfr_set_decimal64(*rop, *(INT2PTR(_Decimal64 *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
       croak("2nd arg (a %s object) supplied to Rmpfr_set_DECIMAL64 needs to be a Math::Decimal64 object",
               HvNAME(SvSTASH(SvRV(op))));
    }
    else croak("2nd arg (which needs to be a Math::Decimal64 object) supplied to Rmpfr_set_DECIMAL64 is not an object");

#else

#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(3,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_set_DECIMAL64 available, rebuild Math::MPFR and pass \"D64=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#endif

    croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL64 need to have been defined when building Math::MPFR - see \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");

#endif
}

/**********************************************
 **********************************************/


SV * Rmpfr_set_DECIMAL128(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(4,1,0)))
     croak("Perl interface to Rmpfr_set_DECIMAL128 not available for this version (%s) of the mpfr library. We need at least version 4.1.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL1128 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL128)
    if(sv_isobject(op)) {
      const char* h = HvNAME(SvSTASH(SvRV(op)));

      if(strEQ(h, "Math::Decimal128"))
        return newSViv(mpfr_set_decimal128(*rop, *(INT2PTR(D128 *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
       croak("2nd arg (a %s object) supplied to Rmpfr_set_DECIMAL128 needs to be a Math::Decimal128 object",
               HvNAME(SvSTASH(SvRV(op))));
    }
    else croak("2nd arg (which needs to be a Math::Decimal128 object) supplied to Rmpfr_set_DECIMAL128 is not an object");

#else

#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_set_DECIMAL128 available, rebuild Math::MPFR and pass \"D128=1\"  as separate args to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#endif

    croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL128 need to have been defined when building Math::MPFR");

#endif
}



/**********************************************
 **********************************************/

void Rmpfr_get_LD(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
     if(sv_isobject(rop)) {
       const char* h = HvNAME(SvSTASH(SvRV(rop)));

       if(strEQ(h, "Math::LongDouble")) {
         *(INT2PTR(long double *, SvIVX(SvRV(rop)))) = mpfr_get_ld(*op, (mpfr_rnd_t)SvUV(rnd));
       }
       else croak("1st arg (a %s object) supplied to Rmpfr_get_LD needs to be a Math::LongDouble object",
                  HvNAME(SvSTASH(SvRV(rop))));
     }
     else croak("1st arg (which needs to be a Math::LongDouble object) supplied to Rmpfr_get_LD is not an object");
}

/**********************************************
 **********************************************/

void Rmpfr_get_DECIMAL64(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(3,1,0)))
     croak("Perl interface to Rmpfr_get_DECIMAL64 not available for this version (%s) of the mpfr library. We need at least version 3.1.0",
              MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL164 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL64)
    if(sv_isobject(rop)) {
      const char* h = HvNAME(SvSTASH(SvRV(rop)));

      if(strEQ(h, "Math::Decimal64"))
        *(INT2PTR(_Decimal64 *, SvIVX(SvRV(rop)))) = mpfr_get_decimal64(*op, (mp_rnd_t)SvUV(rnd));

       else croak("1st arg (a %s object) supplied to Rmpfr_get_DECIMAL64 needs to be a Math::Decimal64 object",
                      HvNAME(SvSTASH(SvRV(rop))));
    }
    else croak("1st arg (which needs to be a Math::Decimal64 object) supplied to Rmpfr_get_DECIMAL64 is not an object");

#else

#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(3,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_get_DECIMAL64 available, rebuild Math::MPFR and pass \"D64=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#endif

    croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL64 need to have been defined when building Math::MPFR");

#endif
}

/**********************************************
 **********************************************/

void Rmpfr_get_DECIMAL128(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(4,1,0)))
     croak("Perl interface to Rmpfr_get_DECIMAL128 not available for this version (%s) of the mpfr library. We need at least version 4.1.0",
              MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL1128 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL128)
    if(sv_isobject(rop)) {
      const char* h = HvNAME(SvSTASH(SvRV(rop)));

      if(strEQ(h, "Math::Decimal128"))
        *(INT2PTR(D128 *, SvIVX(SvRV(rop)))) = mpfr_get_decimal128(*op, (mp_rnd_t)SvUV(rnd));

       else croak("1st arg (a %s object) supplied to Rmpfr_get_DECIMAL128 needs to be a Math::Decimal128 object",
                      HvNAME(SvSTASH(SvRV(rop))));
    }
    else croak("1st arg (which needs to be a Math::Decimal128 object) supplied to Rmpfr_get_DECIMAL128 is not an object");

#else

#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_get_DECIMAL128 available, rebuild Math::MPFR and pass \"D128=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#endif

    croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL128 need to have been defined when building Math::MPFR");

#endif
}


/**********************************************
 **********************************************/

int _MPFR_WANT_DECIMAL_FLOATS(void) {
#ifdef MPFR_WANT_DECIMAL_FLOATS
 return 1;
#else
 return 0;
#endif
}

int _MPFR_WANT_DECIMAL64(void) {
#ifdef MPFR_WANT_DECIMAL64
 return 1;
#else
 return 0;
#endif
}

int _MPFR_WANT_DECIMAL128(void) {
#ifdef MPFR_WANT_DECIMAL128
 return 1;
#else
 return 0;
#endif
}

int _MPFR_WANT_FLOAT128(void) {
#ifdef MPFR_WANT_FLOAT128
 return 1;
#else
 return 0;
#endif
}

SV * _max_base(pTHX) {
     return newSViv(MAXIMUM_ALLOWABLE_BASE);
}

SV * _isobject(pTHX_ SV * x) {
    if(sv_isobject(x))return newSVuv(1);
    return newSVuv(0);
}

void _mp_sizes(void) {
     dTHX;
     dXSARGS;
     XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_exp_t))));
     XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_prec_t))));
     XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_rnd_t))));

     XSRETURN(3);
}

SV * _ivsize(pTHX) {
     return newSVuv(sizeof(IV));
}

SV * _nvsize(pTHX) {
     return newSVuv(sizeof(NV));
}

SV * _FLT128_DIG(pTHX) {
#ifdef FLT128_DIG
     return newSViv(FLT128_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _LDBL_DIG(pTHX) {
#ifdef LDBL_DIG
     return newSViv(LDBL_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _DBL_DIG(pTHX) {
#ifdef DBL_DIG
     return newSViv(DBL_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _FLT128_MANT_DIG(pTHX) {
#ifdef FLT128_MANT_DIG
     return newSViv(FLT128_MANT_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _LDBL_MANT_DIG(pTHX) {
#ifdef LDBL_MANT_DIG
     return newSViv(LDBL_MANT_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _DBL_MANT_DIG(pTHX) {
#ifdef DBL_MANT_DIG
     return newSViv(DBL_MANT_DIG);
#else
     return &PL_sv_undef;
#endif
}


/*///////////////////////////////////////////
////////////////////////////////////////////*/
/* All randinit functions now moved to Math::MPFR::Random */
/*

*/
/***********************************************
************************************************/

SV * Rmpfr_get_float128(pTHX_ mpfr_t * op, SV * rnd) {

#ifdef CAN_PASS_FLOAT128
     return newSVnv(mpfr_get_float128(*op, (mpfr_rnd_t)SvUV(rnd)));
#else
#if MPFR_VERSION_MAJOR >= 4
     if(mpfr_buildopt_float128_p()) {
       warn("To make Rmpfr_get_float128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
       croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
     }
#endif
     croak("Cannot use Rmpfr_get_float128 to return an NV - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

void Rmpfr_get_FLOAT128(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION < MPFR_VERSION_NUM(4,0,0)))
     croak("Perl interface to Rmpfr_get_FLOAT128 not available for this version (%s) of the mpfr library. We need at least version 4.0.0",
              MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_FLOAT128 needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_FLOAT128

    if(sv_isobject(rop)) {
      const char* h = HvNAME(SvSTASH(SvRV(rop)));

      if(strEQ(h, "Math::Float128"))
        *(INT2PTR(float128 *, SvIVX(SvRV(rop)))) = mpfr_get_float128(*op, (mpfr_rnd_t)SvUV(rnd));
      else croak("1st arg (a %s object) supplied to Rmpfr_get_FLOAT128 needs to be a Math::Float128 object",
                      HvNAME(SvSTASH(SvRV(rop))));
    }
    else croak("1st arg (which needs to be a Math::Float128 object) supplied to Rmpfr_get_FLOAT128 is not an object");

#else
#if MPFR_VERSION_MAJOR >= 4
     if(mpfr_buildopt_float128_p()) {
       warn("To make Rmpfr_get_FLOAT128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
       croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
     }
#endif
    croak("MPFR_WANT_FLOAT128 needs to have been defined when building Math::MPFR - - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");

#endif
}

SV * Rmpfr_set_FLOAT128(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION < MPFR_VERSION_NUM(4,0,0)))
     croak("Perl interface to Rmpfr_set_FLOAT128 not available for this version (%s) of the mpfr library. We need at least version 4.0.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_FLOAT128 needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_FLOAT128
    if(sv_isobject(op)) {
      const char* h = HvNAME(SvSTASH(SvRV(op)));

      if(strEQ(h, "Math::Float128"))
        return newSViv(mpfr_set_float128(*rop, *(INT2PTR(float128 *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
       croak("2nd arg (a %s object) supplied to Rmpfr_set_FLOAT128 needs to be a Math::Float128 object",
               HvNAME(SvSTASH(SvRV(op))));
    }
    else croak("2nd arg (which needs to be a Math::Float128 object) supplied to Rmpfr_set_FLOAT128 is not an object");

#else
#if MPFR_VERSION_MAJOR >= 4
     if(mpfr_buildopt_float128_p()) {
       warn("To make Rmpfr_set_FLOAT128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
       croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
     }
#endif
    croak("MPFR_WANT_FLOAT128 needs to have been defined when building Math::MPFR - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");

#endif
}

SV * Rmpfr_set_float128(pTHX_ mpfr_t * rop, SV * q, SV * rnd) {

#ifdef CAN_PASS_FLOAT128
     return newSViv(mpfr_set_float128(*rop, (float128)SvNV(q), (mpfr_rnd_t)SvUV(rnd)));
#else
#if MPFR_VERSION_MAJOR >= 4
     if(mpfr_buildopt_float128_p()) {
       warn("To make Rmpfr_set_float128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
       croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
     }
#endif
     croak("Cannot use Rmpfr_set_float128 to set an NV - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif

}

SV * _is_readonly(pTHX_ SV * sv) {
     if SvREADONLY(sv) return newSVuv(1);
     return newSVuv(0);
}

void _readonly_on(pTHX_ SV * sv) {
     SvREADONLY_on(sv);
}

void _readonly_off(pTHX_ SV * sv) {
     SvREADONLY_off(sv);
}

/* Do not remove _can_pass_float128 - it's used by the Math::MPFI Makefile.PL */

int _can_pass_float128(void) {

#ifdef CAN_PASS_FLOAT128
   return 1;
#else
   return 0;
#endif

}

int _mpfr_want_float128(void) {

#ifdef MPFR_WANT_FLOAT128
   return 1;
#else
   return 0;
#endif

}

int nnumflag(void) {
  return nnum;
}

int nok_pokflag(void) {
  return nok_pok;
}

void clear_nnum(void) {
  nnum = 0;
}

void clear_nok_pok(void){
  nok_pok = 0;
}

void set_nnum(int x) {
  nnum = x;
}

void set_nok_pok(int x) {
  nok_pok = x;
}

void _d_bytes(pTHX_ SV * str, unsigned int bits) {

 /* Assumes 64-bit double (53-bit precision mantissa) */
 /* Corrected to handle subnormal values in 4.02 */

  dXSARGS;
  mpfr_t temp, temp2, DENORM_MIN;
  double ld;
  int i, n = 8, inex, signbit;
  char buff[4];
  void * p = &ld;
  mpfr_prec_t emin, emax, prec;

  if(bits != 53)
    croak("2nd arg to Math::MPFR::_d_bytes must be 53");

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_d_bytes is not a string");

  if((size_t)bits != DBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_d_bytes does not match DBL_MANT_DIG (%u)", bits, DBL_MANT_DIG);

  mpfr_init2(temp, 53);

#if defined(MPFR_VERSION) && MPFR_VERSION > 196869 /* use mpfr_subnormalize */
  emin = mpfr_get_emin();
  emax = mpfr_get_emax();

  mpfr_set_emin(-1073);
  mpfr_set_emax(1024);

  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
  mpfr_subnormalize(temp, inex, GMP_RNDN);

  mpfr_set_emin(emin);
  mpfr_set_emax(emax);

  ld = mpfr_get_d(temp, GMP_RNDN);

#else     /* mpfr_strtofr can return incorrect inex in 3.1.5 and  *
           * earlier - which renders mpfr_subnormalize unreliable */

  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);

  emin = mpfr_get_exp(temp) + 1074;
  signbit = mpfr_signbit(temp) ? -1 : 1;

  if(emin <= 1) {
    if(emin < 0) {
      ld = 0.0 *signbit;
    }
    else {
      if(emin == 0) {
        mpfr_init2(temp2, 2);
        mpfr_set_ui(temp2, 2, GMP_RNDN);
        mpfr_div_2ui(temp2, temp2, 1076, GMP_RNDN);
        mpfr_abs(temp, temp, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) > 0) {
          mpfr_mul_2ui(temp2, temp2, 1, GMP_RNDN);
          ld = mpfr_get_d(temp2, GMP_RNDN);
          mpfr_clear(temp2);
        }
        else {
          ld = 0.0;
        }
        ld *= signbit;
      }
      else {  /* emin == 1 *//* Can't set precision to 1 with older versions of mpfr */

        mpfr_abs(temp, temp, GMP_RNDN);
        mpfr_init2(temp2, 2);
        mpfr_init2(DENORM_MIN, 2);
        mpfr_set_ui(DENORM_MIN, 2, GMP_RNDN);
        mpfr_div_2ui(DENORM_MIN, DENORM_MIN, 1075, GMP_RNDN);
        mpfr_set(temp2, DENORM_MIN, GMP_RNDN);
        mpfr_div_ui(temp2, temp2, 2, GMP_RNDN);
        mpfr_add(temp2, temp2, DENORM_MIN, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) >= 0) mpfr_mul_si(temp, DENORM_MIN, 2 * signbit, GMP_RNDN);
        else mpfr_mul_si(temp, temp, signbit, GMP_RNDN);
        mpfr_clear(temp2);
        mpfr_clear(DENORM_MIN);
        ld = mpfr_get_d(temp, GMP_RNDN);
      }
    }
  }  /* close "if(emin <= 1)" */
  else {
    if(emin < 53) {
      mpfr_set_prec(temp, emin);
      mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    }
    ld = mpfr_get_d(temp, GMP_RNDN);
  }   /* close "else" */
#endif

  mpfr_clear(temp);

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(n);

}

void _d_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* Assumes 64-bit double (53-bit precision mantissa)   */
 /* This function does not call mpfr_subnormalize(). If */
 /* the mpfr_t holds a subnormal value, it should       */
 /* probably be subnormalised before being passed to    */
 /* this function.                                      */

  dXSARGS;
  double ld;
  int i, n = 8;
  char buff[4];
  void * p = &ld;

  if(bits != 53)
    croak("2nd arg to Math::MPFR::_d_bytes_fr must be 53");

  if(mpfr_get_prec(*str) != 53)
    croak("Precision of 1st arg supplied to _d_bytes_fr must be 53");

  if((size_t)bits != DBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_d_bytes_fr does not match DBL_MANT_DIG (%u)", bits, DBL_MANT_DIG);

  ld = mpfr_get_d(*str, GMP_RNDN);

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(n);

}

void _dd_bytes(pTHX_ SV * str, unsigned int bits) {

 /* Assumes 128-bit long double (106-bit precision mantissa) */

  dXSARGS;
  mpfr_t temp;
  double msd, lsd;
  int i, n = 8;
  char buff[4];
  void * pm = &msd;
  void * pl = &lsd;

  if(bits != 106)
    croak("2nd arg to Math::MPFR::_dd_bytes must be 106");

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_dd_bytes is not a string");

  mpfr_init2(temp, 2098);

  mpfr_set_str(temp, SvPV_nolen(str), 0, GMP_RNDN);

  msd = mpfr_get_d(temp, GMP_RNDN);
  if(msd == 0 || msd != msd || msd / msd != 1) { /* zero, nan or inf */
    lsd = 0.0;
  }
  else {
    mpfr_sub_d(temp, temp, msd, GMP_RNDN);
    lsd = mpfr_get_d(temp, GMP_RNDN);
  }

  mpfr_clear(temp);

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pm)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pl)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(16);

}

void _dd_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* Assumes 128-bit long double (106-bit precision mantissa) */
 /* Should handle subnormal values correctly                 */

  dXSARGS;
  mpfr_t temp;
  double msd, lsd;
  int i, n = 8;
  char buff[4];
  void * pm = &msd;
  void * pl = &lsd;

  if(bits != 106)
    croak("2nd arg to Math::MPFR::_dd_bytes must be 106");

  if(mpfr_get_prec(*str) != 2098)
    croak("Precision of 1st arg supplied to _dd_bytes_fr must be 2098");

  mpfr_init2(temp, 2098);

  mpfr_set(temp, *str, GMP_RNDN); /* Avoid altering the value held by *str */

  msd = mpfr_get_d(temp, GMP_RNDN);
  if(msd == 0 || msd != msd || msd / msd != 1) { /* zero, nan or inf */
    lsd = 0.0;
  }
  else {
    mpfr_sub_d(temp, temp, msd, GMP_RNDN);
    lsd = mpfr_get_d(temp, GMP_RNDN);
  }

  mpfr_clear(temp);

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pm)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pl)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(16);

}

void _ld_bytes(pTHX_ SV * str, unsigned int bits) {

 /* For Math::NV - added in version 3.26 */
 /* Corrected to handle subnormal values in 4.02 */

  dXSARGS;
  mpfr_t temp, temp2, DENORM_MIN;
  long double ld;
  int i, n, inex, signbit;
  char buff[4];
  void * p = &ld;
  mpfr_prec_t emin, emax;

  if(bits != 64 && bits != 113) {
    if(bits == 106) warn("\nYou probably want to call Math::MPFR::_dd_bytes\n");
    croak("2nd arg to Math::MPFR::_ld_bytes must be 64 or 113");
  }

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_ld_bytes is not a string");

  if((size_t)bits != LDBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_ld_bytes does not match LDBL_MANT_DIG (%u)", bits, LDBL_MANT_DIG);

  mpfr_init2(temp, bits);


#if defined(MPFR_VERSION) && MPFR_VERSION > 196869 /* use mpfr_subnormalize */

  emin = mpfr_get_emin();
  emax = mpfr_get_emax();

  mpfr_set_emin(-16444);
  mpfr_set_emax(16384);

  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
  mpfr_subnormalize(temp, inex, GMP_RNDN);

  mpfr_set_emin(emin);
  mpfr_set_emax(emax);

  ld = mpfr_get_ld(temp, GMP_RNDN);

#else /* mpfr_strtofr can return incorrect inex in 3.1.5 and   *
       * earlier - which renders mpfr_subnormalize unreliable  */


  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
  emax = bits == 64 ? 16445 : 16494;
  emin = mpfr_get_exp(temp) + emax;

      /* mpfr_get_ld is buggy for extended precision subnormal *
       * values with 3.1.4 and earlier. Hence, croak when this *
       * condition exists.                                      */

#ifdef LD_SUBNORMAL_BUG

       if(mpfr_regular_p(temp) && emin >= 0 && emin < bits) {
         warn("\n mpfr_get_ld is buggy (subnormal values only)\n for this version (%s) of the MPFR library\n", MPFR_VERSION_STRING);
         croak(" Version 3.1.5 or later is required");
       }

#endif


  signbit = mpfr_signbit(temp) ? -1 : 1;

  if(emin <= 1) {
    if(emin < 0) {
      ld = 0.0L;
      ld *= signbit;
    }
    else {
      if(emin == 0) {
        mpfr_init2(temp2, 2);
        mpfr_set_ui(temp2, 2, GMP_RNDN);
        mpfr_div_2ui(temp2, temp2, emax + 2, GMP_RNDN);
        mpfr_abs(temp, temp, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) > 0) {
          mpfr_mul_2ui(temp2, temp2, 1, GMP_RNDN);
          ld = mpfr_get_ld(temp2, GMP_RNDN);
          mpfr_clear(temp2);
        }
        else {
          ld = 0.0L;
        }
        ld *= signbit;
      }
      else {  /* emin == 1 *//* Can't set precision to 1 with older versions of mpfr */

        mpfr_abs(temp, temp, GMP_RNDN);
        mpfr_init2(temp2, 2);
        mpfr_init2(DENORM_MIN, 2);
        mpfr_set_ui(DENORM_MIN, 2, GMP_RNDN);
        mpfr_div_2ui(DENORM_MIN, DENORM_MIN, emax + 1, GMP_RNDN);
        mpfr_set(temp2, DENORM_MIN, GMP_RNDN);
        mpfr_div_ui(temp2, temp2, 2, GMP_RNDN);
        mpfr_add(temp2, temp2, DENORM_MIN, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) >= 0) mpfr_mul_si(temp, DENORM_MIN, 2 * signbit, GMP_RNDN);
        else mpfr_mul_si(temp, temp, signbit, GMP_RNDN);
        mpfr_clear(temp2);
        mpfr_clear(DENORM_MIN);
        ld = mpfr_get_ld(temp, GMP_RNDN);
      }
    }
  }  /* close "if(emin <= 1)" */
  else {
    if(emin < bits) {
      mpfr_set_prec(temp, emin);
      mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    }
  ld = mpfr_get_ld(temp, GMP_RNDN);
  }

#endif

  mpfr_clear(temp);

  sp = mark;

  n = bits == 64 ? 10 : 16;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(n);

}

void _ld_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* For Math::NV - added in version 3.26                    */
 /* Assumes 80-bit long double (64-bit precision mantissa)  */
 /* This function does not call mpfr_subnormalize(). If     */
 /* the mpfr_t holds a subnormal value, it should probably  */
 /* be subnormalised before being passed to this function.  */

  dXSARGS;
  long double ld;
  int i, n;
  char buff[4];
  void * p = &ld;

  if(bits != 64 && bits != 113) {
    if(bits == 106) warn("\nYou probably want to call Math::MPFR::_dd_bytes_fr\n");
    croak("2nd arg to Math::MPFR::_ld_bytes_fr must be 64 or 113");
  }

  if(mpfr_get_prec(*str) != bits)
    croak("Precision of 1st arg supplied to _ld_bytes_fr must match 2nd arg (%d)", bits);

  if((size_t)bits != LDBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_ld_bytes_fr does not match LDBL_MANT_DIG (%u)", bits, LDBL_MANT_DIG);

  ld = mpfr_get_ld(*str, GMP_RNDN);

  sp = mark;

  n = bits == 64 ? 10 : 16;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(n);

}

void _f128_bytes(pTHX_ SV * str, unsigned int bits) {

 /* For Math::NV - added in version 3.26 */
 /* Corrected to handle subnormal values in 4.02 */
 /* Assumes 128-bit float128 (113-bit precision mantissa) */

#ifndef MPFR_WANT_FLOAT128

  croak("__float128 support not built into this Math::MPFR");

#else

  dXSARGS;
  mpfr_t temp, temp2, DENORM_MIN;
  float128 ld;
  int i, n = 16, inex, signbit;
  char buff[4];
  void * p = &ld;
  mpfr_prec_t emin, emax;

  if(bits != 113)
    croak("2nd arg to Math::MPFR::_f128_bytes must be 113");

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_f128_bytes is not a string");

  if((size_t)bits != FLT128_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_f128_bytes does not match FLT128_MANT_DIG (%u)", bits, FLT128_MANT_DIG);

  mpfr_init2(temp, 113);

#if defined(MPFR_VERSION) && MPFR_VERSION > 196869 /* use mpfr_subnormalize */
  emin = mpfr_get_emin();
  emax = mpfr_get_emax();

  mpfr_set_emin(-16493);
  mpfr_set_emax(16384);

  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
  mpfr_subnormalize(temp, inex, GMP_RNDN);

  mpfr_set_emin(emin);
  mpfr_set_emax(emax);

  ld = mpfr_get_float128(temp, GMP_RNDN);

#else   /* mpfr_strtofr can return incorrect inex in 3.1.5 and  *
         * earlier - which renders mpfr_subnormalize unreliable */

  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);

  emin = mpfr_get_exp(temp) + 16494;
  signbit = mpfr_signbit(temp) ? -1 : 1;

  if(emin < 1) {
    if(emin < 0) {
      ld = 0.0Q;
      ld *= signbit;
    }
    else {
      if(emin == 0) {
        mpfr_init2(temp2, 2);
        mpfr_set_ui(temp2, 2, GMP_RNDN);
        mpfr_div_2ui(temp2, temp2, 16496, GMP_RNDN);
        mpfr_abs(temp, temp, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) > 0) {
          mpfr_mul_2ui(temp2, temp2, 1, GMP_RNDN);
          ld = mpfr_get_float128(temp2, GMP_RNDN);
          mpfr_clear(temp2);
        }
        else {
          ld = 0.0Q;
        }
        ld *= signbit;
      }
      else {  /* emin == 1 *//* Can't set precision to 1 with older versions of mpfr */
        mpfr_abs(temp, temp, GMP_RNDN);
        mpfr_init2(temp2, 2);
        mpfr_init2(DENORM_MIN, 2);
        mpfr_set_ui(DENORM_MIN, 2, GMP_RNDN);
        mpfr_div_2ui(DENORM_MIN, DENORM_MIN, 16495, GMP_RNDN);
        mpfr_set(temp2, DENORM_MIN, GMP_RNDN);
        mpfr_div_ui(temp2, temp2, 2, GMP_RNDN);
        mpfr_add(temp2, temp2, DENORM_MIN, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) >= 0) mpfr_mul_si(temp, DENORM_MIN, 2 * signbit, GMP_RNDN);
        else mpfr_mul_si(temp, temp, signbit, GMP_RNDN);
        mpfr_clear(temp2);
        mpfr_clear(DENORM_MIN);
        ld = mpfr_get_float128(temp, GMP_RNDN);
      }
    }
  }  /* close "if(emin <= 1)" */
  else {
    if(emin < 113) {
      mpfr_set_prec(temp, emin);
      mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    }
    ld = mpfr_get_float128(temp, GMP_RNDN);
  }   /* close "else" */

#endif

  mpfr_clear(temp);

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(n);

#endif

}

void _f128_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* Assumes 128-bit float128 (113-bit precision mantissa)   */
 /* This function does not call mpfr_subnormalize(). If     */
 /* the mpfr_t holds a subnormal value, it should probably  */
 /* be subnormalised before being passed to this function.  */

#ifndef MPFR_WANT_FLOAT128

  croak("__float128 support not built into this Math::MPFR");

#else

  dXSARGS;
  float128 ld;
  int i, n = 16;
  char buff[4];
  void * p = &ld;

  if(bits != 113)
    croak("2nd arg to Math::MPFR::_f128_bytes_fr must be 113");

  if(mpfr_get_prec(*str) != 113)
    croak("Precision of 1st arg supplied to _f128_bytes_fr must be 113");

  if((size_t)bits != FLT128_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_f128_bytes_fr does not match FLT128_MANT_DIG (%u)", bits, FLT128_MANT_DIG);

  ld = mpfr_get_float128(*str, GMP_RNDN);

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  XSRETURN(n);

#endif

}

int _required_ldbl_mant_dig(void) {
    return REQUIRED_LDBL_MANT_DIG;
}

SV * _GMP_LIMB_BITS(pTHX) {
#ifdef GMP_LIMB_BITS
     return newSVuv(GMP_LIMB_BITS);
#else
     return &PL_sv_undef;
#endif
}

SV * _GMP_NAIL_BITS(pTHX) {
#ifdef GMP_NAIL_BITS
     return newSVuv(GMP_NAIL_BITS);
#else
     return &PL_sv_undef;
#endif
}

/* New in 3.2.0 */

void Rmpfr_fmodquo(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     dXSARGS;
     long ret, q;
     ret = mpfr_fmodquo(*a, &q, *b, *c, (mpfr_rnd_t)SvUV(round));
     ST(0) = sv_2mortal(newSViv(q));
     ST(1) = sv_2mortal(newSViv(ret));
     XSRETURN(2);
#else
     croak("Rmpfr_fmodquo not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fpif_export(pTHX_ FILE * stream, mpfr_t * op) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     int ret = mpfr_fpif_export(stream, *op);
     fflush(stream);
     return ret;
#else
     croak("Rmpfr_fpif_export not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fpif_import(pTHX_ mpfr_t * op, FILE * stream) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     int ret = mpfr_fpif_import(*op, stream);
     fflush(stream);
     return ret;
#else
     croak("Rmpfr_fpif_import not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_flags_clear(unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     mpfr_flags_clear((mpfr_flags_t) mask);
#else
     croak("Rmpfr_flags_clear not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_flags_set(unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     mpfr_flags_set((mpfr_flags_t) mask);
#else
     croak("Rmpfr_flags_set not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

unsigned int Rmpfr_flags_test(unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     mpfr_flags_t ret = mpfr_flags_test((mpfr_flags_t) mask);
     return (unsigned int)ret;
#else
     croak("Rmpfr_flags_test not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

unsigned int Rmpfr_flags_save(void) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     mpfr_flags_t ret = mpfr_flags_save();
     return (unsigned int)ret;
#else
     croak("Rmpfr_flags_save not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_flags_restore(unsigned int flags, unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     mpfr_flags_restore((mpfr_flags_t) flags, (mpfr_flags_t) mask);
#else
     croak("Rmpfr_flags_restore not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_rint_roundeven(mpfr_t * rop, mpfr_t * op, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_rint_roundeven(*rop, *op, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_rint_roundeven not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_roundeven(mpfr_t * rop, mpfr_t * op) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     return(mpfr_roundeven(*rop, *op));
#else
     croak("Rmpfr_roundeven not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_nrandom(mpfr_t * rop, gmp_randstate_t * state, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     return(mpfr_nrandom(*rop, *state, (mpfr_rnd_t)round));
#else
     croak("Rmpfr_nrandom not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_erandom(mpfr_t * rop, gmp_randstate_t * state, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
     return(mpfr_erandom(*rop, *state, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_erandom not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fmma(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, mpfr_t * op3, mpfr_t * op4, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_fmma(*rop, *op1, *op2, *op3, *op4, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_fmma not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fmms(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, mpfr_t * op3, mpfr_t * op4, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_fmms(*rop, *op1, *op2, *op3, *op4, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_fmms not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_log_ui(mpfr_t * rop, unsigned long op, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_log_ui(*rop, op, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_log_ui not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_gamma_inc(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_gamma_inc(*rop, *op1, *op2, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_gamma_inc not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int _have_IEEE_754_long_double(void) {
#if defined(HAVE_IEEE_754_LONG_DOUBLE)
    return 1;
#else
    return 0;
#endif
}

int _have_extended_precision_long_double(void) {
#if defined(HAVE_EXTENDED_PRECISION_LONG_DOUBLE)
    return 1;
#else
    return 0;
#endif
}

int nanflag_bug(void) {
#if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= NANFLAG_BUG)
    return 1;
#else
    return 0;
#endif
}

SV * Rmpfr_buildopt_float128_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 4
     return newSViv(mpfr_buildopt_float128_p());
#else
     croak("Rmpfr_buildopt_float128_p not implemented with this version of the mpfr library - we have %s but need at least 4.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_sharedcache_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 4
     return newSViv(mpfr_buildopt_sharedcache_p());
#else
     croak("Rmpfr_buildopt_sharedcache_p not implemented with this version of the mpfr library - we have %s but need at least 4.0.0", MPFR_VERSION_STRING);
#endif
}

int _nv_is_float128(void) {
#if defined(NV_IS_FLOAT128)
    return 1;
#else
    return 0;
#endif
}

int _SvNOK(pTHX_ SV * in) {
  if(SvNOK(in)) return 1;
  return 0;
}

int _SvPOK(pTHX_ SV * in) {
  if(SvPOK(in)) return 1;
  return 0;
}

/*
Expects to return either 0 or 1:
*/

int _get_bit(pTHX_ char * s, mpfr_prec_t p) {

  if(s[p] == '1') return 1;
  if(s[p] != '0') croak ("Invalid bit value in Math::MPFR::_get_bit");
  return 0;

}

/*
 A function to return the least
 significant bit of the mantissa:
*/

SV * _lsb(pTHX_ mpfr_t * a) {

  char * buffer;
  mpfr_exp_t exponent;
  mpfr_prec_t p = mpfr_get_prec(*a);

  if(mpfr_nan_p(*a)) {
    mpfr_set_nanflag();
    return newSVuv(0);
  }

  if(mpfr_inf_p(*a)) return newSVuv(0);

  Newxz(buffer, p + 2, char);
  if(buffer == NULL) croak("Failed to allocate memory in _lsb function");

  mpfr_get_str(buffer, &exponent, 2, (size_t)p, *a, GMP_RNDN);

  if(!mpfr_signbit(*a)) p--;

  p = (mpfr_prec_t)_get_bit(aTHX_ buffer, p);

  Safefree(buffer);

  return newSVuv((UV)p);
}

int Rmpfr_rec_root(pTHX_ mpfr_t * rop, mpfr_t * op, unsigned long root, SV * round) {

  /*
    Originally supplied by Vincent Lefevre to mpfr mailing list.
    See https://sympa.inria.fr/sympa/arc/mpfr/2016-12/msg00032.html
    Sisyphus re-arranged it as an XSub and added handling of special
    cases (inf/nan/zero).
    Requires mpfr-3.1.0 or later.
  */

#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3

  mpfr_prec_t p;
  mpfr_t t, u;
  int inex1, inex2 = -1, inex3= 1;

  CHECK_ROUNDING_VALUE

  if(root == 0) {
    mpfr_set_nan(*rop);
    mpfr_set_nanflag();
    return 0;
  }

 /* At this point we know that "root" is greater than 0 */

  if(mpfr_zero_p(*op)) {
    mpfr_set_divby0();
    if(root % 2) {
      mpfr_set_inf(*rop, mpfr_signbit(*op) * -1);
      return 0;
    }
    mpfr_set_inf(*rop, 1);
    return 0;
  }

  /* and we now also know that op != 0 */

  if(mpfr_signbit(*op) && root % 2 == 0) {
      mpfr_set_nan(*rop);
      mpfr_set_nanflag();
      return 0;
  }

  /*
   All other special cases are handled correctly by the following code.
   This is all checked in t/Rmpfr_rec_root.t. (At least, that's the intention.)
  */

  p = mpfr_get_prec(*rop);
  mpfr_init2(t, p);
  mpfr_init2(u, p);

  while(
        (inex2 != inex3 && inex2 * inex3 <= 0)
        || mpfr_cmp(*rop, u)
       ) {
    mpfr_set_prec(t, mpfr_get_prec(t) + 8);
    inex1 = mpfr_ui_div(t, 1, *op, GMP_RNDZ);
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    inex2 = mpfr_rootn_ui(*rop, t, root, (mpfr_rnd_t)SvUV(round));
#else
    inex2 = mpfr_root(*rop, t, root, (mpfr_rnd_t)SvUV(round));
#endif
    if(!inex1) return inex2;
    mpfr_nextabove(t);
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    inex3 = mpfr_rootn_ui(u, t, root, (mpfr_rnd_t)SvUV(round));
#else
    inex3 = mpfr_root(u, t, root, (mpfr_rnd_t)SvUV(round));
#endif
  }
  return inex2;
#else
    croak("Rmpfr_set_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_beta(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_beta(*rop, *op1, *op2, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_beta not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_rootn_ui (mpfr_t * rop, mpfr_t * op, unsigned long k, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
    return(mpfr_rootn_ui(*rop, *op, k, (mpfr_rnd_t)round));
#else
    croak("Rmpfr_rec_root not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int _ld_subnormal_bug(void) {

#if defined(LD_SUBNORMAL_BUG)
    return 1;
#else
    return 0;
#endif
}

/*
*  The atodouble function was written as a means to check that the atonv
*  function  handles subnormal double-doubles correctly.
*  But it is readily available for any other purpose, too.
*  On a perl whose nvtype is double it should return the same value as atonv,
*  though atodouble is not as efficient as atonv.
*/

double atodouble(char * str) {


#if defined(MPFR_VERSION) & MPFR_VERSION > 196869

    mpfr_t workspace;
    mpfr_prec_t emin, emax;
    int inex;
    double d;

    mpfr_init2(workspace, 53);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-1073);
    mpfr_set_emax(1024);

    inex = mpfr_strtofr(workspace, str, NULL, 0, GMP_RNDN);
    mpfr_subnormalize(workspace, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    d = mpfr_get_d(workspace, GMP_RNDN);

    mpfr_clear(workspace);

    return d;

#else

    croak("The atodouble function requires mpfr-3.1.6 or later");

#endif
}

SV * atonv(pTHX_ SV * str) {


#if defined(MPFR_VERSION) & MPFR_VERSION > 196869
    mpfr_t workspace;
#if defined(NV_IS_DOUBLE) || LDBL_MANT_DIG == 53        /* D */
    mpfr_prec_t emin, emax;
    int inex;
    double ret;

    mpfr_init2(workspace, 53);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-1073);
    mpfr_set_emax(1024);

    inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(workspace, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    ret = mpfr_get_d(workspace, GMP_RNDN);
    mpfr_clear(workspace);

    return newSVnv(ret);

#endif                                                  /* close D */

#if defined(NV_IS_LONG_DOUBLE) && LDBL_MANT_DIG != 53   /* LD */
#if REQUIRED_LDBL_MANT_DIG == 64

    mpfr_prec_t emin, emax;
    int inex;
    long double ret;

    mpfr_init2(workspace, 64);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-16444);
    mpfr_set_emax(16384);

    inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(workspace, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    ret = mpfr_get_ld(workspace, GMP_RNDN);
    mpfr_clear(workspace);

    return newSVnv(ret);

#endif

#if REQUIRED_LDBL_MANT_DIG == 113

    mpfr_prec_t emin, emax;
    int inex;
    long double ret;

    mpfr_init2(workspace, 113);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-16493);
    mpfr_set_emax(16384);

    inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(workspace, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    ret = mpfr_get_ld(workspace, GMP_RNDN);
    mpfr_clear(workspace);

    return newSVnv(ret);

#endif

#if REQUIRED_LDBL_MANT_DIG == 2098

    mpfr_t dspace;
    double msd, lsd;        /* 'most' and 'least' significant doubles */
    mpfr_prec_t emin, emax;
    int inex;
    long double ret;

    mpfr_init2(workspace, 2098);
    mpfr_init2(dspace, 53);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-1073);
    mpfr_set_emax(1024);

    inex = mpfr_strtofr(dspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(dspace, inex, GMP_RNDN);

    msd = mpfr_get_d(dspace, GMP_RNDN);

    if(!mpfr_regular_p(dspace)) {
      mpfr_clear(dspace);
      mpfr_set_emin(emin); /* restore to original value */
      mpfr_set_emax(emax); /* restore to original value */
      return newSVnv(msd);
    }

    mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    inex = mpfr_sub(dspace, workspace, dspace, GMP_RNDN);
    mpfr_subnormalize(dspace, inex, GMP_RNDN);
    lsd = mpfr_get_d(dspace, GMP_RNDN);

    mpfr_clear(dspace);
    mpfr_clear(workspace);

    mpfr_set_emin(emin); /* restore to original value */
    mpfr_set_emax(emax); /* restore to original value */

    return newSVnv((long double)msd + (long double)lsd);

#endif
#endif                                                  /* close LD */

#if defined(NV_IS_FLOAT128)                             /* F128 */
#if defined(MPFR_WANT_FLOAT128)

    mpfr_prec_t emin, emax;
    int inex;
    __float128 ret;

    mpfr_init2(workspace, 113);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-16493);
    mpfr_set_emax(16384);

    inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(workspace, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    ret = mpfr_get_float128(workspace, GMP_RNDN);
    mpfr_clear(workspace);
    return newSVnv(ret);

#else
    croak("The atonv function is unavailable for this __float128 build of perl\n");
#endif
#endif                                                  /* close F128 */

    croak("The atonv function has encountered an unrecognized nvtype");

#else

    croak("The atonv function requires mpfr-3.1.6 or later");

#endif

} /* close atonv */

/* new in 4.1.0 (262400) */

SV * Rmpfr_get_str_ndigits(pTHX_ int base, SV * prec) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= 262400 /* version 4.1.0 */
    return newSVuv(mpfr_get_str_ndigits(base, (mpfr_prec_t)SvUV(prec)));
#else
    croak("The Rmpfr_get_str_ndigits function requires mpfr-4.1.0 or later");
#endif
}

SV * Rmpfr_dot(pTHX_ mpfr_t * rop, SV * avref_A, SV * avref_B, SV * len, SV * round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= 262400 /* version 4.1.0 */
     mpfr_ptr *p_A, *p_B;
     SV ** elem;
     int ret, i;
     unsigned long s = (unsigned long)SvUV(len);

     if(s > av_len((AV*)SvRV(avref_A)) + 1 || s > av_len((AV*)SvRV(avref_B)) + 1)
       croak("2nd last arg to Rmpfr_dot is too large");

     Newx(p_A, s, mpfr_ptr);
     if(p_A == NULL) croak("Unable to allocate memory for first array in Rmpfr_dot");

     Newx(p_B, s, mpfr_ptr);
     if(p_B == NULL) croak("Unable to allocate memory for second array in Rmpfr_dot");

     for(i = 0; i < s; ++i) {
        elem = av_fetch((AV*)SvRV(avref_A), i, 0);
        p_A[i] = *(INT2PTR(mpfr_t *, SvIVX(SvRV(*elem))));
     }

     for(i = 0; i < s; ++i) {
        elem = av_fetch((AV*)SvRV(avref_B), i, 0);
        p_B[i] = *(INT2PTR(mpfr_t *, SvIVX(SvRV(*elem))));
     }

     ret = mpfr_dot(*rop, p_A, p_B, s, (mpfr_rnd_t)SvUV(round));

     Safefree(p_A);
     Safefree(p_B);
     return newSViv(ret);
#else
    croak("The Rmpfr_dot function requires mpfr-4.1.0 or later");
#endif
}

/********************************************************
 * Set exponent and precision for nvtoa to utilize. *
 *******************************************************/

void _get_exp_and_bits(mpfr_exp_t * exp, int * bits, NV nv_in) {

  int subnormal_prec_adjustment = 0, tmp;
  void *nvptr = &nv_in;

#if defined(NV_IS_FLOAT128) || (defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 113)	/* 113 bit prec */

#if defined(MPFR_HAVE_BENDIAN)

  int i = 2;

  *exp = ((unsigned char *)nvptr)[0];
  *exp <<= 8;
  tmp = ((unsigned char *)nvptr)[1];
  *exp += tmp - 16382;

  if(*exp == -16382) {
    while(i <= 15) {
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        BITSEARCH_8		/* defined in math_mpfr_include.h */
        break;
      }

      subnormal_prec_adjustment += 8;
      i++;
    }			/* close while loop */
  }

#else

  int i = 13;

  *exp = ((unsigned char *)nvptr)[15];
  *exp <<= 8;
  tmp = ((unsigned char *)nvptr)[14];
  *exp += tmp - 16382;

  if(*exp == -16382) {
    while(i >= 0) {
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        BITSEARCH_8		/* defined in math_mpfr_include.h */
        break;
      }

      subnormal_prec_adjustment += 8;
      i--;
    }			/* close while loop */
  }

#endif

  /* for both endians (113-bit) */
  *exp  -= subnormal_prec_adjustment - 1;
  *bits =  113 - subnormal_prec_adjustment;

  if(!subnormal_prec_adjustment) (*exp)--;

/*********************
 * START DOUBLEDOUBLE*
 *********************/

#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098	/* double-double */
  int msd_exp, lsd_exp, t, lsd_is_negative_reduction = 0, lsd_is_zero = 0;

#if defined(MPFR_HAVE_BENDIAN)
  int i0 = 0, i1 = 1, i2 = 8, i3 = 9;
  int i = 1;

  if( (128 == ((unsigned char *)nvptr)[8] || 0 == ((unsigned char *)nvptr)[8])  &&
      0 == ((unsigned char *)nvptr)[9]  && 0 == ((unsigned char *)nvptr)[10]    &&
      0 == ((unsigned char *)nvptr)[11] && 0 == ((unsigned char *)nvptr)[12]    &&
      0 == ((unsigned char *)nvptr)[13] && 0 == ((unsigned char *)nvptr)[14]    &&
      0 == ((unsigned char *)nvptr)[15]
    ) {
    lsd_is_zero = 1;
    *bits = 53;
  }

  if(*bits == 53) {
    *exp = ((unsigned char *)nvptr)[0];
    *exp <<= 4;
    tmp = ((unsigned char *)nvptr)[i];
    *exp += (tmp >> 4) - 1022;

    if(*exp == -1022) {
      while(i <= 7) {
        tmp = ((unsigned char *)nvptr)[i];
        if(tmp) {
          if(i == 1) {
            BITSEARCH_4		/* defined in math_mpfr_include.h */
            break;
          }
          else {
            BITSEARCH_8		/* defined in math_mpfr_include.h */
            break;
          }
        }

        if(i == 1) subnormal_prec_adjustment += 4;
        else subnormal_prec_adjustment += 8;
        i++;
      }
    }

    if(!subnormal_prec_adjustment){

      (*exp)--;

      if(*exp > 53 && *exp < 106) {
        *bits = *exp;
      }

      else {
       if(*exp < 53)
         *bits += 1022 + *exp;
      }
    }
    else {
      *exp  -= subnormal_prec_adjustment - 1;
      *bits =  53 - subnormal_prec_adjustment;
    }

  }

#else
  int i0 = 15, i1 = 14, i2 = 7, i3 = 6;
  int i = 6;

  if( (128 == ((unsigned char *)nvptr)[7] || 0 == ((unsigned char *)nvptr)[7])  &&
      0 == ((unsigned char *)nvptr)[6]  && 0 == ((unsigned char *)nvptr)[5]    &&
      0 == ((unsigned char *)nvptr)[4] && 0 == ((unsigned char *)nvptr)[3]    &&
      0 == ((unsigned char *)nvptr)[2] && 0 == ((unsigned char *)nvptr)[1]    &&
      0 == ((unsigned char *)nvptr)[0]
    ) {
    lsd_is_zero = 1;
    *bits = 53;
  }

  if(*bits == 53) {
    *exp = ((unsigned char *)nvptr)[7];
    *exp <<= 4;
    tmp = ((unsigned char *)nvptr)[i];
    *exp += (tmp >> 4) - 1022;

    if(*exp == -1022) {
      while(i >= 0) {
        tmp = ((unsigned char *)nvptr)[i];
        if(tmp) {
          if(i == 6) {
            BITSEARCH_4		/* defined in math_mpfr_include.h */
            break;
          }
          else {
            BITSEARCH_8		/* defined in math_mpfr_include.h */
            break;
          }
        }

        if(i == 6) subnormal_prec_adjustment += 4;
        else subnormal_prec_adjustment += 8;
        i--;
      }
    }

    if(!subnormal_prec_adjustment){

      (*exp)--;

      if(*exp > 53 && *exp < 106) {
        *bits = *exp;
      }

      else {
       if(*exp < 53)
         *bits += 1022 + *exp;
      }
    }
    else {
      *exp  -= subnormal_prec_adjustment - 1;
      *bits =  53 - subnormal_prec_adjustment;
    }

  }

#endif

  else {
      msd_exp = ((unsigned char *)nvptr)[i0];
      msd_exp <<= 4;
      tmp = ((unsigned char *)nvptr)[i1];
      msd_exp += (tmp >> 4) - 1022;

      lsd_exp = ((unsigned char *)nvptr)[i2];


      lsd_exp <<= 4;
      tmp = ((unsigned char *)nvptr)[i3];
      lsd_exp += tmp >> 4;
      if(lsd_exp > 2047) {
        lsd_exp -= 2048;
        if(!lsd_is_zero) lsd_is_negative_reduction = 1;
      }
      lsd_exp -= 1022;

      if(lsd_is_zero) *bits = 53;
      else *bits = 53 + msd_exp - lsd_exp;

      if(lsd_is_negative_reduction) {                   /* lsd is negative and not zero */
        if(msd_exp - lsd_exp > 53) {  /* need to check that msd is not a power of 2 */

#if defined(MPFR_HAVE_BENDIAN)
          for(i = 2; i < 8; i++) {
            t = ((unsigned char *)nvptr)[i];
            if(t != 0) {   /* msd is not a power of 2 */
              lsd_is_negative_reduction = 0;
              break;
            }
          }

          if(lsd_is_negative_reduction) {
            t = ((unsigned char *)nvptr)[1];
            if(t & 15) {   /* msd is not a power of 2 */
              lsd_is_negative_reduction = 0;
            }
          }
#else

#endif
        }
        else lsd_is_negative_reduction = 0;
      }

      if(lsd_exp < -1022) *bits += (lsd_exp + 1022);
      if(lsd_exp == -1022) *bits -= 1;
      *exp = msd_exp - lsd_is_negative_reduction;
  }

/*******************
 * END DOUBLEDOUBLE*
 *******************/

#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 64	/* 64 bit prec */
#if defined(MPFR_HAVE_BENDIAN)
  int i = 2;

  *exp = ((unsigned char *)nvptr)[0];
  *exp <<= 8;
  tmp = ((unsigned char *)nvptr)[1];
  *exp += tmp - 16382;

  if(*exp == -16382) {
    while(i <= 9) {
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        BITSEARCH_8		/* defined in math_mpfr_include.h */
        break;
      }

      subnormal_prec_adjustment += 8;
      i++;
    }			/* close while loop */
  }

#else

  int i = 7;

  *exp = ((unsigned char *)nvptr)[9];
  *exp <<= 8;
  tmp = ((unsigned char *)nvptr)[8];
  *exp += tmp - 16382;

  if(*exp == -16382) {
    while(i >= 0) {
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        BITSEARCH_8		/* defined in math_mpfr_include.h */
        break;
      }

      subnormal_prec_adjustment += 8;
      i--;
    }			/* close while loop */
  }

#endif

  /* for both endians (64 bit) */
  if(subnormal_prec_adjustment) subnormal_prec_adjustment--;

  *exp  -= subnormal_prec_adjustment;
  *bits =  64 - subnormal_prec_adjustment;

   if(subnormal_prec_adjustment) (*exp)++;

#else									/* 53 bit prec */

#if defined(MPFR_HAVE_BENDIAN)
  int i = 1;

  *exp = ((unsigned char *)nvptr)[0];
  *exp <<= 4;
  tmp = ((unsigned char *)nvptr)[i];
  *exp += (tmp >> 4) - 1022;

  if(*exp == -1022) {
    while(i <= 7) {
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        if(i == 1) {
          BITSEARCH_4		/* defined in math_mpfr_include.h */
          break;
        }
        else {
          BITSEARCH_8		/* defined in math_mpfr_include.h */
          break;
        }
      }

      if(i == 1) subnormal_prec_adjustment += 4;
      else subnormal_prec_adjustment += 8;
      i++;
    }
  }

#else
  int i = 6;

  *exp = ((unsigned char *)nvptr)[7];
  *exp <<= 4;
  tmp = ((unsigned char *)nvptr)[i];
  *exp += (tmp >> 4) - 1022;

  if(*exp == -1022) {
    while(i >= 0) {
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        if(i == 6) {
          BITSEARCH_4		/* defined in math_mpfr_include.h */
          break;
        }
        else {
          BITSEARCH_8		/* defined in math_mpfr_include.h */
          break;
        }
      }

      if(i == 6) subnormal_prec_adjustment += 4;
      else subnormal_prec_adjustment += 8;
      i--;
    }			/* close while loop */
  }

#endif

  /* for both endians (53 bit) */
  *exp  -= subnormal_prec_adjustment - 1;
  *bits =  53 - subnormal_prec_adjustment;

  if(!subnormal_prec_adjustment) (*exp)--;

#endif

}



/* nvtoa function is adapted from p120 of  "How to Print Floating-Point Numbers Accurately" */
/* by Guy L. Steele Jr and Jon L. White                                                     */

void nvtoa(pTHX_ SV * pnv) {

  dXSARGS;
  int subnormal_prec_adjustment, exp_init;
  int k = 0, k_start, lsb, skip = 0, sign = 0, len, critical;
  int bits = MATH_MPFR_BITS, is_subnormal = 0, shift1, shift2, inex, low, high, cmp;
  unsigned long u;
  mpfr_exp_t e;    /* Change to 'int' when mpfr dependency for doubledouble is removed */
  NV nv;
  void *nvptr = &nv;
#if defined(NV_IS_53_BIT)
  char f[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};

#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 64
  char f[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0',
              '\0','\0','\0','\0'};

#elif REQUIRED_LDBL_MANT_DIG == 2098 && defined(NV_IS_LONG_DOUBLE)
  char *f;
  mpfr_t ws;

#else
  char f[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0',
              '\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};

#endif
  mpz_t R, S, M_minus, M_plus, LHS, TMP;
  char str[] = {'\0','\0','\0','\0','\0','\0','\0','\0'};
  char * c = "0123456789abcdef";
  char *out, *bstr;

  nv = SvNV(pnv);

#if defined(MPFR_HAVE_BENDIAN)

  if(((unsigned char *)nvptr)[0] >= 128) {
#if defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098
    nv = -nv;
#else
    ((unsigned char *)nvptr)[0] &= 127;
#endif

#elif defined(NV_IS_53_BIT)
  if(((unsigned char *)nvptr)[7] >= 128) {
    ((unsigned char *)nvptr)[7] &= 127;
#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 64
  if(((unsigned char *)nvptr)[9] >= 128) {
    ((unsigned char *)nvptr)[9] &= 127;
#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098
  if(((unsigned char *)nvptr)[15] >= 128) {
    nv = -nv;
#else
  if(((unsigned char *)nvptr)[15] >= 128) {
    ((unsigned char *)nvptr)[15] &= 127;
#endif
    sign = 1;
  }

  if(nv == 0) {
    ST(0) = sign ? sv_2mortal(newSVpv("-0.0", 0)) : sv_2mortal(newSVpv("0.0", 0));
    XSRETURN(1);
  }

  if(nv != nv) {
    ST(0) = sv_2mortal(newSVpv("NaN", 0));
    XSRETURN(1);
  }

  if(nv > MATH_MPFR_NV_MAX) {
    ST(0) = sign ? sv_2mortal(newSVpv("-Inf", 0)) : sv_2mortal(newSVpv("Inf", 0));
    XSRETURN(1);
  }

  mpz_init(R);
  mpz_init(S);
  mpz_init(M_plus);
  mpz_init(M_minus);
  mpz_init(LHS);
  mpz_init(TMP);

  _get_exp_and_bits( &e, &bits, nv);

#if REQUIRED_LDBL_MANT_DIG == 2098 && defined(NV_IS_LONG_DOUBLE)

  if(bits < 53) is_subnormal = 1;

#else

  if(bits < MATH_MPFR_BITS) is_subnormal = 1;

#endif

/***************
 * Assign to f *
 ***************/

  if(bits == 1) {
#if defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098			/* doubledouble */
    Newxz(f, 4, char);
    if(f == NULL) croak("Failed to allocate memory for string buffer in nvtoa XSub");
#endif
    f[0] = c[1];
  }
  else {

#if defined(NV_IS_FLOAT128) || (defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 113)	/* 113 bit prec */

    f[0] = is_subnormal ? c[0] : c[1];
    k++;

#if defined(MPFR_HAVE_BENDIAN)
    for(skip = 2; skip <= 15; skip++) {
#else
    for(skip = 13; skip >= 0; skip--) {
#endif
      low = ((unsigned char *)nvptr)[skip];
      f[k] = c[low >> 4];
      f[k + 1] = c[low & 15];
      k += 2;
    }

#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098			/* doubledouble */

    /*********************************************
     * TODO: Remove the mpfr dependency entirely *
     ********************************************/

    mpfr_init2(ws, bits);
    mpfr_set_ld(ws, nv, GMP_RNDN);

    Newxz(f, bits + 8, char);
    if(f == NULL) croak("Failed to allocate memory for string buffer in nvtoa XSub");

    mpfr_get_str(f, &e, 2, bits, ws, GMP_RNDN);		/* using mpfr to set both f and e */
    mpfr_clear(ws);

#elif defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 64	/* 64 bit prec */

#if defined(MPFR_HAVE_BENDIAN)
    for(skip = 2; skip <= 9; skip++) {
#else
    for(skip = 7; skip >= 0; skip--) {
#endif
      low = ((unsigned char *)nvptr)[skip];
      f[k] = c[low >> 4];
      f[k + 1] = c[low & 15];
      k += 2;
    }

#else									/* 53 bit prec */

#if defined(MPFR_HAVE_BENDIAN)
    for(skip = 1; skip <= 7; skip++) {
#else
    for(skip = 6; skip >= 0; skip--) {
#endif
      low = ((unsigned char *)nvptr)[skip];
      if(!k) {
        f[0] = is_subnormal ? c[0] : c[1];
        f[1] = c[low & 15];
      }
      else {
        f[k] = c[low >> 4];
        f[k + 1] = c[low & 15];
      }
      k += 2;
    }
#endif

/********************************
 * assignment to f is completed *
 ********************************/

  }

#if defined(NV_IS_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098			/* doubledouble */

  mpz_set_str(R, f, 2);
  Safefree(f);

#else

  mpz_set_str(R, f, 16);

#endif

  lsb = mpz_tstbit(R, 0);
  mpz_set(TMP, R);

  if(mpz_cmp_ui(R, 0) < 1) croak("Negative value in nvtoa XSub is not allowed");
  mpz_set_ui(S, 1);

  shift2 = e - bits;

  shift1 = shift2 > 0 ? shift2 : 0;
  mpz_mul_2exp(R, R, shift1);

  shift2 = shift1       ? 0 : -shift2;
  mpz_mul_2exp(S, S, shift2);

  mpz_set_ui(M_minus, 1);
  mpz_mul_2exp(M_minus, M_minus, shift1);
  mpz_set(M_plus, M_minus);

  /*************** simple_fixup() **************/

  if(!is_subnormal) {
    mpz_set_ui(LHS, 1);
    mpz_mul_2exp(LHS, LHS, bits - 1);
    if(!mpz_cmp(LHS, TMP)) {
      mpz_mul_2exp(M_plus, M_plus, 1);
      mpz_mul_2exp(R,      R,      1);
      mpz_mul_2exp(S,      S,      1);
    }
  }

  k = 0;	/* used above, so we reset to zero */
  skip = 0;	/* used above, so we reset to zero */

  mpz_cdiv_q_ui(LHS, S, 10);

  if(mpz_cmp(LHS, R) > 0) {
    k = (int)floor(mpz_sizeinbase(LHS, 2) * 0.30102999566398119); /* 0.30102999566398119 < log(2)/log(10) */
    if(k) k--;    /* k should not become -ve here */
    mpz_ui_pow_ui(TMP, 10, k);
    k *= -1;
    mpz_mul(R, R, TMP);
    mpz_mul(M_minus, M_minus, TMP);
    mpz_mul(M_plus, M_plus, TMP);
  }
  else {
    skip = 1; /* No need to enter the following while() loop */
  }

  if(!skip) {
    while(1) {
      if(mpz_cmp(LHS, R) <= 0) break;
      k--;
      mpz_mul_ui(R, R, 10);
      mpz_mul_ui(M_minus, M_minus, 10);
      mpz_mul_ui(M_plus, M_plus, 10);
    }                                   /* close first while loop */
  }

  mpz_mul_2exp(LHS, R, 1);
  mpz_add(LHS, LHS, M_plus);
  mpz_mul_2exp(TMP, S, 1);

  if(mpz_cmp(LHS, TMP) >= 0) {
    skip = 0;
    mpz_div(TMP, LHS, TMP);
    u = (int)floor(mpz_sizeinbase(TMP, 2) * 0.30102999566398119); /* 0.30102999566398119 < log(2)/log(10) */
    if(u) u--;     /* Do not decrement if u is zero */
    mpz_ui_pow_ui(TMP, 10, u);
    k += u;
    mpz_mul(S, S, TMP);
  }
  else {
    skip = 1; /* No need to enter the following while() loop */
  }

  if(!skip) {
    while(1) {
      mpz_mul_2exp(TMP, S, 1);

      if(mpz_cmp(LHS, TMP) < 0) break;

      mpz_mul_ui(S, S, 10);
      k++;
    }                                 /* close second while loop */
  }

  /*********************************************/

  k_start = k - 1;

  Newxz(out, (int)(12 + ceil(0.30103 * bits)), char); /* 1 + ceil(log(2) / log(10) * bits), but allow a few extra for
                                                       exponent and sign */

  if(out == NULL) croak("Failed to allocate memory for output string in nvtoa XSub");

  while(1) {

    k--;

    mpz_mul_ui(TMP, R, 10);
    mpz_fdiv_qr(LHS, R, TMP, S);
    u = mpz_get_ui(LHS);

    mpz_mul_ui(M_minus, M_minus, 10);
    mpz_mul_ui(M_plus, M_plus, 10);

    mpz_mul_2exp(LHS, R, 1);

    cmp = mpz_cmp(LHS, M_minus);

    if(!cmp && !lsb && !is_subnormal) { /* !lsb implies that f is even */
      low = 1;
    }
    else {
      low = cmp < 0 ? 1 : 0;
    }

    mpz_mul_2exp(TMP, S, 1);
    mpz_sub(TMP, TMP, M_plus);

    cmp = mpz_cmp(LHS, TMP);

    if(!cmp && !lsb && !is_subnormal) { /* !lsb implies that f is even */
      high = 1;
    }
    else {
      high = cmp > 0 ? 1 : 0;
    }

    if(!(!low && !high)) break;

    out[k_start - k] = 48 + u;

  }                                   /* close while loop */

  /* Next we set the final digit, rounding up where appropriate */

  if(low && !high) out[k_start - k] = 48 + u;
  if(!low && high) out[k_start - k] = 49 + u;
  if(low && high) {
    mpz_mul_2exp(LHS, R, 1);
    cmp = mpz_cmp(LHS, S);
    if(cmp < 0)    out[k_start - k] = 48 + u;
    if(cmp > 0)    out[k_start - k] = 49 + u;
    if(cmp == 0) {
      if(u & 1)    out[k_start - k] = 49 + u;
      else         out[k_start - k] = 48 + u;
    }
  }

  mpz_clear(R);
  mpz_clear(S);
  mpz_clear(M_plus);
  mpz_clear(M_minus);
  mpz_clear(LHS);
  mpz_clear(TMP);

  /*********************
   * Format the result *
   *********************/

  len = strlen(out);
  critical = k + len; /* "critical" is critical only wrt the formatting of the output string */

  /* printf("sign: %d critical: %d len %d k %d\n", sign, critical, len, k); */

  if(critical < -3) {

    sprintf(str, "e%03d", critical - 1);
    if(sign || len > 1) {
      /* insert decimal point */
      for(skip = len + sign; skip > 1 + sign; skip--) {
        out[skip] = out[skip - 1 - sign];
      }

      out[1 + sign] = '.';
      out[len + 1 + sign] = 0;

      if(sign) {
        out[1] = out[0];
        out[0] = '-';
      }
    }
    strcat(out, str);
    ST(0) = sv_2mortal(newSVpv(out, 0));
    Safefree(out);
    XSRETURN(1);
  }

  if(critical <= 0 ) {
    /* bstr = concatenate "0." . ("0" x -critical) . out; */
    Newxz(bstr, (int)(16 + ceil(0.30103 * bits)), char); /* 1 + ceil(log(2) / log(10) * bits),
                                                        but allow a few extra for exponent and sign */

    if(bstr == NULL) croak("Failed to allocate memory for 2nd output string in nvtoa XSub");

    if(sign) bstr[0] = '-';

    bstr[0 + sign] = '0';
    bstr[1 + sign] = '.';

    sign += 2;

    for(skip = critical; skip < 0; skip++) {
      bstr[sign] = '0';
      sign++;
    }

    bstr[sign] = 0;
    strcat(bstr, out);

    ST(0) = sv_2mortal(newSVpv(bstr, 0));
    Safefree(out);
    Safefree(bstr);
    XSRETURN(1);
  }

  if(critical < MATH_MPFR_MAX_DIG) {
    if(sign) {
      for(skip = len; skip > 0; skip--) out[skip] = out[skip - 1];
      out[0] = '-';
      out[len + 1] = 0;
    }

   if(k >= 0) {
      /* out = concatenate out . ('0' x k); */
      for(skip = 0; skip < k; skip++) out[len + skip + sign] = '0';
      out[len + k + sign] = '.';
      out[len + k + sign + 1] = '0';
      out[len + k + sign + 2] = 0;
      ST(0) = sv_2mortal(newSVpv(out, 0));
      Safefree(out);
      XSRETURN(1);
    }

    /* insert decimal point; */
    for(skip = len + sign; skip > len + k + sign; skip--) out[skip] = out[skip - 1];
    out[len + k + sign] = '.';
    out[len + sign + 1] = 0;
    ST(0) = sv_2mortal(newSVpv(out, 0));
    Safefree(out);
    XSRETURN(1);
  }

  if( len > 1) {
    /* insert decimal point */
    for(skip = len + sign; skip > 1 + sign; skip--) {
      out[skip] = out[skip - 1 - sign];
    }

    out[1 + sign] = '.';
    out[len + 1 + sign] = 0;
  }

  if(sign) {
    out[1] = out[0];
    out[0] = '-';
  }

  sprintf(str, "e+%d", critical - 1);
  strcat(out, str);

  ST(0) = sv_2mortal(newSVpv(out, 0));
  Safefree(out);
  XSRETURN(1);

}



#line 8872 "MPFR.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 9016 "MPFR.c"

XS_EUPXS(XS_Math__MPFR__has_inttypes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_inttypes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_inttypes();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_NNW_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_NNW_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 8874 "MPFR.xs"
  RETVAL = NNW_val (aTHX);
#line 9046 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_NOK_POK_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_NOK_POK_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 8881 "MPFR.xs"
  RETVAL = NOK_POK_val (aTHX);
#line 9064 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__win32_infnanstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__win32_infnanstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	char *	s = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _win32_infnanstring(s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	round = ST(0)
;
#line 8893 "MPFR.xs"
        I32* temp;
#line 9103 "MPFR.c"
#line 8895 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_default_rounding_mode(aTHX_ round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9114 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned long	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_get_default_rounding_mode();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_prec_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_prec_round)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, prec, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8915 "MPFR.xs"
  RETVAL = Rmpfr_prec_round (aTHX_ p, prec, round);
#line 9154 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 8922 "MPFR.xs"
        I32* temp;
#line 9175 "MPFR.c"
#line 8924 "MPFR.xs"
        temp = PL_markstack_ptr++;
        DESTROY(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9186 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 8938 "MPFR.xs"
        I32* temp;
#line 9206 "MPFR.c"
#line 8940 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9217 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_mpfr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_mpfr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 8954 "MPFR.xs"
        I32* temp;
#line 9237 "MPFR.c"
#line 8956 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_mpfr(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9248 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_ptr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 8970 "MPFR.xs"
        I32* temp;
#line 9268 "MPFR.c"
#line 8972 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_ptr(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9279 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clears); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clears)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "p, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	p = ST(0)
;
#line 8986 "MPFR.xs"
        I32* temp;
#line 9299 "MPFR.c"
#line 8988 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clears(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9310 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9001 "MPFR.xs"
  RETVAL = Rmpfr_init (aTHX);
#line 9327 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 9009 "MPFR.xs"
  RETVAL = Rmpfr_init2 (aTHX_ prec);
#line 9347 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9015 "MPFR.xs"
  RETVAL = Rmpfr_init_nobless (aTHX);
#line 9365 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init2_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init2_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 9023 "MPFR.xs"
  RETVAL = Rmpfr_init2_nobless (aTHX_ prec);
#line 9385 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9031 "MPFR.xs"
        I32* temp;
#line 9408 "MPFR.c"
#line 9033 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9419 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9048 "MPFR.xs"
        I32* temp;
#line 9441 "MPFR.c"
#line 9050 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ui(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9452 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9065 "MPFR.xs"
        I32* temp;
#line 9474 "MPFR.c"
#line 9067 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_si(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9485 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9082 "MPFR.xs"
        I32* temp;
#line 9507 "MPFR.c"
#line 9084 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_d(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9518 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9099 "MPFR.xs"
        I32* temp;
#line 9540 "MPFR.c"
#line 9101 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ld(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9551 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9116 "MPFR.xs"
        I32* temp;
#line 9573 "MPFR.c"
#line 9118 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_f(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9584 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9133 "MPFR.xs"
        I32* temp;
#line 9606 "MPFR.c"
#line 9135 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_z(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9617 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9150 "MPFR.xs"
        I32* temp;
#line 9639 "MPFR.c"
#line 9152 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_q(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9650 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "q, base, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
#line 9168 "MPFR.xs"
        I32* temp;
#line 9674 "MPFR.c"
#line 9170 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_str(aTHX_ q, base, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9685 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9185 "MPFR.xs"
        I32* temp;
#line 9707 "MPFR.c"
#line 9187 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9718 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9202 "MPFR.xs"
        I32* temp;
#line 9740 "MPFR.c"
#line 9204 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ui_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9751 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9219 "MPFR.xs"
        I32* temp;
#line 9773 "MPFR.c"
#line 9221 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_si_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9784 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9236 "MPFR.xs"
        I32* temp;
#line 9806 "MPFR.c"
#line 9238 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_d_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9817 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9253 "MPFR.xs"
        I32* temp;
#line 9839 "MPFR.c"
#line 9255 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ld_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9850 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9270 "MPFR.xs"
        I32* temp;
#line 9872 "MPFR.c"
#line 9272 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_f_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9883 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9287 "MPFR.xs"
        I32* temp;
#line 9905 "MPFR.c"
#line 9289 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_z_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9916 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9304 "MPFR.xs"
        I32* temp;
#line 9938 "MPFR.c"
#line 9306 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_q_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9949 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str_nobless)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "q, base, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
#line 9322 "MPFR.xs"
        I32* temp;
#line 9973 "MPFR.c"
#line 9324 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_str_nobless(aTHX_ q, base, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9984 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_deref2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_deref2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, n_digits, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	n_digits = ST(2)
;
	SV *	round = ST(3)
;
#line 9341 "MPFR.xs"
        I32* temp;
#line 10010 "MPFR.c"
#line 9343 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_deref2(aTHX_ p, base, n_digits, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10021 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	prec = ST(0)
;
#line 9357 "MPFR.xs"
        I32* temp;
#line 10041 "MPFR.c"
#line 9359 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_default_prec(aTHX_ prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10052 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_prec)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9372 "MPFR.xs"
  RETVAL = Rmpfr_get_default_prec (aTHX);
#line 10069 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_min_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_min_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 9380 "MPFR.xs"
  RETVAL = Rmpfr_min_prec (aTHX_ x);
#line 10089 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 9388 "MPFR.xs"
        I32* temp;
#line 10112 "MPFR.c"
#line 9390 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_prec(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10123 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec_raw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 9405 "MPFR.xs"
        I32* temp;
#line 10145 "MPFR.c"
#line 9407 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_prec_raw(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10156 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 9421 "MPFR.xs"
  RETVAL = Rmpfr_get_prec (aTHX_ p);
#line 10175 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9430 "MPFR.xs"
  RETVAL = Rmpfr_set (aTHX_ p, q, round);
#line 10199 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9439 "MPFR.xs"
  RETVAL = Rmpfr_set_ui (aTHX_ p, q, round);
#line 10223 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9448 "MPFR.xs"
  RETVAL = Rmpfr_set_si (aTHX_ p, q, round);
#line 10247 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9457 "MPFR.xs"
  RETVAL = Rmpfr_set_uj (aTHX_ p, q, round);
#line 10271 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9466 "MPFR.xs"
  RETVAL = Rmpfr_set_sj (aTHX_ p, q, round);
#line 10295 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_NV)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	unsigned int	round = (unsigned int)SvUV(ST(2))
;
	SV *	RETVAL;
#line 9475 "MPFR.xs"
  RETVAL = Rmpfr_set_NV (aTHX_ p, q, round);
#line 10319 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 9483 "MPFR.xs"
  RETVAL = Rmpfr_cmp_NV (aTHX_ a, b);
#line 10342 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ld)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9492 "MPFR.xs"
  RETVAL = Rmpfr_set_ld (aTHX_ p, q, round);
#line 10365 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_d)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9501 "MPFR.xs"
  RETVAL = Rmpfr_set_d (aTHX_ p, q, round);
#line 10389 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9510 "MPFR.xs"
  RETVAL = Rmpfr_set_z (aTHX_ p, q, round);
#line 10413 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_q)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9519 "MPFR.xs"
  RETVAL = Rmpfr_set_q (aTHX_ p, q, round);
#line 10437 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9528 "MPFR.xs"
  RETVAL = Rmpfr_set_f (aTHX_ p, q, round);
#line 10461 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, num, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	num = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 9538 "MPFR.xs"
  RETVAL = Rmpfr_set_str (aTHX_ p, num, base, round);
#line 10488 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, sign");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	sign = (int)SvIV(ST(1))
;
#line 9546 "MPFR.xs"
        I32* temp;
#line 10510 "MPFR.c"
#line 9548 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_inf(p, sign);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10521 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nan)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 9562 "MPFR.xs"
        I32* temp;
#line 10541 "MPFR.c"
#line 9564 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_nan(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10552 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_swap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_swap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, q");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 9579 "MPFR.xs"
        I32* temp;
#line 10574 "MPFR.c"
#line 9581 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_swap(p, q);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10585 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 9596 "MPFR.xs"
  RETVAL = Rmpfr_get_d (aTHX_ p, round);
#line 10606 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "exp, p, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9605 "MPFR.xs"
  RETVAL = Rmpfr_get_d_2exp (aTHX_ exp, p, round);
#line 10630 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "exp, p, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9614 "MPFR.xs"
  RETVAL = Rmpfr_get_ld_2exp (aTHX_ exp, p, round);
#line 10654 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 9622 "MPFR.xs"
  RETVAL = Rmpfr_get_ld (aTHX_ p, round);
#line 10676 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d1)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_get_d1(p);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z_2exp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "z, p");
    {
	mpz_t *            z = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	RETVAL;
#line 9634 "MPFR.xs"
  RETVAL = Rmpfr_get_z_2exp (aTHX_ z, p);
#line 10717 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9644 "MPFR.xs"
  RETVAL = Rmpfr_add (aTHX_ a, b, c, round);
#line 10743 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9654 "MPFR.xs"
  RETVAL = Rmpfr_add_ui (aTHX_ a, b, c, round);
#line 10769 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9664 "MPFR.xs"
  RETVAL = Rmpfr_add_d (aTHX_ a, b, c, round);
#line 10795 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9674 "MPFR.xs"
  RETVAL = Rmpfr_add_si (aTHX_ a, b, c, round);
#line 10821 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9684 "MPFR.xs"
  RETVAL = Rmpfr_add_z (aTHX_ a, b, c, round);
#line 10847 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9694 "MPFR.xs"
  RETVAL = Rmpfr_add_q (aTHX_ a, b, c, round);
#line 10873 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9704 "MPFR.xs"
  RETVAL = Rmpfr_sub (aTHX_ a, b, c, round);
#line 10899 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9714 "MPFR.xs"
  RETVAL = Rmpfr_sub_ui (aTHX_ a, b, c, round);
#line 10925 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9724 "MPFR.xs"
  RETVAL = Rmpfr_sub_d (aTHX_ a, b, c, round);
#line 10951 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9734 "MPFR.xs"
  RETVAL = Rmpfr_sub_z (aTHX_ a, b, c, round);
#line 10977 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9744 "MPFR.xs"
  RETVAL = Rmpfr_sub_q (aTHX_ a, b, c, round);
#line 11003 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9754 "MPFR.xs"
  RETVAL = Rmpfr_ui_sub (aTHX_ a, b, c, round);
#line 11029 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_d_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_d_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9764 "MPFR.xs"
  RETVAL = Rmpfr_d_sub (aTHX_ a, b, c, round);
#line 11055 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9774 "MPFR.xs"
  RETVAL = Rmpfr_mul (aTHX_ a, b, c, round);
#line 11081 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9784 "MPFR.xs"
  RETVAL = Rmpfr_mul_ui (aTHX_ a, b, c, round);
#line 11107 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9794 "MPFR.xs"
  RETVAL = Rmpfr_mul_d (aTHX_ a, b, c, round);
#line 11133 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9804 "MPFR.xs"
  RETVAL = Rmpfr_mul_z (aTHX_ a, b, c, round);
#line 11159 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9814 "MPFR.xs"
  RETVAL = Rmpfr_mul_q (aTHX_ a, b, c, round);
#line 11185 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dim)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9824 "MPFR.xs"
  RETVAL = Rmpfr_dim (aTHX_ rop, op1, op2, round);
#line 11211 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9834 "MPFR.xs"
  RETVAL = Rmpfr_div (aTHX_ a, b, c, round);
#line 11237 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9844 "MPFR.xs"
  RETVAL = Rmpfr_div_ui (aTHX_ a, b, c, round);
#line 11263 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9854 "MPFR.xs"
  RETVAL = Rmpfr_div_d (aTHX_ a, b, c, round);
#line 11289 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9864 "MPFR.xs"
  RETVAL = Rmpfr_div_z (aTHX_ a, b, c, round);
#line 11315 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9874 "MPFR.xs"
  RETVAL = Rmpfr_div_q (aTHX_ a, b, c, round);
#line 11341 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9884 "MPFR.xs"
  RETVAL = Rmpfr_ui_div (aTHX_ a, b, c, round);
#line 11367 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_d_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_d_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9894 "MPFR.xs"
  RETVAL = Rmpfr_d_div (aTHX_ a, b, c, round);
#line 11393 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9903 "MPFR.xs"
  RETVAL = Rmpfr_sqrt (aTHX_ a, b, round);
#line 11417 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9912 "MPFR.xs"
  RETVAL = Rmpfr_rec_sqrt (aTHX_ a, b, round);
#line 11441 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cbrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cbrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9921 "MPFR.xs"
  RETVAL = Rmpfr_cbrt (aTHX_ a, b, round);
#line 11465 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9930 "MPFR.xs"
  RETVAL = Rmpfr_sqrt_ui (aTHX_ a, b, round);
#line 11489 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9940 "MPFR.xs"
  RETVAL = Rmpfr_pow_ui (aTHX_ a, b, c, round);
#line 11515 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9950 "MPFR.xs"
  RETVAL = Rmpfr_ui_pow_ui (aTHX_ a, b, c, round);
#line 11541 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9960 "MPFR.xs"
  RETVAL = Rmpfr_ui_pow (aTHX_ a, b, c, round);
#line 11567 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9970 "MPFR.xs"
  RETVAL = Rmpfr_pow_si (aTHX_ a, b, c, round);
#line 11593 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9980 "MPFR.xs"
  RETVAL = Rmpfr_pow (aTHX_ a, b, c, round);
#line 11619 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_neg)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9989 "MPFR.xs"
  RETVAL = Rmpfr_neg (aTHX_ a, b, round);
#line 11643 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9998 "MPFR.xs"
  RETVAL = Rmpfr_abs (aTHX_ a, b, round);
#line 11667 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10008 "MPFR.xs"
  RETVAL = Rmpfr_mul_2exp (aTHX_ a, b, c, round);
#line 11693 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10018 "MPFR.xs"
  RETVAL = Rmpfr_mul_2ui (aTHX_ a, b, c, round);
#line 11719 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10028 "MPFR.xs"
  RETVAL = Rmpfr_mul_2si (aTHX_ a, b, c, round);
#line 11745 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10038 "MPFR.xs"
  RETVAL = Rmpfr_div_2exp (aTHX_ a, b, c, round);
#line 11771 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10048 "MPFR.xs"
  RETVAL = Rmpfr_div_2ui (aTHX_ a, b, c, round);
#line 11797 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10058 "MPFR.xs"
  RETVAL = Rmpfr_div_2si (aTHX_ a, b, c, round);
#line 11823 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmpabs(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	b = (unsigned long)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_ui(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	double	b = (double)SvNV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_d(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 10086 "MPFR.xs"
  RETVAL = Rmpfr_cmp_ld (aTHX_ a, b);
#line 11930 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	long	b = (long)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_si(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 10100 "MPFR.xs"
  RETVAL = Rmpfr_cmp_ui_2exp (aTHX_ a, b, c);
#line 11975 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 10109 "MPFR.xs"
  RETVAL = Rmpfr_cmp_si_2exp (aTHX_ a, b, c);
#line 11999 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_eq(a, b, c);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nan_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nan_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nan_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inf_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inf_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_inf_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_number_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_number_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_number_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_reldiff); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_reldiff)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 10137 "MPFR.xs"
        I32* temp;
#line 12105 "MPFR.c"
#line 10139 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_reldiff(aTHX_ a, b, c, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12116 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sgn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sgn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_sgn(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_greater_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_greater_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_greater_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_greaterequal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_greaterequal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_greaterequal_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_less_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_less_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_less_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lessequal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lessequal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_lessequal_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lessgreater_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lessgreater_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_lessgreater_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_equal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_equal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_equal_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_unordered_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_unordered_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_unordered_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sin_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sin_cos)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10195 "MPFR.xs"
  RETVAL = Rmpfr_sin_cos (aTHX_ a, b, c, round);
#line 12307 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh_cosh)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10205 "MPFR.xs"
  RETVAL = Rmpfr_sinh_cosh (aTHX_ a, b, c, round);
#line 12333 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10214 "MPFR.xs"
  RETVAL = Rmpfr_sin (aTHX_ a, b, round);
#line 12357 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10223 "MPFR.xs"
  RETVAL = Rmpfr_cos (aTHX_ a, b, round);
#line 12381 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10232 "MPFR.xs"
  RETVAL = Rmpfr_tan (aTHX_ a, b, round);
#line 12405 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10241 "MPFR.xs"
  RETVAL = Rmpfr_asin (aTHX_ a, b, round);
#line 12429 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10250 "MPFR.xs"
  RETVAL = Rmpfr_acos (aTHX_ a, b, round);
#line 12453 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10259 "MPFR.xs"
  RETVAL = Rmpfr_atan (aTHX_ a, b, round);
#line 12477 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10268 "MPFR.xs"
  RETVAL = Rmpfr_sinh (aTHX_ a, b, round);
#line 12501 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10277 "MPFR.xs"
  RETVAL = Rmpfr_cosh (aTHX_ a, b, round);
#line 12525 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10286 "MPFR.xs"
  RETVAL = Rmpfr_tanh (aTHX_ a, b, round);
#line 12549 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10295 "MPFR.xs"
  RETVAL = Rmpfr_asinh (aTHX_ a, b, round);
#line 12573 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10304 "MPFR.xs"
  RETVAL = Rmpfr_acosh (aTHX_ a, b, round);
#line 12597 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10313 "MPFR.xs"
  RETVAL = Rmpfr_atanh (aTHX_ a, b, round);
#line 12621 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fac_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fac_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10322 "MPFR.xs"
  RETVAL = Rmpfr_fac_ui (aTHX_ a, b, round);
#line 12645 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log1p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log1p)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10331 "MPFR.xs"
  RETVAL = Rmpfr_log1p (aTHX_ a, b, round);
#line 12669 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_expm1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_expm1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10340 "MPFR.xs"
  RETVAL = Rmpfr_expm1 (aTHX_ a, b, round);
#line 12693 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10349 "MPFR.xs"
  RETVAL = Rmpfr_log2 (aTHX_ a, b, round);
#line 12717 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10358 "MPFR.xs"
  RETVAL = Rmpfr_log10 (aTHX_ a, b, round);
#line 12741 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fma)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            d = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 10369 "MPFR.xs"
  RETVAL = Rmpfr_fma (aTHX_ a, b, c, d, round);
#line 12769 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fms)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            d = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 10380 "MPFR.xs"
  RETVAL = Rmpfr_fms (aTHX_ a, b, c, d, round);
#line 12797 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_agm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_agm)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10390 "MPFR.xs"
  RETVAL = Rmpfr_agm (aTHX_ a, b, c, round);
#line 12823 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_hypot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_hypot)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10400 "MPFR.xs"
  RETVAL = Rmpfr_hypot (aTHX_ a, b, c, round);
#line 12849 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_log2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_log2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 10408 "MPFR.xs"
  RETVAL = Rmpfr_const_log2 (aTHX_ p, round);
#line 12871 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_pi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_pi)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 10416 "MPFR.xs"
  RETVAL = Rmpfr_const_pi (aTHX_ p, round);
#line 12893 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_euler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_euler)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 10424 "MPFR.xs"
  RETVAL = Rmpfr_const_euler (aTHX_ p, round);
#line 12915 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10433 "MPFR.xs"
  RETVAL = Rmpfr_rint (aTHX_ a, b, round);
#line 12939 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ceil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ceil)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_ceil(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_floor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_floor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_floor(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_round)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_round(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_trunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_trunc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_trunc(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_can_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_can_round)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "p, err, round1, round2, prec");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	err = ST(1)
;
	SV *	round1 = ST(2)
;
	SV *	round2 = ST(3)
;
	SV *	prec = ST(4)
;
	SV *	RETVAL;
#line 10464 "MPFR.xs"
  RETVAL = Rmpfr_can_round (aTHX_ p, err, round1, round2, prec);
#line 13051 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_print_rnd_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_print_rnd_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "rnd");
    {
	SV *	rnd = ST(0)
;
	SV *	RETVAL;
#line 10471 "MPFR.xs"
  RETVAL = Rmpfr_print_rnd_mode (aTHX_ rnd);
#line 13071 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 10477 "MPFR.xs"
  RETVAL = Rmpfr_get_emin (aTHX);
#line 13089 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 10484 "MPFR.xs"
  RETVAL = Rmpfr_get_emax (aTHX);
#line 13107 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "e");
    {
	SV *	e = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 10492 "MPFR.xs"
  RETVAL = Rmpfr_set_emin (aTHX_ e);
#line 13128 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emax)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "e");
    {
	SV *	e = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 10499 "MPFR.xs"
  RETVAL = Rmpfr_set_emax (aTHX_ e);
#line 13148 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_check_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_check_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, t, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	t = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10508 "MPFR.xs"
  RETVAL = Rmpfr_check_range (aTHX_ p, t, round);
#line 13171 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_underflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_underflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10515 "MPFR.xs"
        I32* temp;
#line 13190 "MPFR.c"
#line 10517 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_underflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13201 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_overflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10531 "MPFR.xs"
        I32* temp;
#line 13219 "MPFR.c"
#line 10533 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_overflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13230 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_nanflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_nanflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10547 "MPFR.xs"
        I32* temp;
#line 13248 "MPFR.c"
#line 10549 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_nanflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13259 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_inexflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_inexflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10563 "MPFR.xs"
        I32* temp;
#line 13277 "MPFR.c"
#line 10565 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_inexflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13288 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_flags)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10579 "MPFR.xs"
        I32* temp;
#line 13306 "MPFR.c"
#line 10581 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_flags();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13317 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_underflow_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_underflow_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_underflow_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_overflow_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_overflow_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_overflow_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nanflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nanflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nanflag_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inexflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inexflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_inexflag_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10613 "MPFR.xs"
  RETVAL = Rmpfr_log (aTHX_ a, b, round);
#line 13408 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10622 "MPFR.xs"
  RETVAL = Rmpfr_exp (aTHX_ a, b, round);
#line 13432 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10631 "MPFR.xs"
  RETVAL = Rmpfr_exp2 (aTHX_ a, b, round);
#line 13456 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10640 "MPFR.xs"
  RETVAL = Rmpfr_exp10 (aTHX_ a, b, round);
#line 13480 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_urandomb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_urandomb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "x, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	x = ST(0)
;
#line 10647 "MPFR.xs"
        I32* temp;
#line 13501 "MPFR.c"
#line 10649 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_urandomb(aTHX_ x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13512 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_random2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_random2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, s, exp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	s = ST(1)
;
	SV *	exp = ST(2)
;
#line 10665 "MPFR.xs"
        I32* temp;
#line 13536 "MPFR.c"
#line 10667 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_random2(aTHX_ p, s, exp);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13547 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_str)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "stream, base, dig, p, round");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 10685 "MPFR.xs"
  RETVAL = _TRmpfr_out_str (aTHX_ stream, base, dig, p, round);
#line 13574 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, dig, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10695 "MPFR.xs"
  RETVAL = _Rmpfr_out_str (aTHX_ p, base, dig, round);
#line 13600 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "stream, base, dig, p, round, suff");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 10707 "MPFR.xs"
  RETVAL = _TRmpfr_out_strS (aTHX_ stream, base, dig, p, round, suff);
#line 13630 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strP)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	RETVAL;
#line 10719 "MPFR.xs"
  RETVAL = _TRmpfr_out_strP (aTHX_ pre, stream, base, dig, p, round);
#line 13660 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round, suff");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	suff = ST(6)
;
	SV *	RETVAL;
#line 10732 "MPFR.xs"
  RETVAL = _TRmpfr_out_strPS (aTHX_ pre, stream, base, dig, p, round, suff);
#line 13692 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strS)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "p, base, dig, round, suff");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	SV *	round = ST(3)
;
	SV *	suff = ST(4)
;
	SV *	RETVAL;
#line 10743 "MPFR.xs"
  RETVAL = _Rmpfr_out_strS (aTHX_ p, base, dig, round, suff);
#line 13720 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strP)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "pre, p, base, dig, round");
    {
	SV *	pre = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 10754 "MPFR.xs"
  RETVAL = _Rmpfr_out_strP (aTHX_ pre, p, base, dig, round);
#line 13748 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, p, base, dig, round, suff");
    {
	SV *	pre = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 10766 "MPFR.xs"
  RETVAL = _Rmpfr_out_strPS (aTHX_ pre, p, base, dig, round, suff);
#line 13778 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_TRmpfr_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_TRmpfr_inp_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, stream, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10776 "MPFR.xs"
  RETVAL = TRmpfr_inp_str (aTHX_ p, stream, base, round);
#line 13804 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inp_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10785 "MPFR.xs"
  RETVAL = Rmpfr_inp_str (aTHX_ p, base, round);
#line 13828 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10794 "MPFR.xs"
  RETVAL = Rmpfr_gamma (aTHX_ a, b, round);
#line 13852 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10803 "MPFR.xs"
  RETVAL = Rmpfr_zeta (aTHX_ a, b, round);
#line 13876 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10812 "MPFR.xs"
  RETVAL = Rmpfr_zeta_ui (aTHX_ a, b, round);
#line 13900 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10821 "MPFR.xs"
  RETVAL = Rmpfr_erf (aTHX_ a, b, round);
#line 13924 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_frac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_frac)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10830 "MPFR.xs"
  RETVAL = Rmpfr_frac (aTHX_ a, b, round);
#line 13948 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_remainder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_remainder)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10840 "MPFR.xs"
  RETVAL = Rmpfr_remainder (aTHX_ a, b, c, round);
#line 13974 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_modf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_modf)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10850 "MPFR.xs"
  RETVAL = Rmpfr_modf (aTHX_ a, b, c, round);
#line 14000 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10860 "MPFR.xs"
  RETVAL = Rmpfr_fmod (aTHX_ a, b, c, round);
#line 14026 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_remquo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_remquo)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 10870 "MPFR.xs"
        I32* temp;
#line 14053 "MPFR.c"
#line 10872 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_remquo(aTHX_ a, b, c, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14064 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_integer_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_integer_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_integer_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nexttoward); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nexttoward)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 10891 "MPFR.xs"
        I32* temp;
#line 14105 "MPFR.c"
#line 10893 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_nexttoward(a, b);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14116 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nextabove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nextabove)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 10907 "MPFR.xs"
        I32* temp;
#line 14136 "MPFR.c"
#line 10909 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_nextabove(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14147 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nextbelow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nextbelow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 10923 "MPFR.xs"
        I32* temp;
#line 14167 "MPFR.c"
#line 10925 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_nextbelow(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14178 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_min)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10942 "MPFR.xs"
  RETVAL = Rmpfr_min (aTHX_ a, b, c, round);
#line 14203 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_max)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10952 "MPFR.xs"
  RETVAL = Rmpfr_max (aTHX_ a, b, c, round);
#line 14229 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_exp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 10959 "MPFR.xs"
  RETVAL = Rmpfr_get_exp (aTHX_ p);
#line 14249 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_exp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, exp");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	exp = ST(1)
;
	SV *	RETVAL;
#line 10967 "MPFR.xs"
  RETVAL = Rmpfr_set_exp (aTHX_ p, exp);
#line 14271 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_signbit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_signbit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_signbit(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_setsign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_setsign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, sign, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	sign = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10981 "MPFR.xs"
  RETVAL = Rmpfr_setsign (aTHX_ rop, op, sign, round);
#line 14316 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_copysign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_copysign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10991 "MPFR.xs"
  RETVAL = Rmpfr_copysign (aTHX_ rop, op1, op2, round);
#line 14342 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_get_refcnt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_get_refcnt)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	SV *	s = ST(0)
;
	SV *	RETVAL;
#line 10998 "MPFR.xs"
  RETVAL = get_refcnt (aTHX_ s);
#line 14362 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_get_package_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_get_package_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 11005 "MPFR.xs"
  RETVAL = get_package_name (aTHX_ x);
#line 14382 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 11012 "MPFR.xs"
        I32* temp;
#line 14403 "MPFR.c"
#line 11014 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_dump(a);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14414 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_gmp_v); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_gmp_v)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11027 "MPFR.xs"
  RETVAL = gmp_v (aTHX);
#line 14431 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11038 "MPFR.xs"
  RETVAL = Rmpfr_set_ui_2exp (aTHX_ a, b, c, round);
#line 14457 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11048 "MPFR.xs"
  RETVAL = Rmpfr_set_si_2exp (aTHX_ a, b, c, round);
#line 14483 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11058 "MPFR.xs"
  RETVAL = Rmpfr_set_uj_2exp (aTHX_ a, b, c, round);
#line 14509 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11068 "MPFR.xs"
  RETVAL = Rmpfr_set_sj_2exp (aTHX_ a, b, c, round);
#line 14535 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpz_t *            a = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11077 "MPFR.xs"
  RETVAL = Rmpfr_get_z (aTHX_ a, b, round);
#line 14559 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_si_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_si_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, c, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	c = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11087 "MPFR.xs"
  RETVAL = Rmpfr_si_sub (aTHX_ a, c, b, round);
#line 14585 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11097 "MPFR.xs"
  RETVAL = Rmpfr_sub_si (aTHX_ a, b, c, round);
#line 14611 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11107 "MPFR.xs"
  RETVAL = Rmpfr_mul_si (aTHX_ a, b, c, round);
#line 14637 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_si_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_si_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11117 "MPFR.xs"
  RETVAL = Rmpfr_si_div (aTHX_ a, b, c, round);
#line 14663 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11127 "MPFR.xs"
  RETVAL = Rmpfr_div_si (aTHX_ a, b, c, round);
#line 14689 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11136 "MPFR.xs"
  RETVAL = Rmpfr_sqr (aTHX_ a, b, round);
#line 14713 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_z)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            b = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_z(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_q(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            b = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_f(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zero_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zero_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_zero_p(a);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11162 "MPFR.xs"
        I32* temp;
#line 14814 "MPFR.c"
#line 11164 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_free_cache();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14825 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "way");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	way = (unsigned int)SvUV(ST(0))
;
#line 11178 "MPFR.xs"
        I32* temp;
#line 14845 "MPFR.c"
#line 11180 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_free_cache2(way);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14856 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_pool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_pool)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11194 "MPFR.xs"
        I32* temp;
#line 14874 "MPFR.c"
#line 11196 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_free_pool();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14885 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11209 "MPFR.xs"
  RETVAL = Rmpfr_get_version (aTHX);
#line 14902 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_patches); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_patches)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11216 "MPFR.xs"
  RETVAL = Rmpfr_get_patches (aTHX);
#line 14920 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_min)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11223 "MPFR.xs"
  RETVAL = Rmpfr_get_emin_min (aTHX);
#line 14938 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11230 "MPFR.xs"
  RETVAL = Rmpfr_get_emin_max (aTHX);
#line 14956 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_min)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11237 "MPFR.xs"
  RETVAL = Rmpfr_get_emax_min (aTHX);
#line 14974 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11244 "MPFR.xs"
  RETVAL = Rmpfr_get_emax_max (aTHX);
#line 14992 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_erangeflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_erangeflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11252 "MPFR.xs"
        I32* temp;
#line 15011 "MPFR.c"
#line 11254 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_erangeflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15022 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erangeflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erangeflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_erangeflag_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_round)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11274 "MPFR.xs"
  RETVAL = Rmpfr_rint_round (aTHX_ a, b, round);
#line 15062 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_trunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_trunc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11283 "MPFR.xs"
  RETVAL = Rmpfr_rint_trunc (aTHX_ a, b, round);
#line 15086 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_ceil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_ceil)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11292 "MPFR.xs"
  RETVAL = Rmpfr_rint_ceil (aTHX_ a, b, round);
#line 15110 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_floor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_floor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11301 "MPFR.xs"
  RETVAL = Rmpfr_rint_floor (aTHX_ a, b, round);
#line 15134 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11309 "MPFR.xs"
  RETVAL = Rmpfr_get_ui (aTHX_ a, round);
#line 15156 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11317 "MPFR.xs"
  RETVAL = Rmpfr_get_si (aTHX_ a, round);
#line 15178 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_uj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11325 "MPFR.xs"
  RETVAL = Rmpfr_get_uj (aTHX_ a, round);
#line 15200 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_sj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11333 "MPFR.xs"
  RETVAL = Rmpfr_get_sj (aTHX_ a, round);
#line 15222 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_IV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11341 "MPFR.xs"
  RETVAL = Rmpfr_get_IV (aTHX_ x, round);
#line 15244 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_UV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_UV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11349 "MPFR.xs"
  RETVAL = Rmpfr_get_UV (aTHX_ x, round);
#line 15266 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11357 "MPFR.xs"
  RETVAL = Rmpfr_get_NV (aTHX_ x, round);
#line 15288 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ulong_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ulong_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11365 "MPFR.xs"
  RETVAL = Rmpfr_fits_ulong_p (aTHX_ a, round);
#line 15310 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_slong_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_slong_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11373 "MPFR.xs"
  RETVAL = Rmpfr_fits_slong_p (aTHX_ a, round);
#line 15332 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ushort_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ushort_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11381 "MPFR.xs"
  RETVAL = Rmpfr_fits_ushort_p (aTHX_ a, round);
#line 15354 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sshort_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sshort_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11389 "MPFR.xs"
  RETVAL = Rmpfr_fits_sshort_p (aTHX_ a, round);
#line 15376 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uint_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uint_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11397 "MPFR.xs"
  RETVAL = Rmpfr_fits_uint_p (aTHX_ a, round);
#line 15398 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sint_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sint_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11405 "MPFR.xs"
  RETVAL = Rmpfr_fits_sint_p (aTHX_ a, round);
#line 15420 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uintmax_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uintmax_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11413 "MPFR.xs"
  RETVAL = Rmpfr_fits_uintmax_p (aTHX_ a, round);
#line 15442 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_intmax_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_intmax_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11421 "MPFR.xs"
  RETVAL = Rmpfr_fits_intmax_p (aTHX_ a, round);
#line 15464 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_IV_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_IV_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11429 "MPFR.xs"
  RETVAL = Rmpfr_fits_IV_p (aTHX_ x, round);
#line 15486 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_UV_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_UV_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11437 "MPFR.xs"
  RETVAL = Rmpfr_fits_UV_p (aTHX_ x, round);
#line 15508 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_strtofr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_strtofr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, str, base, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	str = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11447 "MPFR.xs"
  RETVAL = Rmpfr_strtofr (aTHX_ a, str, base, round);
#line 15534 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_erangeflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_erangeflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11454 "MPFR.xs"
        I32* temp;
#line 15553 "MPFR.c"
#line 11456 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_erangeflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15564 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_underflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_underflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11470 "MPFR.xs"
        I32* temp;
#line 15582 "MPFR.c"
#line 11472 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_underflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15593 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_overflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11486 "MPFR.xs"
        I32* temp;
#line 15611 "MPFR.c"
#line 11488 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_overflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15622 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nanflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nanflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11502 "MPFR.xs"
        I32* temp;
#line 15640 "MPFR.c"
#line 11504 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_nanflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15651 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inexflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inexflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11518 "MPFR.xs"
        I32* temp;
#line 15669 "MPFR.c"
#line 11520 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_inexflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15680 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erfc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erfc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11536 "MPFR.xs"
  RETVAL = Rmpfr_erfc (aTHX_ a, b, round);
#line 15703 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_j0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_j0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11545 "MPFR.xs"
  RETVAL = Rmpfr_j0 (aTHX_ a, b, round);
#line 15727 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_j1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_j1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11554 "MPFR.xs"
  RETVAL = Rmpfr_j1 (aTHX_ a, b, round);
#line 15751 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_jn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_jn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, n, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	n = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11564 "MPFR.xs"
  RETVAL = Rmpfr_jn (aTHX_ a, n, b, round);
#line 15777 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_y0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_y0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11573 "MPFR.xs"
  RETVAL = Rmpfr_y0 (aTHX_ a, b, round);
#line 15801 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_y1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_y1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11582 "MPFR.xs"
  RETVAL = Rmpfr_y1 (aTHX_ a, b, round);
#line 15825 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_yn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_yn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, n, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	n = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11592 "MPFR.xs"
  RETVAL = Rmpfr_yn (aTHX_ a, n, b, round);
#line 15851 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11602 "MPFR.xs"
  RETVAL = Rmpfr_atan2 (aTHX_ a, b, c, round);
#line 15877 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11612 "MPFR.xs"
  RETVAL = Rmpfr_pow_z (aTHX_ a, b, c, round);
#line 15903 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_subnormalize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_subnormalize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11621 "MPFR.xs"
  RETVAL = Rmpfr_subnormalize (aTHX_ a, b, round);
#line 15927 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_catalan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_catalan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11629 "MPFR.xs"
  RETVAL = Rmpfr_const_catalan (aTHX_ a, round);
#line 15949 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11638 "MPFR.xs"
  RETVAL = Rmpfr_sec (aTHX_ a, b, round);
#line 15973 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_csc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_csc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11647 "MPFR.xs"
  RETVAL = Rmpfr_csc (aTHX_ a, b, round);
#line 15997 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cot)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11656 "MPFR.xs"
  RETVAL = Rmpfr_cot (aTHX_ a, b, round);
#line 16021 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_root)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11666 "MPFR.xs"
  RETVAL = Rmpfr_root (aTHX_ a, b, c, round);
#line 16047 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_eint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_eint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11675 "MPFR.xs"
  RETVAL = Rmpfr_eint (aTHX_ a, b, round);
#line 16071 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_li2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_li2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11684 "MPFR.xs"
  RETVAL = Rmpfr_li2 (aTHX_ a, b, round);
#line 16095 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpf_t *            a = INT2PTR(mpf_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11693 "MPFR.xs"
  RETVAL = Rmpfr_get_f (aTHX_ a, b, round);
#line 16119 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 11701 "MPFR.xs"
        I32* temp;
#line 16142 "MPFR.c"
#line 11703 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_q(a, b);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16153 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sech); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sech)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11719 "MPFR.xs"
  RETVAL = Rmpfr_sech (aTHX_ a, b, round);
#line 16176 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_csch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_csch)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11728 "MPFR.xs"
  RETVAL = Rmpfr_csch (aTHX_ a, b, round);
#line 16200 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_coth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_coth)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11737 "MPFR.xs"
  RETVAL = Rmpfr_coth (aTHX_ a, b, round);
#line 16224 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lngamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lngamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11746 "MPFR.xs"
  RETVAL = Rmpfr_lngamma (aTHX_ a, b, round);
#line 16248 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lgamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lgamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 11755 "MPFR.xs"
        I32* temp;
#line 16273 "MPFR.c"
#line 11757 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_lgamma(aTHX_ a, b, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16284 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11770 "MPFR.xs"
  RETVAL = _MPFR_VERSION (aTHX);
#line 16301 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MAJOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MAJOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11777 "MPFR.xs"
  RETVAL = _MPFR_VERSION_MAJOR (aTHX);
#line 16319 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MINOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MINOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11784 "MPFR.xs"
  RETVAL = _MPFR_VERSION_MINOR (aTHX);
#line 16337 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11791 "MPFR.xs"
  RETVAL = _MPFR_VERSION_PATCHLEVEL (aTHX);
#line 16355 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_STRING); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_STRING)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11798 "MPFR.xs"
  RETVAL = _MPFR_VERSION_STRING (aTHX);
#line 16373 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_VERSION_NUM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_VERSION_NUM)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	RETVAL;
#line 11808 "MPFR.xs"
  RETVAL = RMPFR_VERSION_NUM (aTHX_ a, b, c);
#line 16397 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sum)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, avref, len, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	avref = ST(1)
;
	SV *	len = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11818 "MPFR.xs"
  RETVAL = Rmpfr_sum (aTHX_ rop, avref, len, round);
#line 16423 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__fr_to_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__fr_to_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, fr");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 11826 "MPFR.xs"
        I32* temp;
#line 16446 "MPFR.c"
#line 11828 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _fr_to_q(q, fr);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16457 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_q_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_q_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, q, fr, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_q_div(rop, q, fr, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_z_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_z_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, z, fr, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            z = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_z_div(rop, z, fr, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11858 "MPFR.xs"
  RETVAL = overload_mul (aTHX_ a, b, third);
#line 16530 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11867 "MPFR.xs"
  RETVAL = overload_add (aTHX_ a, b, third);
#line 16554 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11876 "MPFR.xs"
  RETVAL = overload_sub (aTHX_ a, b, third);
#line 16578 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11885 "MPFR.xs"
  RETVAL = overload_div (aTHX_ a, b, third);
#line 16602 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11894 "MPFR.xs"
  RETVAL = overload_copy (aTHX_ p, b, third);
#line 16626 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11903 "MPFR.xs"
  RETVAL = overload_abs (aTHX_ p, b, third);
#line 16650 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_gt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_gt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11912 "MPFR.xs"
  RETVAL = overload_gt (aTHX_ a, b, third);
#line 16674 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_gte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_gte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11921 "MPFR.xs"
  RETVAL = overload_gte (aTHX_ a, b, third);
#line 16698 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_lt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_lt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11930 "MPFR.xs"
  RETVAL = overload_lt (aTHX_ a, b, third);
#line 16722 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_lte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_lte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11939 "MPFR.xs"
  RETVAL = overload_lte (aTHX_ a, b, third);
#line 16746 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11948 "MPFR.xs"
  RETVAL = overload_spaceship (aTHX_ a, b, third);
#line 16770 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11957 "MPFR.xs"
  RETVAL = overload_equiv (aTHX_ a, b, third);
#line 16794 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_not_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_not_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11966 "MPFR.xs"
  RETVAL = overload_not_equiv (aTHX_ a, b, third);
#line 16818 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_true); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_true)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11975 "MPFR.xs"
  RETVAL = overload_true (aTHX_ a, b, third);
#line 16842 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_not)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11984 "MPFR.xs"
  RETVAL = overload_not (aTHX_ a, b, third);
#line 16866 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 11993 "MPFR.xs"
  RETVAL = overload_sqrt (aTHX_ p, b, third);
#line 16890 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	SV *	p = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12002 "MPFR.xs"
  RETVAL = overload_pow (aTHX_ p, b, third);
#line 16914 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12011 "MPFR.xs"
  RETVAL = overload_log (aTHX_ p, b, third);
#line 16938 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12020 "MPFR.xs"
  RETVAL = overload_exp (aTHX_ p, b, third);
#line 16962 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12029 "MPFR.xs"
  RETVAL = overload_sin (aTHX_ p, b, third);
#line 16986 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12038 "MPFR.xs"
  RETVAL = overload_cos (aTHX_ p, b, third);
#line 17010 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_int)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12047 "MPFR.xs"
  RETVAL = overload_int (aTHX_ p, b, third);
#line 17034 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_atan2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12056 "MPFR.xs"
  RETVAL = overload_atan2 (aTHX_ a, b, third);
#line 17058 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_default_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_default_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12062 "MPFR.xs"
  RETVAL = Rmpfr_randinit_default_nobless (aTHX);
#line 17076 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_mt_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_mt_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12069 "MPFR.xs"
  RETVAL = Rmpfr_randinit_mt_nobless (aTHX);
#line 17094 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, c, m2exp");
    {
	SV *	a = ST(0)
;
	SV *	c = ST(1)
;
	SV *	m2exp = ST(2)
;
	SV *	RETVAL;
#line 12079 "MPFR.xs"
  RETVAL = Rmpfr_randinit_lc_2exp_nobless (aTHX_ a, c, m2exp);
#line 17118 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "size");
    {
	SV *	size = ST(0)
;
	SV *	RETVAL;
#line 12086 "MPFR.xs"
  RETVAL = Rmpfr_randinit_lc_2exp_size_nobless (aTHX_ size);
#line 17138 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randclear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randclear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	p = ST(0)
;
#line 12093 "MPFR.xs"
        I32* temp;
#line 17159 "MPFR.c"
#line 12095 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_randclear(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 17170 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	state = ST(0)
;
	SV *	seed = ST(1)
;
#line 12110 "MPFR.xs"
        I32* temp;
#line 17192 "MPFR.c"
#line 12112 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_randseed(aTHX_ state, seed);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 17203 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	state = ST(0)
;
	SV *	seed = ST(1)
;
#line 12127 "MPFR.xs"
        I32* temp;
#line 17225 "MPFR.c"
#line 12129 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_randseed_ui(aTHX_ state, seed);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 17236 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_overload_pow_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_pow_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	SV *	p = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12145 "MPFR.xs"
  RETVAL = overload_pow_eq (aTHX_ p, b, third);
#line 17259 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_div_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_div_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12154 "MPFR.xs"
  RETVAL = overload_div_eq (aTHX_ a, b, third);
#line 17283 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sub_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sub_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12163 "MPFR.xs"
  RETVAL = overload_sub_eq (aTHX_ a, b, third);
#line 17307 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_add_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_add_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12172 "MPFR.xs"
  RETVAL = overload_add_eq (aTHX_ a, b, third);
#line 17331 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_mul_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_mul_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12181 "MPFR.xs"
  RETVAL = overload_mul_eq (aTHX_ a, b, third);
#line 17355 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__itsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__itsa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	SV *	a = ST(0)
;
	SV *	RETVAL;
#line 12188 "MPFR.xs"
  RETVAL = _itsa (aTHX_ a);
#line 17375 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_longlong); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_longlong)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longlong();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_longdouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_longdouble)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longdouble();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__ivsize_bits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ivsize_bits)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _ivsize_bits();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MAX); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MAX)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12209 "MPFR.xs"
  RETVAL = RMPFR_PREC_MAX (aTHX);
#line 17444 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MIN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MIN)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12216 "MPFR.xs"
  RETVAL = RMPFR_PREC_MIN (aTHX);
#line 17462 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	RETVAL;
#line 12228 "MPFR.xs"
  RETVAL = wrap_mpfr_printf (aTHX_ a, b);
#line 17484 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stream, a, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 12237 "MPFR.xs"
  RETVAL = wrap_mpfr_fprintf (aTHX_ stream, a, b);
#line 17508 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "s, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	int	buflen = (int)SvIV(ST(3))
;
	SV *	RETVAL;
#line 12247 "MPFR.xs"
  RETVAL = wrap_mpfr_sprintf (aTHX_ s, a, b, buflen);
#line 17534 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, bytes, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 12258 "MPFR.xs"
  RETVAL = wrap_mpfr_snprintf (aTHX_ s, bytes, a, b, buflen);
#line 17562 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf_rnd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, round, b");
    {
	SV *	a = ST(0)
;
	SV *	round = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 12267 "MPFR.xs"
  RETVAL = wrap_mpfr_printf_rnd (aTHX_ a, round, b);
#line 17586 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "stream, a, round, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	round = ST(2)
;
	SV *	b = ST(3)
;
	SV *	RETVAL;
#line 12277 "MPFR.xs"
  RETVAL = wrap_mpfr_fprintf_rnd (aTHX_ stream, a, round, b);
#line 17612 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, a, round, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	round = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 12288 "MPFR.xs"
  RETVAL = wrap_mpfr_sprintf_rnd (aTHX_ s, a, round, b, buflen);
#line 17640 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "s, bytes, a, round, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	round = ST(3)
;
	SV *	b = ST(4)
;
	int	buflen = (int)SvIV(ST(5))
;
	SV *	RETVAL;
#line 12300 "MPFR.xs"
  RETVAL = wrap_mpfr_snprintf_rnd (aTHX_ s, bytes, a, round, b, buflen);
#line 17670 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tls_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tls_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12306 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_tls_p (aTHX);
#line 17688 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_decimal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_decimal_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12313 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_decimal_p (aTHX);
#line 17706 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_regular_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_regular_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12321 "MPFR.xs"
  RETVAL = Rmpfr_regular_p (aTHX_ a);
#line 17726 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, sign");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sign = ST(1)
;
#line 12329 "MPFR.xs"
        I32* temp;
#line 17749 "MPFR.c"
#line 12331 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_zero(aTHX_ a, sign);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 17760 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_digamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_digamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12347 "MPFR.xs"
  RETVAL = Rmpfr_digamma (aTHX_ rop, op, round);
#line 17783 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ai); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ai)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12356 "MPFR.xs"
  RETVAL = Rmpfr_ai (aTHX_ rop, op, round);
#line 17807 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_flt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 12364 "MPFR.xs"
  RETVAL = Rmpfr_get_flt (aTHX_ a, round);
#line 17829 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_flt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, f, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	f = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12373 "MPFR.xs"
  RETVAL = Rmpfr_set_flt (aTHX_ rop, f, round);
#line 17853 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_urandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_urandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12382 "MPFR.xs"
  RETVAL = Rmpfr_urandom (aTHX_ rop, state, round);
#line 17877 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, exp, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            op = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	exp = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12392 "MPFR.xs"
  RETVAL = Rmpfr_set_z_2exp (aTHX_ rop, op, exp, round);
#line 17903 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tune_case); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tune_case)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12398 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_tune_case (aTHX);
#line 17921 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_frexp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_frexp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "exp, rop, op, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12409 "MPFR.xs"
  RETVAL = Rmpfr_frexp (aTHX_ exp, rop, op, round);
#line 17947 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_z_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_z_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            op1 = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12419 "MPFR.xs"
  RETVAL = Rmpfr_z_sub (aTHX_ rop, op1, op2, round);
#line 17973 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_grandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_grandom)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop1, rop2, state, round");
    {
	mpfr_t *            rop1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            rop2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12429 "MPFR.xs"
  RETVAL = Rmpfr_grandom (aTHX_ rop1, rop2, state, round);
#line 17999 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_divby0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_divby0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12436 "MPFR.xs"
        I32* temp;
#line 18018 "MPFR.c"
#line 12438 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_divby0(aTHX);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18029 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_divby0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_divby0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12452 "MPFR.xs"
        I32* temp;
#line 18047 "MPFR.c"
#line 12454 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_divby0(aTHX);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18058 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_divby0_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_divby0_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12467 "MPFR.xs"
  RETVAL = Rmpfr_divby0_p (aTHX);
#line 18075 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12474 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_gmpinternals_p (aTHX);
#line 18093 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__get_xs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__get_xs_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12481 "MPFR.xs"
  RETVAL = _get_xs_version (aTHX);
#line 18111 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_inc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12491 "MPFR.xs"
  RETVAL = overload_inc (aTHX_ a, b, third);
#line 18135 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_dec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	SV *	p = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12500 "MPFR.xs"
  RETVAL = overload_dec (aTHX_ p, b, third);
#line 18159 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__wrap_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__wrap_count)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12506 "MPFR.xs"
  RETVAL = _wrap_count (aTHX);
#line 18177 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_LD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_LD)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12516 "MPFR.xs"
  RETVAL = Rmpfr_set_LD (aTHX_ rop, op, rnd);
#line 18201 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12525 "MPFR.xs"
  RETVAL = Rmpfr_set_DECIMAL64 (aTHX_ rop, op, rnd);
#line 18225 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12534 "MPFR.xs"
  RETVAL = Rmpfr_set_DECIMAL128 (aTHX_ rop, op, rnd);
#line 18249 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_LD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_LD)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12543 "MPFR.xs"
        I32* temp;
#line 18274 "MPFR.c"
#line 12545 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_LD(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18285 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12561 "MPFR.xs"
        I32* temp;
#line 18309 "MPFR.c"
#line 12563 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_DECIMAL64(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18320 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12579 "MPFR.xs"
        I32* temp;
#line 18344 "MPFR.c"
#line 12581 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_DECIMAL128(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18355 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL_FLOATS();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL64();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_FLOAT128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__max_base); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__max_base)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12610 "MPFR.xs"
  RETVAL = _max_base (aTHX);
#line 18440 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__isobject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__isobject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 12618 "MPFR.xs"
  RETVAL = _isobject (aTHX_ x);
#line 18460 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mp_sizes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mp_sizes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12625 "MPFR.xs"
        I32* temp;
#line 18479 "MPFR.c"
#line 12627 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _mp_sizes();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18490 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ivsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ivsize)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12640 "MPFR.xs"
  RETVAL = _ivsize (aTHX);
#line 18507 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__nvsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__nvsize)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12647 "MPFR.xs"
  RETVAL = _nvsize (aTHX);
#line 18525 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__FLT128_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__FLT128_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12654 "MPFR.xs"
  RETVAL = _FLT128_DIG (aTHX);
#line 18543 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__LDBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__LDBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12661 "MPFR.xs"
  RETVAL = _LDBL_DIG (aTHX);
#line 18561 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__DBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__DBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12668 "MPFR.xs"
  RETVAL = _DBL_DIG (aTHX);
#line 18579 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__FLT128_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__FLT128_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12675 "MPFR.xs"
  RETVAL = _FLT128_MANT_DIG (aTHX);
#line 18597 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__LDBL_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__LDBL_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12682 "MPFR.xs"
  RETVAL = _LDBL_MANT_DIG (aTHX);
#line 18615 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__DBL_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__DBL_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12689 "MPFR.xs"
  RETVAL = _DBL_MANT_DIG (aTHX);
#line 18633 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "op, rnd");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	rnd = ST(1)
;
	SV *	RETVAL;
#line 12698 "MPFR.xs"
  RETVAL = Rmpfr_get_float128 (aTHX_ op, rnd);
#line 18655 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12707 "MPFR.xs"
        I32* temp;
#line 18680 "MPFR.c"
#line 12709 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_FLOAT128(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18691 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12725 "MPFR.xs"
  RETVAL = Rmpfr_set_FLOAT128 (aTHX_ rop, op, rnd);
#line 18714 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, q, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12734 "MPFR.xs"
  RETVAL = Rmpfr_set_float128 (aTHX_ rop, q, rnd);
#line 18738 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__is_readonly); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__is_readonly)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	SV *	RETVAL;
#line 12741 "MPFR.xs"
  RETVAL = _is_readonly (aTHX_ sv);
#line 18758 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__readonly_on); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__readonly_on)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 12748 "MPFR.xs"
        I32* temp;
#line 18779 "MPFR.c"
#line 12750 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _readonly_on(aTHX_ sv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18790 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__readonly_off); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__readonly_off)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 12764 "MPFR.xs"
        I32* temp;
#line 18810 "MPFR.c"
#line 12766 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _readonly_off(aTHX_ sv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18821 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__can_pass_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__can_pass_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _can_pass_float128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mpfr_want_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mpfr_want_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _mpfr_want_float128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nnumflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nnumflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nnumflag();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nok_pokflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nok_pokflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nok_pokflag();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_clear_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_clear_nnum)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12796 "MPFR.xs"
        I32* temp;
#line 18907 "MPFR.c"
#line 12798 "MPFR.xs"
        temp = PL_markstack_ptr++;
        clear_nnum();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18918 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_clear_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_clear_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12812 "MPFR.xs"
        I32* temp;
#line 18936 "MPFR.c"
#line 12814 "MPFR.xs"
        temp = PL_markstack_ptr++;
        clear_nok_pok();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18947 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_set_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_set_nnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 12828 "MPFR.xs"
        I32* temp;
#line 18967 "MPFR.c"
#line 12830 "MPFR.xs"
        temp = PL_markstack_ptr++;
        set_nnum(x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 18978 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_set_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_set_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 12844 "MPFR.xs"
        I32* temp;
#line 18998 "MPFR.c"
#line 12846 "MPFR.xs"
        temp = PL_markstack_ptr++;
        set_nok_pok(x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19009 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__d_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__d_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12861 "MPFR.xs"
        I32* temp;
#line 19031 "MPFR.c"
#line 12863 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _d_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19042 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__d_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__d_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12878 "MPFR.xs"
        I32* temp;
#line 19064 "MPFR.c"
#line 12880 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _d_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19075 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__dd_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__dd_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12895 "MPFR.xs"
        I32* temp;
#line 19097 "MPFR.c"
#line 12897 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _dd_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19108 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__dd_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__dd_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12912 "MPFR.xs"
        I32* temp;
#line 19130 "MPFR.c"
#line 12914 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _dd_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19141 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ld_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12929 "MPFR.xs"
        I32* temp;
#line 19163 "MPFR.c"
#line 12931 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _ld_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19174 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ld_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12946 "MPFR.xs"
        I32* temp;
#line 19196 "MPFR.c"
#line 12948 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _ld_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19207 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__f128_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__f128_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12963 "MPFR.xs"
        I32* temp;
#line 19229 "MPFR.c"
#line 12965 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _f128_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19240 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__f128_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__f128_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 12980 "MPFR.xs"
        I32* temp;
#line 19262 "MPFR.c"
#line 12982 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _f128_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19273 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__required_ldbl_mant_dig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__required_ldbl_mant_dig)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _required_ldbl_mant_dig();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__GMP_LIMB_BITS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__GMP_LIMB_BITS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12999 "MPFR.xs"
  RETVAL = _GMP_LIMB_BITS (aTHX);
#line 19307 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__GMP_NAIL_BITS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__GMP_NAIL_BITS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13006 "MPFR.xs"
  RETVAL = _GMP_NAIL_BITS (aTHX);
#line 19325 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmodquo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmodquo)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 13017 "MPFR.xs"
        I32* temp;
#line 19352 "MPFR.c"
#line 13019 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_fmodquo(aTHX_ a, b, c, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19363 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_export); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_export)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "stream, op");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;
#line 13034 "MPFR.xs"
  RETVAL = Rmpfr_fpif_export (aTHX_ stream, op);
#line 19385 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_import); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_import)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "op, stream");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	int	RETVAL;
	dXSTARG;
#line 13042 "MPFR.xs"
  RETVAL = Rmpfr_fpif_import (aTHX_ op, stream);
#line 19407 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	mask = (unsigned int)SvUV(ST(0))
;
#line 13049 "MPFR.xs"
        I32* temp;
#line 19427 "MPFR.c"
#line 13051 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_flags_clear(mask);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19438 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_set)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	mask = (unsigned int)SvUV(ST(0))
;
#line 13065 "MPFR.xs"
        I32* temp;
#line 19458 "MPFR.c"
#line 13067 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_flags_set(mask);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19469 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_test); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_test)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mask");
    {
	unsigned int	mask = (unsigned int)SvUV(ST(0))
;
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_flags_test(mask);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_save)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_flags_save();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_restore); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_restore)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "flags, mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	flags = (unsigned int)SvUV(ST(0))
;
	unsigned int	mask = (unsigned int)SvUV(ST(1))
;
#line 13090 "MPFR.xs"
        I32* temp;
#line 19527 "MPFR.c"
#line 13092 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_flags_restore(flags, mask);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 19538 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_roundeven); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_roundeven)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_rint_roundeven(rop, op, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_roundeven); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_roundeven)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_roundeven(rop, op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nrandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nrandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(1))))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nrandom(rop, state, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(1))))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_erandom(rop, state, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmma)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "rop, op1, op2, op3, op4, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            op3 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	mpfr_t *            op4 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	int	round = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_fmma(rop, op1, op2, op3, op4, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmms)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "rop, op1, op2, op3, op4, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            op3 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	mpfr_t *            op4 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	int	round = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_fmms(rop, op1, op2, op3, op4, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	op = (unsigned long)SvUV(ST(1))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_log_ui(rop, op, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma_inc)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_gamma_inc(rop, op1, op2, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__have_IEEE_754_long_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__have_IEEE_754_long_double)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _have_IEEE_754_long_double();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__have_extended_precision_long_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__have_extended_precision_long_double)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _have_extended_precision_long_double();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nanflag_bug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nanflag_bug)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nanflag_bug();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_float128_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_float128_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13171 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_float128_p (aTHX);
#line 19802 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_sharedcache_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_sharedcache_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13178 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_sharedcache_p (aTHX);
#line 19820 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__nv_is_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__nv_is_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _nv_is_float128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__SvNOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__SvNOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 13190 "MPFR.xs"
  RETVAL = _SvNOK (aTHX_ in);
#line 19858 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 13197 "MPFR.xs"
  RETVAL = _SvPOK (aTHX_ in);
#line 19878 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__lsb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__lsb)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 13204 "MPFR.xs"
  RETVAL = _lsb (aTHX_ a);
#line 19897 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_root)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, root, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	root = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 13214 "MPFR.xs"
  RETVAL = Rmpfr_rec_root (aTHX_ rop, op, root, round);
#line 19924 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_beta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_beta)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_beta(rop, op1, op2, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rootn_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rootn_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, k, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	k = (unsigned long)SvUV(ST(2))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_rootn_ui(rop, op, k, round);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__ld_subnormal_bug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_subnormal_bug)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _ld_subnormal_bug();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_atodouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_atodouble)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	char *	str = (char *)SvPV_nolen(ST(0))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = atodouble(str);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_atonv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_atonv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 13243 "MPFR.xs"
  RETVAL = atonv (aTHX_ str);
#line 20029 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_str_ndigits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_str_ndigits)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "base, prec");
    {
	int	base = (int)SvIV(ST(0))
;
	SV *	prec = ST(1)
;
	SV *	RETVAL;
#line 13251 "MPFR.xs"
  RETVAL = Rmpfr_get_str_ndigits (aTHX_ base, prec);
#line 20051 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dot)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "rop, avref_A, avref_B, len, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	avref_A = ST(1)
;
	SV *	avref_B = ST(2)
;
	SV *	len = ST(3)
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 13262 "MPFR.xs"
  RETVAL = Rmpfr_dot (aTHX_ rop, avref_A, avref_B, len, round);
#line 20079 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nvtoa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nvtoa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pnv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pnv = ST(0)
;
#line 13269 "MPFR.xs"
        I32* temp;
#line 20100 "MPFR.c"
#line 13271 "MPFR.xs"
        temp = PL_markstack_ptr++;
        nvtoa(aTHX_ pnv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 20111 "MPFR.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__MPFR); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__MPFR)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::MPFR::_has_inttypes", XS_Math__MPFR__has_inttypes);
        newXS_deffile("Math::MPFR::NNW_val", XS_Math__MPFR_NNW_val);
        newXS_deffile("Math::MPFR::NOK_POK_val", XS_Math__MPFR_NOK_POK_val);
        newXS_deffile("Math::MPFR::_win32_infnanstring", XS_Math__MPFR__win32_infnanstring);
        newXS_deffile("Math::MPFR::Rmpfr_set_default_rounding_mode", XS_Math__MPFR_Rmpfr_set_default_rounding_mode);
        newXS_deffile("Math::MPFR::Rmpfr_get_default_rounding_mode", XS_Math__MPFR_Rmpfr_get_default_rounding_mode);
        newXS_deffile("Math::MPFR::Rmpfr_prec_round", XS_Math__MPFR_Rmpfr_prec_round);
        newXS_deffile("Math::MPFR::DESTROY", XS_Math__MPFR_DESTROY);
        newXS_deffile("Math::MPFR::Rmpfr_clear", XS_Math__MPFR_Rmpfr_clear);
        newXS_deffile("Math::MPFR::Rmpfr_clear_mpfr", XS_Math__MPFR_Rmpfr_clear_mpfr);
        newXS_deffile("Math::MPFR::Rmpfr_clear_ptr", XS_Math__MPFR_Rmpfr_clear_ptr);
        newXS_deffile("Math::MPFR::Rmpfr_clears", XS_Math__MPFR_Rmpfr_clears);
        newXS_deffile("Math::MPFR::Rmpfr_init", XS_Math__MPFR_Rmpfr_init);
        newXS_deffile("Math::MPFR::Rmpfr_init2", XS_Math__MPFR_Rmpfr_init2);
        newXS_deffile("Math::MPFR::Rmpfr_init_nobless", XS_Math__MPFR_Rmpfr_init_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init2_nobless", XS_Math__MPFR_Rmpfr_init2_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set", XS_Math__MPFR_Rmpfr_init_set);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ui", XS_Math__MPFR_Rmpfr_init_set_ui);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_si", XS_Math__MPFR_Rmpfr_init_set_si);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_d", XS_Math__MPFR_Rmpfr_init_set_d);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ld", XS_Math__MPFR_Rmpfr_init_set_ld);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_f", XS_Math__MPFR_Rmpfr_init_set_f);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_z", XS_Math__MPFR_Rmpfr_init_set_z);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_q", XS_Math__MPFR_Rmpfr_init_set_q);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_str", XS_Math__MPFR_Rmpfr_init_set_str);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_nobless", XS_Math__MPFR_Rmpfr_init_set_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ui_nobless", XS_Math__MPFR_Rmpfr_init_set_ui_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_si_nobless", XS_Math__MPFR_Rmpfr_init_set_si_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_d_nobless", XS_Math__MPFR_Rmpfr_init_set_d_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ld_nobless", XS_Math__MPFR_Rmpfr_init_set_ld_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_f_nobless", XS_Math__MPFR_Rmpfr_init_set_f_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_z_nobless", XS_Math__MPFR_Rmpfr_init_set_z_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_q_nobless", XS_Math__MPFR_Rmpfr_init_set_q_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_str_nobless", XS_Math__MPFR_Rmpfr_init_set_str_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_deref2", XS_Math__MPFR_Rmpfr_deref2);
        newXS_deffile("Math::MPFR::Rmpfr_set_default_prec", XS_Math__MPFR_Rmpfr_set_default_prec);
        newXS_deffile("Math::MPFR::Rmpfr_get_default_prec", XS_Math__MPFR_Rmpfr_get_default_prec);
        newXS_deffile("Math::MPFR::Rmpfr_min_prec", XS_Math__MPFR_Rmpfr_min_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set_prec", XS_Math__MPFR_Rmpfr_set_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set_prec_raw", XS_Math__MPFR_Rmpfr_set_prec_raw);
        newXS_deffile("Math::MPFR::Rmpfr_get_prec", XS_Math__MPFR_Rmpfr_get_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set", XS_Math__MPFR_Rmpfr_set);
        newXS_deffile("Math::MPFR::Rmpfr_set_ui", XS_Math__MPFR_Rmpfr_set_ui);
        newXS_deffile("Math::MPFR::Rmpfr_set_si", XS_Math__MPFR_Rmpfr_set_si);
        newXS_deffile("Math::MPFR::Rmpfr_set_uj", XS_Math__MPFR_Rmpfr_set_uj);
        newXS_deffile("Math::MPFR::Rmpfr_set_sj", XS_Math__MPFR_Rmpfr_set_sj);
        newXS_deffile("Math::MPFR::Rmpfr_set_NV", XS_Math__MPFR_Rmpfr_set_NV);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_NV", XS_Math__MPFR_Rmpfr_cmp_NV);
        newXS_deffile("Math::MPFR::Rmpfr_set_ld", XS_Math__MPFR_Rmpfr_set_ld);
        newXS_deffile("Math::MPFR::Rmpfr_set_d", XS_Math__MPFR_Rmpfr_set_d);
        newXS_deffile("Math::MPFR::Rmpfr_set_z", XS_Math__MPFR_Rmpfr_set_z);
        newXS_deffile("Math::MPFR::Rmpfr_set_q", XS_Math__MPFR_Rmpfr_set_q);
        newXS_deffile("Math::MPFR::Rmpfr_set_f", XS_Math__MPFR_Rmpfr_set_f);
        newXS_deffile("Math::MPFR::Rmpfr_set_str", XS_Math__MPFR_Rmpfr_set_str);
        newXS_deffile("Math::MPFR::Rmpfr_set_inf", XS_Math__MPFR_Rmpfr_set_inf);
        newXS_deffile("Math::MPFR::Rmpfr_set_nan", XS_Math__MPFR_Rmpfr_set_nan);
        newXS_deffile("Math::MPFR::Rmpfr_swap", XS_Math__MPFR_Rmpfr_swap);
        newXS_deffile("Math::MPFR::Rmpfr_get_d", XS_Math__MPFR_Rmpfr_get_d);
        newXS_deffile("Math::MPFR::Rmpfr_get_d_2exp", XS_Math__MPFR_Rmpfr_get_d_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_ld_2exp", XS_Math__MPFR_Rmpfr_get_ld_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_ld", XS_Math__MPFR_Rmpfr_get_ld);
        newXS_deffile("Math::MPFR::Rmpfr_get_d1", XS_Math__MPFR_Rmpfr_get_d1);
        newXS_deffile("Math::MPFR::Rmpfr_get_z_2exp", XS_Math__MPFR_Rmpfr_get_z_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_add", XS_Math__MPFR_Rmpfr_add);
        newXS_deffile("Math::MPFR::Rmpfr_add_ui", XS_Math__MPFR_Rmpfr_add_ui);
        newXS_deffile("Math::MPFR::Rmpfr_add_d", XS_Math__MPFR_Rmpfr_add_d);
        newXS_deffile("Math::MPFR::Rmpfr_add_si", XS_Math__MPFR_Rmpfr_add_si);
        newXS_deffile("Math::MPFR::Rmpfr_add_z", XS_Math__MPFR_Rmpfr_add_z);
        newXS_deffile("Math::MPFR::Rmpfr_add_q", XS_Math__MPFR_Rmpfr_add_q);
        newXS_deffile("Math::MPFR::Rmpfr_sub", XS_Math__MPFR_Rmpfr_sub);
        newXS_deffile("Math::MPFR::Rmpfr_sub_ui", XS_Math__MPFR_Rmpfr_sub_ui);
        newXS_deffile("Math::MPFR::Rmpfr_sub_d", XS_Math__MPFR_Rmpfr_sub_d);
        newXS_deffile("Math::MPFR::Rmpfr_sub_z", XS_Math__MPFR_Rmpfr_sub_z);
        newXS_deffile("Math::MPFR::Rmpfr_sub_q", XS_Math__MPFR_Rmpfr_sub_q);
        newXS_deffile("Math::MPFR::Rmpfr_ui_sub", XS_Math__MPFR_Rmpfr_ui_sub);
        newXS_deffile("Math::MPFR::Rmpfr_d_sub", XS_Math__MPFR_Rmpfr_d_sub);
        newXS_deffile("Math::MPFR::Rmpfr_mul", XS_Math__MPFR_Rmpfr_mul);
        newXS_deffile("Math::MPFR::Rmpfr_mul_ui", XS_Math__MPFR_Rmpfr_mul_ui);
        newXS_deffile("Math::MPFR::Rmpfr_mul_d", XS_Math__MPFR_Rmpfr_mul_d);
        newXS_deffile("Math::MPFR::Rmpfr_mul_z", XS_Math__MPFR_Rmpfr_mul_z);
        newXS_deffile("Math::MPFR::Rmpfr_mul_q", XS_Math__MPFR_Rmpfr_mul_q);
        newXS_deffile("Math::MPFR::Rmpfr_dim", XS_Math__MPFR_Rmpfr_dim);
        newXS_deffile("Math::MPFR::Rmpfr_div", XS_Math__MPFR_Rmpfr_div);
        newXS_deffile("Math::MPFR::Rmpfr_div_ui", XS_Math__MPFR_Rmpfr_div_ui);
        newXS_deffile("Math::MPFR::Rmpfr_div_d", XS_Math__MPFR_Rmpfr_div_d);
        newXS_deffile("Math::MPFR::Rmpfr_div_z", XS_Math__MPFR_Rmpfr_div_z);
        newXS_deffile("Math::MPFR::Rmpfr_div_q", XS_Math__MPFR_Rmpfr_div_q);
        newXS_deffile("Math::MPFR::Rmpfr_ui_div", XS_Math__MPFR_Rmpfr_ui_div);
        newXS_deffile("Math::MPFR::Rmpfr_d_div", XS_Math__MPFR_Rmpfr_d_div);
        newXS_deffile("Math::MPFR::Rmpfr_sqrt", XS_Math__MPFR_Rmpfr_sqrt);
        newXS_deffile("Math::MPFR::Rmpfr_rec_sqrt", XS_Math__MPFR_Rmpfr_rec_sqrt);
        newXS_deffile("Math::MPFR::Rmpfr_cbrt", XS_Math__MPFR_Rmpfr_cbrt);
        newXS_deffile("Math::MPFR::Rmpfr_sqrt_ui", XS_Math__MPFR_Rmpfr_sqrt_ui);
        newXS_deffile("Math::MPFR::Rmpfr_pow_ui", XS_Math__MPFR_Rmpfr_pow_ui);
        newXS_deffile("Math::MPFR::Rmpfr_ui_pow_ui", XS_Math__MPFR_Rmpfr_ui_pow_ui);
        newXS_deffile("Math::MPFR::Rmpfr_ui_pow", XS_Math__MPFR_Rmpfr_ui_pow);
        newXS_deffile("Math::MPFR::Rmpfr_pow_si", XS_Math__MPFR_Rmpfr_pow_si);
        newXS_deffile("Math::MPFR::Rmpfr_pow", XS_Math__MPFR_Rmpfr_pow);
        newXS_deffile("Math::MPFR::Rmpfr_neg", XS_Math__MPFR_Rmpfr_neg);
        newXS_deffile("Math::MPFR::Rmpfr_abs", XS_Math__MPFR_Rmpfr_abs);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2exp", XS_Math__MPFR_Rmpfr_mul_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2ui", XS_Math__MPFR_Rmpfr_mul_2ui);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2si", XS_Math__MPFR_Rmpfr_mul_2si);
        newXS_deffile("Math::MPFR::Rmpfr_div_2exp", XS_Math__MPFR_Rmpfr_div_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_div_2ui", XS_Math__MPFR_Rmpfr_div_2ui);
        newXS_deffile("Math::MPFR::Rmpfr_div_2si", XS_Math__MPFR_Rmpfr_div_2si);
        newXS_deffile("Math::MPFR::Rmpfr_cmp", XS_Math__MPFR_Rmpfr_cmp);
        newXS_deffile("Math::MPFR::Rmpfr_cmpabs", XS_Math__MPFR_Rmpfr_cmpabs);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ui", XS_Math__MPFR_Rmpfr_cmp_ui);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_d", XS_Math__MPFR_Rmpfr_cmp_d);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ld", XS_Math__MPFR_Rmpfr_cmp_ld);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_si", XS_Math__MPFR_Rmpfr_cmp_si);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ui_2exp", XS_Math__MPFR_Rmpfr_cmp_ui_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_si_2exp", XS_Math__MPFR_Rmpfr_cmp_si_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_eq", XS_Math__MPFR_Rmpfr_eq);
        newXS_deffile("Math::MPFR::Rmpfr_nan_p", XS_Math__MPFR_Rmpfr_nan_p);
        newXS_deffile("Math::MPFR::Rmpfr_inf_p", XS_Math__MPFR_Rmpfr_inf_p);
        newXS_deffile("Math::MPFR::Rmpfr_number_p", XS_Math__MPFR_Rmpfr_number_p);
        newXS_deffile("Math::MPFR::Rmpfr_reldiff", XS_Math__MPFR_Rmpfr_reldiff);
        newXS_deffile("Math::MPFR::Rmpfr_sgn", XS_Math__MPFR_Rmpfr_sgn);
        newXS_deffile("Math::MPFR::Rmpfr_greater_p", XS_Math__MPFR_Rmpfr_greater_p);
        newXS_deffile("Math::MPFR::Rmpfr_greaterequal_p", XS_Math__MPFR_Rmpfr_greaterequal_p);
        newXS_deffile("Math::MPFR::Rmpfr_less_p", XS_Math__MPFR_Rmpfr_less_p);
        newXS_deffile("Math::MPFR::Rmpfr_lessequal_p", XS_Math__MPFR_Rmpfr_lessequal_p);
        newXS_deffile("Math::MPFR::Rmpfr_lessgreater_p", XS_Math__MPFR_Rmpfr_lessgreater_p);
        newXS_deffile("Math::MPFR::Rmpfr_equal_p", XS_Math__MPFR_Rmpfr_equal_p);
        newXS_deffile("Math::MPFR::Rmpfr_unordered_p", XS_Math__MPFR_Rmpfr_unordered_p);
        newXS_deffile("Math::MPFR::Rmpfr_sin_cos", XS_Math__MPFR_Rmpfr_sin_cos);
        newXS_deffile("Math::MPFR::Rmpfr_sinh_cosh", XS_Math__MPFR_Rmpfr_sinh_cosh);
        newXS_deffile("Math::MPFR::Rmpfr_sin", XS_Math__MPFR_Rmpfr_sin);
        newXS_deffile("Math::MPFR::Rmpfr_cos", XS_Math__MPFR_Rmpfr_cos);
        newXS_deffile("Math::MPFR::Rmpfr_tan", XS_Math__MPFR_Rmpfr_tan);
        newXS_deffile("Math::MPFR::Rmpfr_asin", XS_Math__MPFR_Rmpfr_asin);
        newXS_deffile("Math::MPFR::Rmpfr_acos", XS_Math__MPFR_Rmpfr_acos);
        newXS_deffile("Math::MPFR::Rmpfr_atan", XS_Math__MPFR_Rmpfr_atan);
        newXS_deffile("Math::MPFR::Rmpfr_sinh", XS_Math__MPFR_Rmpfr_sinh);
        newXS_deffile("Math::MPFR::Rmpfr_cosh", XS_Math__MPFR_Rmpfr_cosh);
        newXS_deffile("Math::MPFR::Rmpfr_tanh", XS_Math__MPFR_Rmpfr_tanh);
        newXS_deffile("Math::MPFR::Rmpfr_asinh", XS_Math__MPFR_Rmpfr_asinh);
        newXS_deffile("Math::MPFR::Rmpfr_acosh", XS_Math__MPFR_Rmpfr_acosh);
        newXS_deffile("Math::MPFR::Rmpfr_atanh", XS_Math__MPFR_Rmpfr_atanh);
        newXS_deffile("Math::MPFR::Rmpfr_fac_ui", XS_Math__MPFR_Rmpfr_fac_ui);
        newXS_deffile("Math::MPFR::Rmpfr_log1p", XS_Math__MPFR_Rmpfr_log1p);
        newXS_deffile("Math::MPFR::Rmpfr_expm1", XS_Math__MPFR_Rmpfr_expm1);
        newXS_deffile("Math::MPFR::Rmpfr_log2", XS_Math__MPFR_Rmpfr_log2);
        newXS_deffile("Math::MPFR::Rmpfr_log10", XS_Math__MPFR_Rmpfr_log10);
        newXS_deffile("Math::MPFR::Rmpfr_fma", XS_Math__MPFR_Rmpfr_fma);
        newXS_deffile("Math::MPFR::Rmpfr_fms", XS_Math__MPFR_Rmpfr_fms);
        newXS_deffile("Math::MPFR::Rmpfr_agm", XS_Math__MPFR_Rmpfr_agm);
        newXS_deffile("Math::MPFR::Rmpfr_hypot", XS_Math__MPFR_Rmpfr_hypot);
        newXS_deffile("Math::MPFR::Rmpfr_const_log2", XS_Math__MPFR_Rmpfr_const_log2);
        newXS_deffile("Math::MPFR::Rmpfr_const_pi", XS_Math__MPFR_Rmpfr_const_pi);
        newXS_deffile("Math::MPFR::Rmpfr_const_euler", XS_Math__MPFR_Rmpfr_const_euler);
        newXS_deffile("Math::MPFR::Rmpfr_rint", XS_Math__MPFR_Rmpfr_rint);
        newXS_deffile("Math::MPFR::Rmpfr_ceil", XS_Math__MPFR_Rmpfr_ceil);
        newXS_deffile("Math::MPFR::Rmpfr_floor", XS_Math__MPFR_Rmpfr_floor);
        newXS_deffile("Math::MPFR::Rmpfr_round", XS_Math__MPFR_Rmpfr_round);
        newXS_deffile("Math::MPFR::Rmpfr_trunc", XS_Math__MPFR_Rmpfr_trunc);
        newXS_deffile("Math::MPFR::Rmpfr_can_round", XS_Math__MPFR_Rmpfr_can_round);
        newXS_deffile("Math::MPFR::Rmpfr_print_rnd_mode", XS_Math__MPFR_Rmpfr_print_rnd_mode);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin", XS_Math__MPFR_Rmpfr_get_emin);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax", XS_Math__MPFR_Rmpfr_get_emax);
        newXS_deffile("Math::MPFR::Rmpfr_set_emin", XS_Math__MPFR_Rmpfr_set_emin);
        newXS_deffile("Math::MPFR::Rmpfr_set_emax", XS_Math__MPFR_Rmpfr_set_emax);
        newXS_deffile("Math::MPFR::Rmpfr_check_range", XS_Math__MPFR_Rmpfr_check_range);
        newXS_deffile("Math::MPFR::Rmpfr_clear_underflow", XS_Math__MPFR_Rmpfr_clear_underflow);
        newXS_deffile("Math::MPFR::Rmpfr_clear_overflow", XS_Math__MPFR_Rmpfr_clear_overflow);
        newXS_deffile("Math::MPFR::Rmpfr_clear_nanflag", XS_Math__MPFR_Rmpfr_clear_nanflag);
        newXS_deffile("Math::MPFR::Rmpfr_clear_inexflag", XS_Math__MPFR_Rmpfr_clear_inexflag);
        newXS_deffile("Math::MPFR::Rmpfr_clear_flags", XS_Math__MPFR_Rmpfr_clear_flags);
        newXS_deffile("Math::MPFR::Rmpfr_underflow_p", XS_Math__MPFR_Rmpfr_underflow_p);
        newXS_deffile("Math::MPFR::Rmpfr_overflow_p", XS_Math__MPFR_Rmpfr_overflow_p);
        newXS_deffile("Math::MPFR::Rmpfr_nanflag_p", XS_Math__MPFR_Rmpfr_nanflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_inexflag_p", XS_Math__MPFR_Rmpfr_inexflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_log", XS_Math__MPFR_Rmpfr_log);
        newXS_deffile("Math::MPFR::Rmpfr_exp", XS_Math__MPFR_Rmpfr_exp);
        newXS_deffile("Math::MPFR::Rmpfr_exp2", XS_Math__MPFR_Rmpfr_exp2);
        newXS_deffile("Math::MPFR::Rmpfr_exp10", XS_Math__MPFR_Rmpfr_exp10);
        newXS_deffile("Math::MPFR::Rmpfr_urandomb", XS_Math__MPFR_Rmpfr_urandomb);
        newXS_deffile("Math::MPFR::Rmpfr_random2", XS_Math__MPFR_Rmpfr_random2);
        newXS_deffile("Math::MPFR::_TRmpfr_out_str", XS_Math__MPFR__TRmpfr_out_str);
        newXS_deffile("Math::MPFR::_Rmpfr_out_str", XS_Math__MPFR__Rmpfr_out_str);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strS", XS_Math__MPFR__TRmpfr_out_strS);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strP", XS_Math__MPFR__TRmpfr_out_strP);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strPS", XS_Math__MPFR__TRmpfr_out_strPS);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strS", XS_Math__MPFR__Rmpfr_out_strS);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strP", XS_Math__MPFR__Rmpfr_out_strP);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strPS", XS_Math__MPFR__Rmpfr_out_strPS);
        newXS_deffile("Math::MPFR::TRmpfr_inp_str", XS_Math__MPFR_TRmpfr_inp_str);
        newXS_deffile("Math::MPFR::Rmpfr_inp_str", XS_Math__MPFR_Rmpfr_inp_str);
        newXS_deffile("Math::MPFR::Rmpfr_gamma", XS_Math__MPFR_Rmpfr_gamma);
        newXS_deffile("Math::MPFR::Rmpfr_zeta", XS_Math__MPFR_Rmpfr_zeta);
        newXS_deffile("Math::MPFR::Rmpfr_zeta_ui", XS_Math__MPFR_Rmpfr_zeta_ui);
        newXS_deffile("Math::MPFR::Rmpfr_erf", XS_Math__MPFR_Rmpfr_erf);
        newXS_deffile("Math::MPFR::Rmpfr_frac", XS_Math__MPFR_Rmpfr_frac);
        newXS_deffile("Math::MPFR::Rmpfr_remainder", XS_Math__MPFR_Rmpfr_remainder);
        newXS_deffile("Math::MPFR::Rmpfr_modf", XS_Math__MPFR_Rmpfr_modf);
        newXS_deffile("Math::MPFR::Rmpfr_fmod", XS_Math__MPFR_Rmpfr_fmod);
        newXS_deffile("Math::MPFR::Rmpfr_remquo", XS_Math__MPFR_Rmpfr_remquo);
        newXS_deffile("Math::MPFR::Rmpfr_integer_p", XS_Math__MPFR_Rmpfr_integer_p);
        newXS_deffile("Math::MPFR::Rmpfr_nexttoward", XS_Math__MPFR_Rmpfr_nexttoward);
        newXS_deffile("Math::MPFR::Rmpfr_nextabove", XS_Math__MPFR_Rmpfr_nextabove);
        newXS_deffile("Math::MPFR::Rmpfr_nextbelow", XS_Math__MPFR_Rmpfr_nextbelow);
        newXS_deffile("Math::MPFR::Rmpfr_min", XS_Math__MPFR_Rmpfr_min);
        newXS_deffile("Math::MPFR::Rmpfr_max", XS_Math__MPFR_Rmpfr_max);
        newXS_deffile("Math::MPFR::Rmpfr_get_exp", XS_Math__MPFR_Rmpfr_get_exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_exp", XS_Math__MPFR_Rmpfr_set_exp);
        newXS_deffile("Math::MPFR::Rmpfr_signbit", XS_Math__MPFR_Rmpfr_signbit);
        newXS_deffile("Math::MPFR::Rmpfr_setsign", XS_Math__MPFR_Rmpfr_setsign);
        newXS_deffile("Math::MPFR::Rmpfr_copysign", XS_Math__MPFR_Rmpfr_copysign);
        newXS_deffile("Math::MPFR::get_refcnt", XS_Math__MPFR_get_refcnt);
        newXS_deffile("Math::MPFR::get_package_name", XS_Math__MPFR_get_package_name);
        newXS_deffile("Math::MPFR::Rmpfr_dump", XS_Math__MPFR_Rmpfr_dump);
        newXS_deffile("Math::MPFR::gmp_v", XS_Math__MPFR_gmp_v);
        newXS_deffile("Math::MPFR::Rmpfr_set_ui_2exp", XS_Math__MPFR_Rmpfr_set_ui_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_si_2exp", XS_Math__MPFR_Rmpfr_set_si_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_uj_2exp", XS_Math__MPFR_Rmpfr_set_uj_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_sj_2exp", XS_Math__MPFR_Rmpfr_set_sj_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_z", XS_Math__MPFR_Rmpfr_get_z);
        newXS_deffile("Math::MPFR::Rmpfr_si_sub", XS_Math__MPFR_Rmpfr_si_sub);
        newXS_deffile("Math::MPFR::Rmpfr_sub_si", XS_Math__MPFR_Rmpfr_sub_si);
        newXS_deffile("Math::MPFR::Rmpfr_mul_si", XS_Math__MPFR_Rmpfr_mul_si);
        newXS_deffile("Math::MPFR::Rmpfr_si_div", XS_Math__MPFR_Rmpfr_si_div);
        newXS_deffile("Math::MPFR::Rmpfr_div_si", XS_Math__MPFR_Rmpfr_div_si);
        newXS_deffile("Math::MPFR::Rmpfr_sqr", XS_Math__MPFR_Rmpfr_sqr);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_z", XS_Math__MPFR_Rmpfr_cmp_z);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_q", XS_Math__MPFR_Rmpfr_cmp_q);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_f", XS_Math__MPFR_Rmpfr_cmp_f);
        newXS_deffile("Math::MPFR::Rmpfr_zero_p", XS_Math__MPFR_Rmpfr_zero_p);
        newXS_deffile("Math::MPFR::Rmpfr_free_cache", XS_Math__MPFR_Rmpfr_free_cache);
        newXS_deffile("Math::MPFR::Rmpfr_free_cache2", XS_Math__MPFR_Rmpfr_free_cache2);
        newXS_deffile("Math::MPFR::Rmpfr_free_pool", XS_Math__MPFR_Rmpfr_free_pool);
        newXS_deffile("Math::MPFR::Rmpfr_get_version", XS_Math__MPFR_Rmpfr_get_version);
        newXS_deffile("Math::MPFR::Rmpfr_get_patches", XS_Math__MPFR_Rmpfr_get_patches);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin_min", XS_Math__MPFR_Rmpfr_get_emin_min);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin_max", XS_Math__MPFR_Rmpfr_get_emin_max);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax_min", XS_Math__MPFR_Rmpfr_get_emax_min);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax_max", XS_Math__MPFR_Rmpfr_get_emax_max);
        newXS_deffile("Math::MPFR::Rmpfr_clear_erangeflag", XS_Math__MPFR_Rmpfr_clear_erangeflag);
        newXS_deffile("Math::MPFR::Rmpfr_erangeflag_p", XS_Math__MPFR_Rmpfr_erangeflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_rint_round", XS_Math__MPFR_Rmpfr_rint_round);
        newXS_deffile("Math::MPFR::Rmpfr_rint_trunc", XS_Math__MPFR_Rmpfr_rint_trunc);
        newXS_deffile("Math::MPFR::Rmpfr_rint_ceil", XS_Math__MPFR_Rmpfr_rint_ceil);
        newXS_deffile("Math::MPFR::Rmpfr_rint_floor", XS_Math__MPFR_Rmpfr_rint_floor);
        newXS_deffile("Math::MPFR::Rmpfr_get_ui", XS_Math__MPFR_Rmpfr_get_ui);
        newXS_deffile("Math::MPFR::Rmpfr_get_si", XS_Math__MPFR_Rmpfr_get_si);
        newXS_deffile("Math::MPFR::Rmpfr_get_uj", XS_Math__MPFR_Rmpfr_get_uj);
        newXS_deffile("Math::MPFR::Rmpfr_get_sj", XS_Math__MPFR_Rmpfr_get_sj);
        newXS_deffile("Math::MPFR::Rmpfr_get_IV", XS_Math__MPFR_Rmpfr_get_IV);
        newXS_deffile("Math::MPFR::Rmpfr_get_UV", XS_Math__MPFR_Rmpfr_get_UV);
        newXS_deffile("Math::MPFR::Rmpfr_get_NV", XS_Math__MPFR_Rmpfr_get_NV);
        newXS_deffile("Math::MPFR::Rmpfr_fits_ulong_p", XS_Math__MPFR_Rmpfr_fits_ulong_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_slong_p", XS_Math__MPFR_Rmpfr_fits_slong_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_ushort_p", XS_Math__MPFR_Rmpfr_fits_ushort_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_sshort_p", XS_Math__MPFR_Rmpfr_fits_sshort_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_uint_p", XS_Math__MPFR_Rmpfr_fits_uint_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_sint_p", XS_Math__MPFR_Rmpfr_fits_sint_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_uintmax_p", XS_Math__MPFR_Rmpfr_fits_uintmax_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_intmax_p", XS_Math__MPFR_Rmpfr_fits_intmax_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_IV_p", XS_Math__MPFR_Rmpfr_fits_IV_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_UV_p", XS_Math__MPFR_Rmpfr_fits_UV_p);
        newXS_deffile("Math::MPFR::Rmpfr_strtofr", XS_Math__MPFR_Rmpfr_strtofr);
        newXS_deffile("Math::MPFR::Rmpfr_set_erangeflag", XS_Math__MPFR_Rmpfr_set_erangeflag);
        newXS_deffile("Math::MPFR::Rmpfr_set_underflow", XS_Math__MPFR_Rmpfr_set_underflow);
        newXS_deffile("Math::MPFR::Rmpfr_set_overflow", XS_Math__MPFR_Rmpfr_set_overflow);
        newXS_deffile("Math::MPFR::Rmpfr_set_nanflag", XS_Math__MPFR_Rmpfr_set_nanflag);
        newXS_deffile("Math::MPFR::Rmpfr_set_inexflag", XS_Math__MPFR_Rmpfr_set_inexflag);
        newXS_deffile("Math::MPFR::Rmpfr_erfc", XS_Math__MPFR_Rmpfr_erfc);
        newXS_deffile("Math::MPFR::Rmpfr_j0", XS_Math__MPFR_Rmpfr_j0);
        newXS_deffile("Math::MPFR::Rmpfr_j1", XS_Math__MPFR_Rmpfr_j1);
        newXS_deffile("Math::MPFR::Rmpfr_jn", XS_Math__MPFR_Rmpfr_jn);
        newXS_deffile("Math::MPFR::Rmpfr_y0", XS_Math__MPFR_Rmpfr_y0);
        newXS_deffile("Math::MPFR::Rmpfr_y1", XS_Math__MPFR_Rmpfr_y1);
        newXS_deffile("Math::MPFR::Rmpfr_yn", XS_Math__MPFR_Rmpfr_yn);
        newXS_deffile("Math::MPFR::Rmpfr_atan2", XS_Math__MPFR_Rmpfr_atan2);
        newXS_deffile("Math::MPFR::Rmpfr_pow_z", XS_Math__MPFR_Rmpfr_pow_z);
        newXS_deffile("Math::MPFR::Rmpfr_subnormalize", XS_Math__MPFR_Rmpfr_subnormalize);
        newXS_deffile("Math::MPFR::Rmpfr_const_catalan", XS_Math__MPFR_Rmpfr_const_catalan);
        newXS_deffile("Math::MPFR::Rmpfr_sec", XS_Math__MPFR_Rmpfr_sec);
        newXS_deffile("Math::MPFR::Rmpfr_csc", XS_Math__MPFR_Rmpfr_csc);
        newXS_deffile("Math::MPFR::Rmpfr_cot", XS_Math__MPFR_Rmpfr_cot);
        newXS_deffile("Math::MPFR::Rmpfr_root", XS_Math__MPFR_Rmpfr_root);
        newXS_deffile("Math::MPFR::Rmpfr_eint", XS_Math__MPFR_Rmpfr_eint);
        newXS_deffile("Math::MPFR::Rmpfr_li2", XS_Math__MPFR_Rmpfr_li2);
        newXS_deffile("Math::MPFR::Rmpfr_get_f", XS_Math__MPFR_Rmpfr_get_f);
        newXS_deffile("Math::MPFR::Rmpfr_get_q", XS_Math__MPFR_Rmpfr_get_q);
        newXS_deffile("Math::MPFR::Rmpfr_sech", XS_Math__MPFR_Rmpfr_sech);
        newXS_deffile("Math::MPFR::Rmpfr_csch", XS_Math__MPFR_Rmpfr_csch);
        newXS_deffile("Math::MPFR::Rmpfr_coth", XS_Math__MPFR_Rmpfr_coth);
        newXS_deffile("Math::MPFR::Rmpfr_lngamma", XS_Math__MPFR_Rmpfr_lngamma);
        newXS_deffile("Math::MPFR::Rmpfr_lgamma", XS_Math__MPFR_Rmpfr_lgamma);
        newXS_deffile("Math::MPFR::_MPFR_VERSION", XS_Math__MPFR__MPFR_VERSION);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_MAJOR", XS_Math__MPFR__MPFR_VERSION_MAJOR);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_MINOR", XS_Math__MPFR__MPFR_VERSION_MINOR);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_PATCHLEVEL", XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_STRING", XS_Math__MPFR__MPFR_VERSION_STRING);
        newXS_deffile("Math::MPFR::RMPFR_VERSION_NUM", XS_Math__MPFR_RMPFR_VERSION_NUM);
        newXS_deffile("Math::MPFR::Rmpfr_sum", XS_Math__MPFR_Rmpfr_sum);
        newXS_deffile("Math::MPFR::_fr_to_q", XS_Math__MPFR__fr_to_q);
        newXS_deffile("Math::MPFR::Rmpfr_q_div", XS_Math__MPFR_Rmpfr_q_div);
        newXS_deffile("Math::MPFR::Rmpfr_z_div", XS_Math__MPFR_Rmpfr_z_div);
        newXS_deffile("Math::MPFR::overload_mul", XS_Math__MPFR_overload_mul);
        newXS_deffile("Math::MPFR::overload_add", XS_Math__MPFR_overload_add);
        newXS_deffile("Math::MPFR::overload_sub", XS_Math__MPFR_overload_sub);
        newXS_deffile("Math::MPFR::overload_div", XS_Math__MPFR_overload_div);
        newXS_deffile("Math::MPFR::overload_copy", XS_Math__MPFR_overload_copy);
        newXS_deffile("Math::MPFR::overload_abs", XS_Math__MPFR_overload_abs);
        newXS_deffile("Math::MPFR::overload_gt", XS_Math__MPFR_overload_gt);
        newXS_deffile("Math::MPFR::overload_gte", XS_Math__MPFR_overload_gte);
        newXS_deffile("Math::MPFR::overload_lt", XS_Math__MPFR_overload_lt);
        newXS_deffile("Math::MPFR::overload_lte", XS_Math__MPFR_overload_lte);
        newXS_deffile("Math::MPFR::overload_spaceship", XS_Math__MPFR_overload_spaceship);
        newXS_deffile("Math::MPFR::overload_equiv", XS_Math__MPFR_overload_equiv);
        newXS_deffile("Math::MPFR::overload_not_equiv", XS_Math__MPFR_overload_not_equiv);
        newXS_deffile("Math::MPFR::overload_true", XS_Math__MPFR_overload_true);
        newXS_deffile("Math::MPFR::overload_not", XS_Math__MPFR_overload_not);
        newXS_deffile("Math::MPFR::overload_sqrt", XS_Math__MPFR_overload_sqrt);
        newXS_deffile("Math::MPFR::overload_pow", XS_Math__MPFR_overload_pow);
        newXS_deffile("Math::MPFR::overload_log", XS_Math__MPFR_overload_log);
        newXS_deffile("Math::MPFR::overload_exp", XS_Math__MPFR_overload_exp);
        newXS_deffile("Math::MPFR::overload_sin", XS_Math__MPFR_overload_sin);
        newXS_deffile("Math::MPFR::overload_cos", XS_Math__MPFR_overload_cos);
        newXS_deffile("Math::MPFR::overload_int", XS_Math__MPFR_overload_int);
        newXS_deffile("Math::MPFR::overload_atan2", XS_Math__MPFR_overload_atan2);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_default_nobless", XS_Math__MPFR_Rmpfr_randinit_default_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_mt_nobless", XS_Math__MPFR_Rmpfr_randinit_mt_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_lc_2exp_nobless", XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_lc_2exp_size_nobless", XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randclear", XS_Math__MPFR_Rmpfr_randclear);
        newXS_deffile("Math::MPFR::Rmpfr_randseed", XS_Math__MPFR_Rmpfr_randseed);
        newXS_deffile("Math::MPFR::Rmpfr_randseed_ui", XS_Math__MPFR_Rmpfr_randseed_ui);
        newXS_deffile("Math::MPFR::overload_pow_eq", XS_Math__MPFR_overload_pow_eq);
        newXS_deffile("Math::MPFR::overload_div_eq", XS_Math__MPFR_overload_div_eq);
        newXS_deffile("Math::MPFR::overload_sub_eq", XS_Math__MPFR_overload_sub_eq);
        newXS_deffile("Math::MPFR::overload_add_eq", XS_Math__MPFR_overload_add_eq);
        newXS_deffile("Math::MPFR::overload_mul_eq", XS_Math__MPFR_overload_mul_eq);
        newXS_deffile("Math::MPFR::_itsa", XS_Math__MPFR__itsa);
        newXS_deffile("Math::MPFR::_has_longlong", XS_Math__MPFR__has_longlong);
        newXS_deffile("Math::MPFR::_has_longdouble", XS_Math__MPFR__has_longdouble);
        newXS_deffile("Math::MPFR::_ivsize_bits", XS_Math__MPFR__ivsize_bits);
        (void)newXSproto_portable("Math::MPFR::RMPFR_PREC_MAX", XS_Math__MPFR_RMPFR_PREC_MAX, file, "");
        (void)newXSproto_portable("Math::MPFR::RMPFR_PREC_MIN", XS_Math__MPFR_RMPFR_PREC_MIN, file, "");
        newXS_deffile("Math::MPFR::wrap_mpfr_printf", XS_Math__MPFR_wrap_mpfr_printf);
        newXS_deffile("Math::MPFR::wrap_mpfr_fprintf", XS_Math__MPFR_wrap_mpfr_fprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_sprintf", XS_Math__MPFR_wrap_mpfr_sprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_snprintf", XS_Math__MPFR_wrap_mpfr_snprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_printf_rnd", XS_Math__MPFR_wrap_mpfr_printf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_fprintf_rnd", XS_Math__MPFR_wrap_mpfr_fprintf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_sprintf_rnd", XS_Math__MPFR_wrap_mpfr_sprintf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_snprintf_rnd", XS_Math__MPFR_wrap_mpfr_snprintf_rnd);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_tls_p", XS_Math__MPFR_Rmpfr_buildopt_tls_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_decimal_p", XS_Math__MPFR_Rmpfr_buildopt_decimal_p);
        newXS_deffile("Math::MPFR::Rmpfr_regular_p", XS_Math__MPFR_Rmpfr_regular_p);
        newXS_deffile("Math::MPFR::Rmpfr_set_zero", XS_Math__MPFR_Rmpfr_set_zero);
        newXS_deffile("Math::MPFR::Rmpfr_digamma", XS_Math__MPFR_Rmpfr_digamma);
        newXS_deffile("Math::MPFR::Rmpfr_ai", XS_Math__MPFR_Rmpfr_ai);
        newXS_deffile("Math::MPFR::Rmpfr_get_flt", XS_Math__MPFR_Rmpfr_get_flt);
        newXS_deffile("Math::MPFR::Rmpfr_set_flt", XS_Math__MPFR_Rmpfr_set_flt);
        newXS_deffile("Math::MPFR::Rmpfr_urandom", XS_Math__MPFR_Rmpfr_urandom);
        newXS_deffile("Math::MPFR::Rmpfr_set_z_2exp", XS_Math__MPFR_Rmpfr_set_z_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_tune_case", XS_Math__MPFR_Rmpfr_buildopt_tune_case);
        newXS_deffile("Math::MPFR::Rmpfr_frexp", XS_Math__MPFR_Rmpfr_frexp);
        newXS_deffile("Math::MPFR::Rmpfr_z_sub", XS_Math__MPFR_Rmpfr_z_sub);
        newXS_deffile("Math::MPFR::Rmpfr_grandom", XS_Math__MPFR_Rmpfr_grandom);
        newXS_deffile("Math::MPFR::Rmpfr_clear_divby0", XS_Math__MPFR_Rmpfr_clear_divby0);
        newXS_deffile("Math::MPFR::Rmpfr_set_divby0", XS_Math__MPFR_Rmpfr_set_divby0);
        newXS_deffile("Math::MPFR::Rmpfr_divby0_p", XS_Math__MPFR_Rmpfr_divby0_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_gmpinternals_p", XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p);
        newXS_deffile("Math::MPFR::_get_xs_version", XS_Math__MPFR__get_xs_version);
        newXS_deffile("Math::MPFR::overload_inc", XS_Math__MPFR_overload_inc);
        newXS_deffile("Math::MPFR::overload_dec", XS_Math__MPFR_overload_dec);
        newXS_deffile("Math::MPFR::_wrap_count", XS_Math__MPFR__wrap_count);
        newXS_deffile("Math::MPFR::Rmpfr_set_LD", XS_Math__MPFR_Rmpfr_set_LD);
        newXS_deffile("Math::MPFR::Rmpfr_set_DECIMAL64", XS_Math__MPFR_Rmpfr_set_DECIMAL64);
        newXS_deffile("Math::MPFR::Rmpfr_set_DECIMAL128", XS_Math__MPFR_Rmpfr_set_DECIMAL128);
        newXS_deffile("Math::MPFR::Rmpfr_get_LD", XS_Math__MPFR_Rmpfr_get_LD);
        newXS_deffile("Math::MPFR::Rmpfr_get_DECIMAL64", XS_Math__MPFR_Rmpfr_get_DECIMAL64);
        newXS_deffile("Math::MPFR::Rmpfr_get_DECIMAL128", XS_Math__MPFR_Rmpfr_get_DECIMAL128);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL_FLOATS", XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL64", XS_Math__MPFR__MPFR_WANT_DECIMAL64);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL128", XS_Math__MPFR__MPFR_WANT_DECIMAL128);
        newXS_deffile("Math::MPFR::_MPFR_WANT_FLOAT128", XS_Math__MPFR__MPFR_WANT_FLOAT128);
        newXS_deffile("Math::MPFR::_max_base", XS_Math__MPFR__max_base);
        newXS_deffile("Math::MPFR::_isobject", XS_Math__MPFR__isobject);
        newXS_deffile("Math::MPFR::_mp_sizes", XS_Math__MPFR__mp_sizes);
        newXS_deffile("Math::MPFR::_ivsize", XS_Math__MPFR__ivsize);
        newXS_deffile("Math::MPFR::_nvsize", XS_Math__MPFR__nvsize);
        newXS_deffile("Math::MPFR::_FLT128_DIG", XS_Math__MPFR__FLT128_DIG);
        newXS_deffile("Math::MPFR::_LDBL_DIG", XS_Math__MPFR__LDBL_DIG);
        newXS_deffile("Math::MPFR::_DBL_DIG", XS_Math__MPFR__DBL_DIG);
        newXS_deffile("Math::MPFR::_FLT128_MANT_DIG", XS_Math__MPFR__FLT128_MANT_DIG);
        newXS_deffile("Math::MPFR::_LDBL_MANT_DIG", XS_Math__MPFR__LDBL_MANT_DIG);
        newXS_deffile("Math::MPFR::_DBL_MANT_DIG", XS_Math__MPFR__DBL_MANT_DIG);
        newXS_deffile("Math::MPFR::Rmpfr_get_float128", XS_Math__MPFR_Rmpfr_get_float128);
        newXS_deffile("Math::MPFR::Rmpfr_get_FLOAT128", XS_Math__MPFR_Rmpfr_get_FLOAT128);
        newXS_deffile("Math::MPFR::Rmpfr_set_FLOAT128", XS_Math__MPFR_Rmpfr_set_FLOAT128);
        newXS_deffile("Math::MPFR::Rmpfr_set_float128", XS_Math__MPFR_Rmpfr_set_float128);
        newXS_deffile("Math::MPFR::_is_readonly", XS_Math__MPFR__is_readonly);
        newXS_deffile("Math::MPFR::_readonly_on", XS_Math__MPFR__readonly_on);
        newXS_deffile("Math::MPFR::_readonly_off", XS_Math__MPFR__readonly_off);
        newXS_deffile("Math::MPFR::_can_pass_float128", XS_Math__MPFR__can_pass_float128);
        newXS_deffile("Math::MPFR::_mpfr_want_float128", XS_Math__MPFR__mpfr_want_float128);
        newXS_deffile("Math::MPFR::nnumflag", XS_Math__MPFR_nnumflag);
        newXS_deffile("Math::MPFR::nok_pokflag", XS_Math__MPFR_nok_pokflag);
        newXS_deffile("Math::MPFR::clear_nnum", XS_Math__MPFR_clear_nnum);
        newXS_deffile("Math::MPFR::clear_nok_pok", XS_Math__MPFR_clear_nok_pok);
        newXS_deffile("Math::MPFR::set_nnum", XS_Math__MPFR_set_nnum);
        newXS_deffile("Math::MPFR::set_nok_pok", XS_Math__MPFR_set_nok_pok);
        newXS_deffile("Math::MPFR::_d_bytes", XS_Math__MPFR__d_bytes);
        newXS_deffile("Math::MPFR::_d_bytes_fr", XS_Math__MPFR__d_bytes_fr);
        newXS_deffile("Math::MPFR::_dd_bytes", XS_Math__MPFR__dd_bytes);
        newXS_deffile("Math::MPFR::_dd_bytes_fr", XS_Math__MPFR__dd_bytes_fr);
        newXS_deffile("Math::MPFR::_ld_bytes", XS_Math__MPFR__ld_bytes);
        newXS_deffile("Math::MPFR::_ld_bytes_fr", XS_Math__MPFR__ld_bytes_fr);
        newXS_deffile("Math::MPFR::_f128_bytes", XS_Math__MPFR__f128_bytes);
        newXS_deffile("Math::MPFR::_f128_bytes_fr", XS_Math__MPFR__f128_bytes_fr);
        newXS_deffile("Math::MPFR::_required_ldbl_mant_dig", XS_Math__MPFR__required_ldbl_mant_dig);
        newXS_deffile("Math::MPFR::_GMP_LIMB_BITS", XS_Math__MPFR__GMP_LIMB_BITS);
        newXS_deffile("Math::MPFR::_GMP_NAIL_BITS", XS_Math__MPFR__GMP_NAIL_BITS);
        newXS_deffile("Math::MPFR::Rmpfr_fmodquo", XS_Math__MPFR_Rmpfr_fmodquo);
        newXS_deffile("Math::MPFR::Rmpfr_fpif_export", XS_Math__MPFR_Rmpfr_fpif_export);
        newXS_deffile("Math::MPFR::Rmpfr_fpif_import", XS_Math__MPFR_Rmpfr_fpif_import);
        newXS_deffile("Math::MPFR::Rmpfr_flags_clear", XS_Math__MPFR_Rmpfr_flags_clear);
        newXS_deffile("Math::MPFR::Rmpfr_flags_set", XS_Math__MPFR_Rmpfr_flags_set);
        newXS_deffile("Math::MPFR::Rmpfr_flags_test", XS_Math__MPFR_Rmpfr_flags_test);
        newXS_deffile("Math::MPFR::Rmpfr_flags_save", XS_Math__MPFR_Rmpfr_flags_save);
        newXS_deffile("Math::MPFR::Rmpfr_flags_restore", XS_Math__MPFR_Rmpfr_flags_restore);
        newXS_deffile("Math::MPFR::Rmpfr_rint_roundeven", XS_Math__MPFR_Rmpfr_rint_roundeven);
        newXS_deffile("Math::MPFR::Rmpfr_roundeven", XS_Math__MPFR_Rmpfr_roundeven);
        newXS_deffile("Math::MPFR::Rmpfr_nrandom", XS_Math__MPFR_Rmpfr_nrandom);
        newXS_deffile("Math::MPFR::Rmpfr_erandom", XS_Math__MPFR_Rmpfr_erandom);
        newXS_deffile("Math::MPFR::Rmpfr_fmma", XS_Math__MPFR_Rmpfr_fmma);
        newXS_deffile("Math::MPFR::Rmpfr_fmms", XS_Math__MPFR_Rmpfr_fmms);
        newXS_deffile("Math::MPFR::Rmpfr_log_ui", XS_Math__MPFR_Rmpfr_log_ui);
        newXS_deffile("Math::MPFR::Rmpfr_gamma_inc", XS_Math__MPFR_Rmpfr_gamma_inc);
        newXS_deffile("Math::MPFR::_have_IEEE_754_long_double", XS_Math__MPFR__have_IEEE_754_long_double);
        newXS_deffile("Math::MPFR::_have_extended_precision_long_double", XS_Math__MPFR__have_extended_precision_long_double);
        newXS_deffile("Math::MPFR::nanflag_bug", XS_Math__MPFR_nanflag_bug);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_float128_p", XS_Math__MPFR_Rmpfr_buildopt_float128_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_sharedcache_p", XS_Math__MPFR_Rmpfr_buildopt_sharedcache_p);
        newXS_deffile("Math::MPFR::_nv_is_float128", XS_Math__MPFR__nv_is_float128);
        newXS_deffile("Math::MPFR::_SvNOK", XS_Math__MPFR__SvNOK);
        newXS_deffile("Math::MPFR::_SvPOK", XS_Math__MPFR__SvPOK);
        newXS_deffile("Math::MPFR::_lsb", XS_Math__MPFR__lsb);
        newXS_deffile("Math::MPFR::Rmpfr_rec_root", XS_Math__MPFR_Rmpfr_rec_root);
        newXS_deffile("Math::MPFR::Rmpfr_beta", XS_Math__MPFR_Rmpfr_beta);
        newXS_deffile("Math::MPFR::Rmpfr_rootn_ui", XS_Math__MPFR_Rmpfr_rootn_ui);
        newXS_deffile("Math::MPFR::_ld_subnormal_bug", XS_Math__MPFR__ld_subnormal_bug);
        newXS_deffile("Math::MPFR::atodouble", XS_Math__MPFR_atodouble);
        newXS_deffile("Math::MPFR::atonv", XS_Math__MPFR_atonv);
        newXS_deffile("Math::MPFR::Rmpfr_get_str_ndigits", XS_Math__MPFR_Rmpfr_get_str_ndigits);
        newXS_deffile("Math::MPFR::Rmpfr_dot", XS_Math__MPFR_Rmpfr_dot);
        newXS_deffile("Math::MPFR::nvtoa", XS_Math__MPFR_nvtoa);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

